(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var _ = Package.underscore._;
var Tracker = Package.tracker.Tracker;
var Deps = Package.tracker.Deps;
var ReactiveDict = Package['reactive-dict'].ReactiveDict;
var ReactiveVar = Package['reactive-var'].ReactiveVar;

/* Package-scope variables */
var FlowRouter, Router, Group, Route, FastRender;

(function () {

//////////////////////////////////////////////////////////////////////////////////////
//                                                                                  //
// packages/meteorhacks:flow-router/server/router.js                                //
//                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////
                                                                                    //
var Qs = Npm.require('qs');                                                         // 1
                                                                                    // 2
Router = function () {                                                              // 3
  this._routesMap = {};                                                             // 4
  this._routeNamesMap = {};                                                         // 5
  this.subscriptions = Function.prototype;                                          // 6
};                                                                                  // 7
                                                                                    // 8
                                                                                    // 9
Router.prototype.route = function(path, options) {                                  // 10
  this._routesMap[path] = new Route(this, path, options);                           // 11
                                                                                    // 12
  if (options.name) {                                                               // 13
    this._routeNamesMap[options.name] = path;                                       // 14
  }                                                                                 // 15
                                                                                    // 16
  return this._routesMap[path];                                                     // 17
};                                                                                  // 18
                                                                                    // 19
Router.prototype.group = function(options) {                                        // 20
  return new Group(this, options);                                                  // 21
};                                                                                  // 22
                                                                                    // 23
Router.prototype.path = function(pathDef, fields, queryParams) {                    // 24
  if (this._routeNamesMap[pathDef]) {                                               // 25
    pathDef = this._routeNamesMap[pathDef];                                         // 26
  }                                                                                 // 27
                                                                                    // 28
  if (this._routesMap[pathDef]) {                                                   // 29
    pathDef = this._routesMap[pathDef].path;                                        // 30
  }                                                                                 // 31
                                                                                    // 32
  fields = fields || {};                                                            // 33
  var regExp = /(:[\w\(\)\\\+\*\.\?]+)+/g;                                          // 34
  var path = pathDef.replace(regExp, function(key) {                                // 35
    var firstRegexpChar = key.indexOf("(");                                         // 36
    // get the content behind : and (\\d+/)                                         // 37
    key = key.substring(1, (firstRegexpChar > 0)? firstRegexpChar: undefined);      // 38
    // remove +?*                                                                   // 39
    key = key.replace(/[\+\*\?]+/g, "");                                            // 40
                                                                                    // 41
    return fields[key] || "";                                                       // 42
  });                                                                               // 43
                                                                                    // 44
  path = path.replace(/\/\/+/g, "/"); // Replace multiple slashes with single slash // 45
                                                                                    // 46
  // remove trailing slash                                                          // 47
  // but keep the root slash if it's the only one                                   // 48
  path = path.match(/^\/{1}$/) ? path: path.replace(/\/$/, "");                     // 49
                                                                                    // 50
  var strQueryParams = Qs.stringify(queryParams || {});                             // 51
  if(strQueryParams) {                                                              // 52
    path += "?" + strQueryParams;                                                   // 53
  }                                                                                 // 54
                                                                                    // 55
  return path;                                                                      // 56
};                                                                                  // 57
                                                                                    // 58
                                                                                    // 59
Router.prototype.go = function() {                                                  // 60
  // client only                                                                    // 61
};                                                                                  // 62
                                                                                    // 63
                                                                                    // 64
Router.prototype.current = function() {                                             // 65
  // client only                                                                    // 66
};                                                                                  // 67
                                                                                    // 68
                                                                                    // 69
Router.prototype.triggers = {                                                       // 70
  enter: function() {                                                               // 71
    // client only                                                                  // 72
  },                                                                                // 73
  exit: function() {                                                                // 74
    // client only                                                                  // 75
  }                                                                                 // 76
};                                                                                  // 77
                                                                                    // 78
Router.prototype.middleware = function() {                                          // 79
  // client only                                                                    // 80
};                                                                                  // 81
                                                                                    // 82
                                                                                    // 83
Router.prototype.getState = function() {                                            // 84
  // client only                                                                    // 85
};                                                                                  // 86
                                                                                    // 87
                                                                                    // 88
Router.prototype.getAllStates = function() {                                        // 89
  // client only                                                                    // 90
};                                                                                  // 91
                                                                                    // 92
                                                                                    // 93
Router.prototype.setState = function() {                                            // 94
  // client only                                                                    // 95
};                                                                                  // 96
                                                                                    // 97
                                                                                    // 98
Router.prototype.removeState = function() {                                         // 99
  // client only                                                                    // 100
};                                                                                  // 101
                                                                                    // 102
                                                                                    // 103
Router.prototype.clearStates = function() {                                         // 104
  // client only                                                                    // 105
};                                                                                  // 106
                                                                                    // 107
                                                                                    // 108
Router.prototype.ready = function() {                                               // 109
  // client only                                                                    // 110
};                                                                                  // 111
                                                                                    // 112
                                                                                    // 113
Router.prototype.initialize = function() {                                          // 114
  // client only                                                                    // 115
};                                                                                  // 116
                                                                                    // 117
Router.prototype.wait = function() {                                                // 118
  // client only                                                                    // 119
};                                                                                  // 120
                                                                                    // 121
//////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

//////////////////////////////////////////////////////////////////////////////////////
//                                                                                  //
// packages/meteorhacks:flow-router/server/group.js                                 //
//                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////
                                                                                    //
Group = function(router, options) {                                                 // 1
  options = options || {};                                                          // 2
  this.prefix = options.prefix || '';                                               // 3
                                                                                    // 4
  this._router = router;                                                            // 5
};                                                                                  // 6
                                                                                    // 7
Group.prototype.route = function(path, options) {                                   // 8
  path = this.prefix + path;                                                        // 9
  return this._router.route(path, options);                                         // 10
};                                                                                  // 11
                                                                                    // 12
Group.prototype.group = function(options) {                                         // 13
  var group = new Group(this._router, options);                                     // 14
  group.parent = this;                                                              // 15
                                                                                    // 16
  return group;                                                                     // 17
};                                                                                  // 18
                                                                                    // 19
//////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

//////////////////////////////////////////////////////////////////////////////////////
//                                                                                  //
// packages/meteorhacks:flow-router/server/route.js                                 //
//                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////
                                                                                    //
Route = function(router, path, options) {                                           // 1
  options = options || {};                                                          // 2
                                                                                    // 3
  this.path = path;                                                                 // 4
  this.action = options.action || Function.prototype;                               // 5
  this.subscriptions = options.subscriptions || Function.prototype;                 // 6
  this._subsMap = {};                                                               // 7
};                                                                                  // 8
                                                                                    // 9
                                                                                    // 10
Route.prototype.register = function(name, sub, options) {                           // 11
  this._subsMap[name] = sub;                                                        // 12
};                                                                                  // 13
                                                                                    // 14
                                                                                    // 15
Route.prototype.subscription = function(name) {                                     // 16
  return this._subsMap[name];                                                       // 17
};                                                                                  // 18
                                                                                    // 19
                                                                                    // 20
Route.prototype.middleware = function(middleware) {                                 // 21
                                                                                    // 22
};                                                                                  // 23
                                                                                    // 24
//////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

//////////////////////////////////////////////////////////////////////////////////////
//                                                                                  //
// packages/meteorhacks:flow-router/server/_init.js                                 //
//                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////
                                                                                    //
// Export Router Instance                                                           // 1
FlowRouter = new Router();                                                          // 2
FlowRouter.Router = Router;                                                         // 3
FlowRouter.Route = Route;                                                           // 4
                                                                                    // 5
//////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

//////////////////////////////////////////////////////////////////////////////////////
//                                                                                  //
// packages/meteorhacks:flow-router/server/plugins/fast_render.js                   //
//                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////
                                                                                    //
if(!Package['meteorhacks:fast-render']) {                                           // 1
  return;                                                                           // 2
}                                                                                   // 3
                                                                                    // 4
FastRender = Package['meteorhacks:fast-render'].FastRender;                         // 5
                                                                                    // 6
// hack to run after eveything else on startup                                      // 7
Meteor.startup(function () {                                                        // 8
  Meteor.startup(function () {                                                      // 9
    setupFastRender();                                                              // 10
  });                                                                               // 11
});                                                                                 // 12
                                                                                    // 13
function setupFastRender () {                                                       // 14
  _.each(FlowRouter._routesMap, function (route, path) {                            // 15
    FastRender.route(path, function (params, path) {                                // 16
      var self = this;                                                              // 17
                                                                                    // 18
      // anyone using Meteor.subscribe for something else?                          // 19
      var original = Meteor.subscribe;                                              // 20
      Meteor.subscribe = function () {                                              // 21
        return _.toArray(arguments);                                                // 22
      };                                                                            // 23
                                                                                    // 24
      route._subsMap = {};                                                          // 25
      FlowRouter.subscriptions.call(route, path);                                   // 26
      if(route.subscriptions) {                                                     // 27
        route.subscriptions(params);                                                // 28
      }                                                                             // 29
      _.each(route._subsMap, function (args) {                                      // 30
        self.subscribe.apply(self, args);                                           // 31
      });                                                                           // 32
                                                                                    // 33
      // restore Meteor.subscribe, ... on server side                               // 34
      Meteor.subscribe = original;                                                  // 35
    });                                                                             // 36
  });                                                                               // 37
}                                                                                   // 38
                                                                                    // 39
//////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['meteorhacks:flow-router'] = {
  FlowRouter: FlowRouter
};

})();

//# sourceMappingURL=meteorhacks_flow-router.js.map
