(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var _ = Package.underscore._;
var Tracker = Package.tracker.Tracker;
var Deps = Package.tracker.Deps;
var DDP = Package.ddp.DDP;
var DDPServer = Package.ddp.DDPServer;
var loglevel = Package['practicalmeteor:loglevel'].loglevel;
var MeteorStubs = Package['velocity:meteor-stubs'].MeteorStubs;
var Karma = Package['sanjo:karma'].Karma;
var KarmaInternals = Package['sanjo:karma'].KarmaInternals;
var MeteorVersion = Package['sanjo:meteor-version'].MeteorVersion;
var PackageVersion = Package['package-version-parser'].PackageVersion;
var MeteorFilesHelpers = Package['sanjo:meteor-files-helpers'].MeteorFilesHelpers;

/* Package-scope variables */
var Jasmine, log, freeport, lazyStart, MirrorStarter, parseStack, JasmineTestFramework, JasmineInterface, VelocityTestReporter, ServerIntegrationTestFramework, runCodeInContext, runFileInContext, coffeeRequire, fileLoader, loadOrderSort, mockLoader, packagesToIncludeInUnitTests, MockGenerator, ServerUnitTestFramework, ClientUnitTestFramework, ClientIntegrationTestFramework, getSpecFiles, frameworks, isMirror, isMainApp, isTestPackagesMode, shouldRunFramework;

(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/lib/log.js                                                                              //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals log: true */                                                                                               // 1
                                                                                                                      // 2
var level = Meteor.isServer && process.env.VELOCITY_DEBUG ? 'debug' : 'info'                                          // 3
if (Meteor.isServer && process.env.JASMINE_LOG_LEVEL) {                                                               // 4
  level = process.env.JASMINE_LOG_LEVEL                                                                               // 5
}                                                                                                                     // 6
log = loglevel.createPackageLogger('[sanjo:jasmine]', level)                                                          // 7
                                                                                                                      // 8
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/lib/freeport.js                                                                         //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals freeport: true */                                                                                          // 1
                                                                                                                      // 2
freeport = Meteor.wrapAsync(Npm.require('freeport'))                                                                  // 3
                                                                                                                      // 4
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/lib/lazyStart.js                                                                        //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals lazyStart: true */                                                                                         // 1
                                                                                                                      // 2
// Run the func when tests for the framework are available.                                                           // 3
lazyStart = function (frameworkName, func) {                                                                          // 4
  var testsCursor = VelocityTestFiles.find(                                                                           // 5
    {targetFramework: frameworkName}                                                                                  // 6
  )                                                                                                                   // 7
                                                                                                                      // 8
  if (testsCursor.count() > 0) {                                                                                      // 9
    func()                                                                                                            // 10
  } else {                                                                                                            // 11
    // Needed for `meteor --test`                                                                                     // 12
    log.debug('No tests for ' + frameworkName + ' found. Reporting completed.')                                       // 13
    Meteor.call('velocity/reports/completed', {framework: frameworkName})                                             // 14
    var testsObserver = testsCursor.observe({                                                                         // 15
      added: _.once(function () {                                                                                     // 16
        // Delay the stop because added can be called before observe returns                                          // 17
        Meteor.setTimeout(function () {                                                                               // 18
          testsObserver.stop()                                                                                        // 19
        }, 5000)                                                                                                      // 20
        func()                                                                                                        // 21
      })                                                                                                              // 22
    })                                                                                                                // 23
  }                                                                                                                   // 24
}                                                                                                                     // 25
                                                                                                                      // 26
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/lib/MirrorStarter.js                                                                    //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals MirrorStarter: true */                                                                                     // 1
                                                                                                                      // 2
MirrorStarter = function (testingFrameworkName) {                                                                     // 3
  this.name = testingFrameworkName                                                                                    // 4
}                                                                                                                     // 5
                                                                                                                      // 6
_.extend(MirrorStarter.prototype, {                                                                                   // 7
                                                                                                                      // 8
  lazyStartMirror: function (mirrorOptions) {                                                                         // 9
    var requestMirror = this.startMirror.bind(this, mirrorOptions)                                                    // 10
    lazyStart(this.name, requestMirror)                                                                               // 11
  },                                                                                                                  // 12
                                                                                                                      // 13
  startMirror: function (mirrorOptions) {                                                                             // 14
    var options = {                                                                                                   // 15
      framework: this.name                                                                                            // 16
    }                                                                                                                 // 17
    _.extend(options, mirrorOptions)                                                                                  // 18
                                                                                                                      // 19
    if (!options.port) {                                                                                              // 20
      options.port = freeport()                                                                                       // 21
    }                                                                                                                 // 22
                                                                                                                      // 23
    log.debug('Starting mirror for ' + this.name)                                                                     // 24
                                                                                                                      // 25
    // HACK: need to make sure after the proxy package adds the test files                                            // 26
    Meteor.setTimeout(function() {                                                                                    // 27
      Meteor.call(                                                                                                    // 28
        'velocity/mirrors/request',                                                                                   // 29
        options,                                                                                                      // 30
        function (error) {                                                                                            // 31
          if (error) {                                                                                                // 32
            log.error(error)                                                                                          // 33
          }                                                                                                           // 34
        }                                                                                                             // 35
      )                                                                                                               // 36
    }, 100)                                                                                                           // 37
  },                                                                                                                  // 38
                                                                                                                      // 39
  startSelfMirror: function (mirrorOptions) {                                                                         // 40
    mirrorOptions = mirrorOptions || {}                                                                               // 41
    VelocityMirrors.upsert(                                                                                           // 42
      {framework: this.name},                                                                                         // 43
      {                                                                                                               // 44
        framework: this.name,                                                                                         // 45
        mongoUrl: process.env.MONGO_URL,                                                                              // 46
        host: process.env.ROOT_URL,                                                                                   // 47
        rootUrl: process.env.ROOT_URL,                                                                                // 48
        rootUrlPath: mirrorOptions.rootUrlPath,                                                                       // 49
        state: 'ready',                                                                                               // 50
        lastModified: Date.now()                                                                                      // 51
      }                                                                                                               // 52
    )                                                                                                                 // 53
  }                                                                                                                   // 54
                                                                                                                      // 55
})                                                                                                                    // 56
                                                                                                                      // 57
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/lib/parseStack.js                                                                       //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals parseStack: true */                                                                                        // 1
                                                                                                                      // 2
parseStack = {};                                                                                                      // 3
                                                                                                                      // 4
// Given an Error (eg, 'new Error'), return the stack associated with                                                 // 5
// that error as an array. More recently called functions appear first                                                // 6
// and each element is an object with keys:                                                                           // 7
// - file: filename as it appears in the stack                                                                        // 8
// - line: 1-indexed line number in file, as a Number                                                                 // 9
// - column: 1-indexed column in line, as a Number                                                                    // 10
// - func: name of the function in the frame (maybe null)                                                             // 11
//                                                                                                                    // 12
// Accomplishes this by parsing the text representation of the stack                                                  // 13
// with regular expressions. Unlikely to work anywhere but v8.                                                        // 14
//                                                                                                                    // 15
// If a function on the stack has been marked with mark(), don't                                                      // 16
// return anything past that function. We call this the "user portion"                                                // 17
// of the stack.                                                                                                      // 18
parseStack.parse = function (err) {                                                                                   // 19
  var frames = err.stack.split('\n');                                                                                 // 20
                                                                                                                      // 21
  frames.shift(); // at least the first line is the exception                                                         // 22
  var stop = false;                                                                                                   // 23
  var ret = [];                                                                                                       // 24
                                                                                                                      // 25
  _.each(frames, function (frame) {                                                                                   // 26
    if (stop)                                                                                                         // 27
      return;                                                                                                         // 28
    var m;                                                                                                            // 29
    if (m =                                                                                                           // 30
        frame.match(/^\s*at\s*((new )?.+?)\s*(\[as\s*([^\]]*)\]\s*)?\((.*?)(:(\d+))?(:(\d+))?\)\s*$/)) {              // 31
      // https://code.google.com/p/v8/wiki/JavaScriptStackTraceApi                                                    // 32
      // "    at My.Function (/path/to/myfile.js:532:39)"                                                             // 33
      // "    at Array.forEach (native)"                                                                              // 34
      // "    at new My.Class (file.js:1:2)"                                                                          // 35
      // "    at [object Object].main.registerCommand.name [as func] (meteor/tools/commands.js:1225:19)"              // 36
      // "    at __top_mark__ [as matchErr] (meteor/tools/parse-stack.js:82:14)"                                      // 37
      //                                                                                                              // 38
      // In that last example, it is not at all clear to me what the                                                  // 39
      // 'as' stanza refers to, but it is in m[3] if you find a use for it.                                           // 40
      if (m[1].match(/(?:^|\.)__top_mark__$/)) {                                                                      // 41
        // m[1] could be Object.__top_mark__ or something like that                                                   // 42
        // depending on where exactly you put the function returned by                                                // 43
        // markTop                                                                                                    // 44
        ret = [];                                                                                                     // 45
        return;                                                                                                       // 46
      }                                                                                                               // 47
      if (m[1].match(/(?:^|\.)__bottom_mark__$/)) {                                                                   // 48
        stop = true;                                                                                                  // 49
        return;                                                                                                       // 50
      }                                                                                                               // 51
      ret.push({                                                                                                      // 52
        func: m[1],                                                                                                   // 53
        file: m[5],                                                                                                   // 54
        line: m[7] ? +m[7] : undefined,                                                                               // 55
        column: m[9] ? +m[9] : undefined                                                                              // 56
      });                                                                                                             // 57
    } else if (m = frame.match(/^\s*at\s+(.+?)(:(\d+))?(:(\d+))?\s*$/)) {                                             // 58
      // "    at /path/to/myfile.js:532:39"                                                                           // 59
      ret.push({                                                                                                      // 60
        file: m[1],                                                                                                   // 61
        line: m[3] ? +m[3] : undefined,                                                                               // 62
        column: m[5] ? +m[5] : undefined                                                                              // 63
      });                                                                                                             // 64
    } else if (m = frame.match(/^\s*-\s*-\s*-\s*-\s*-\s*$/)) {                                                        // 65
      // "    - - - - -"                                                                                              // 66
      // This is something added when you throw an Error through a future. The                                        // 67
      // stack above the dashes is the stack of the 'wait' call; the stack below                                      // 68
      // is the stack inside the fiber where the Error is originally                                                  // 69
      // constructed. Taking just the former seems good for now, but in the                                           // 70
      // future we may want to sew them together (possibly in the opposite                                            // 71
      // order?)                                                                                                      // 72
      stop = true;                                                                                                    // 73
    } else if (_.isEmpty(ret)) {                                                                                      // 74
      // We haven't found any stack frames, so probably we have newlines in the                                       // 75
      // error message. Just skip this line.                                                                          // 76
    } else {                                                                                                          // 77
      throw new Error("Couldn't parse stack frame: '" + frame + "'");                                                 // 78
    }                                                                                                                 // 79
  });                                                                                                                 // 80
                                                                                                                      // 81
  return ret;                                                                                                         // 82
};                                                                                                                    // 83
                                                                                                                      // 84
// Decorator. Mark the point at which a stack trace returned by                                                       // 85
// parse() should stop: no frames earlier than this point will be                                                     // 86
// included in the parsed stack. Confusingly, in the argot of the                                                     // 87
// times, you'd say that frames "higher up" than this or "above" this                                                 // 88
// will not be returned, but you'd also say that those frames are "at                                                 // 89
// the bottom of the stack". Frames below the bottom are the outer                                                    // 90
// context of the framework running the user's code.                                                                  // 91
parseStack.markBottom = function (f) {                                                                                // 92
  return function __bottom_mark__ () {                                                                                // 93
    return f.apply(this, arguments);                                                                                  // 94
  };                                                                                                                  // 95
};                                                                                                                    // 96
                                                                                                                      // 97
// Decorator. Mark the point at which a stack trace returned by                                                       // 98
// parse() should begin: no frames later than this point will be                                                      // 99
// included in the parsed stack. The opposite of markBottom().                                                        // 100
// Frames above the top are helper functions defined by the                                                           // 101
// framework and executed by user code whose internal behavior                                                        // 102
// should not be exposed.                                                                                             // 103
parseStack.markTop = function (f) {                                                                                   // 104
  return function __top_mark__ () {                                                                                   // 105
    return f.apply(this, arguments);                                                                                  // 106
  };                                                                                                                  // 107
};                                                                                                                    // 108
                                                                                                                      // 109
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/lib/JasmineTestFramework.js                                                             //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals JasmineTestFramework: true */                                                                              // 1
                                                                                                                      // 2
JasmineTestFramework = function (options) {                                                                           // 3
  if (!options || !options.name) {                                                                                    // 4
    throw new Error('[JasmineTestFramework] Missing required field "name"')                                           // 5
  }                                                                                                                   // 6
                                                                                                                      // 7
  if (!options.regex) {                                                                                               // 8
    throw new Error('[JasmineTestFramework] Missing required field "regex"')                                          // 9
  }                                                                                                                   // 10
                                                                                                                      // 11
  if (_.isUndefined(options.jasmineRequire)) {                                                                        // 12
    throw new Error('[JasmineTestFramework] Missing required field "jasmineRequire"')                                 // 13
  }                                                                                                                   // 14
                                                                                                                      // 15
  this.name = options.name                                                                                            // 16
  this.regex = options.regex                                                                                          // 17
  this.sampleTestGenerator = options.sampleTestGenerator                                                              // 18
  this.logPrefix = options.logPrefix || '[' + this.name + '] '                                                        // 19
  this.jasmineRequire = options.jasmineRequire                                                                        // 20
                                                                                                                      // 21
  // load jasmine-velocity reporter                                                                                   // 22
  // [unit] mock packages                                                                                             // 23
                                                                                                                      // 24
}                                                                                                                     // 25
                                                                                                                      // 26
_.extend(JasmineTestFramework.prototype, {                                                                            // 27
                                                                                                                      // 28
  //////////////////////////////////////////////////////////////////////                                              // 29
  // Public functions                                                                                                 // 30
  //                                                                                                                  // 31
                                                                                                                      // 32
  runTests: function () {},                                                                                           // 33
                                                                                                                      // 34
  //////////////////////////////////////////////////////////////////////                                              // 35
  // Protected functions                                                                                              // 36
  //                                                                                                                  // 37
                                                                                                                      // 38
  registerWithVelocity: function () {                                                                                 // 39
    Velocity.registerTestingFramework(this.name, {                                                                    // 40
      regex: this.regex,                                                                                              // 41
      sampleTestGenerator: this.sampleTestGenerator                                                                   // 42
    })                                                                                                                // 43
  }                                                                                                                   // 44
                                                                                                                      // 45
})                                                                                                                    // 46
                                                                                                                      // 47
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/lib/JasmineInterface.js                                                                 //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals JasmineInterface: true */                                                                                  // 1
                                                                                                                      // 2
var jasmineRequire = Meteor.isServer ?                                                                                // 3
  Npm.require('jasmine-core') :                                                                                       // 4
  window.jasmineRequire                                                                                               // 5
                                                                                                                      // 6
/**                                                                                                                   // 7
 * Object that will be directly put into the global context of the running                                            // 8
 * tests.                                                                                                             // 9
 *                                                                                                                    // 10
 * ex.                                                                                                                // 11
 *     describe(...)   // rather than 'jasmine.describe'                                                              // 12
 *     jasmine.clock   // rather than just 'clock'                                                                    // 13
 *                                                                                                                    // 14
 * @class JasmineInterface                                                                                            // 15
 * @constructor                                                                                                       // 16
 */                                                                                                                   // 17
JasmineInterface = function (options) {                                                                               // 18
  if (!options || !options.jasmine) {                                                                                 // 19
    throw new Error('[JasmineInterface] Missing required field "jasmine"')                                            // 20
  }                                                                                                                   // 21
                                                                                                                      // 22
  var env = options.jasmine.getEnv()                                                                                  // 23
                                                                                                                      // 24
  _.extend(this, jasmineRequire.interface(options.jasmine, env))                                                      // 25
                                                                                                                      // 26
  var markBottom = function (func) {                                                                                  // 27
    var boundFunction = parseStack.markBottom(func)                                                                   // 28
    if (func.length > 0) {                                                                                            // 29
      // Async test                                                                                                   // 30
      return function (done) {                                                                                        // 31
        return boundFunction.apply(this, arguments)                                                                   // 32
      }                                                                                                               // 33
    } else {                                                                                                          // 34
      // Sync test                                                                                                    // 35
      return function () {                                                                                            // 36
        return boundFunction.call(this)                                                                               // 37
      }                                                                                                               // 38
    }                                                                                                                 // 39
  }                                                                                                                   // 40
                                                                                                                      // 41
  _.forEach(['describe', 'xdescribe', 'fdescribe', 'it', 'fit'], function (word) {                                    // 42
    var originalFunction = this[word]                                                                                 // 43
    this[word] = function (/* arguments */) {                                                                         // 44
      arguments[1] = markBottom(arguments[1])                                                                         // 45
      return originalFunction.apply(this, arguments)                                                                  // 46
    }                                                                                                                 // 47
  }, this)                                                                                                            // 48
                                                                                                                      // 49
  _.forEach(['beforeEach', 'afterEach', 'beforeAll', 'afterAll'], function (word) {                                   // 50
    var originalFunction = this[word]                                                                                 // 51
    this[word] = function (/* arguments */) {                                                                         // 52
      arguments[0] = markBottom(arguments[0])                                                                         // 53
      return originalFunction.apply(this, arguments)                                                                  // 54
    }                                                                                                                 // 55
  }, this)                                                                                                            // 56
}                                                                                                                     // 57
                                                                                                                      // 58
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/lib/VelocityTestReporter.js                                                             //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* global                                                                                                             // 1
   VelocityTestReporter: true                                                                                         // 2
 */                                                                                                                   // 3
                                                                                                                      // 4
(function (Meteor) {                                                                                                  // 5
  var noopTimer = {                                                                                                   // 6
    start: function() {},                                                                                             // 7
    elapsed: function() { return 0 }                                                                                  // 8
  }                                                                                                                   // 9
                                                                                                                      // 10
  VelocityTestReporter = function VelocityTestReporter(options) {                                                     // 11
    var self = this,                                                                                                  // 12
      timer = options.timer || noopTimer,                                                                             // 13
      ddpParentConnection = options.ddpParentConnection,                                                              // 14
      ancestors = [],                                                                                                 // 15
      _jasmineDone                                                                                                    // 16
                                                                                                                      // 17
    self.mode = options.mode                                                                                          // 18
                                                                                                                      // 19
    var saveTestResult = Meteor.bindEnvironment(function saveTestResult(test) {                                       // 20
      var result = {                                                                                                  // 21
        id: 'jasmine:' + self.mode + ' | ' + test.id,                                                                 // 22
        //async: test.async,                                                                                          // 23
        framework: options.framework,                                                                                 // 24
        name: test.fullName,                                                                                          // 25
        pending: test.status === 'pending',                                                                           // 26
        result: test.status,                                                                                          // 27
        duration: timer.elapsed(),                                                                                    // 28
        //timeOut: test._timeout,                                                                                     // 29
        //timedOut: test.timedOut,                                                                                    // 30
        ancestors: ancestors,                                                                                         // 31
        timestamp: new Date()                                                                                         // 32
      }                                                                                                               // 33
      if (test.failedExpectations[0]){                                                                                // 34
        var stack = removeStackTraceClutter(parseStack.parse({stack: filterStack(test.failedExpectations[0].stack)})) // 35
        var message = _.extend({                                                                                      // 36
          message: test.failedExpectations[0].message,                                                                // 37
          stack: stack                                                                                                // 38
        }, stack[0])                                                                                                  // 39
        result.failureMessage = message.message                                                                       // 40
        result.failureStackTrace = formatMessage([message])                                                           // 41
      }                                                                                                               // 42
                                                                                                                      // 43
      if (Meteor.isClient || process.env.IS_MIRROR) {                                                                 // 44
        ddpParentConnection.call('velocity/reports/submit', result, function (error){                                 // 45
          if (error){                                                                                                 // 46
            console.error('ERROR WRITING TEST', error)                                                                // 47
          }                                                                                                           // 48
        })                                                                                                            // 49
      } else {                                                                                                        // 50
        Meteor.call('velocity/reports/submit', result, function(error){                                               // 51
          if (error){                                                                                                 // 52
            console.error('ERROR WRITING TEST', error)                                                                // 53
          }                                                                                                           // 54
        })                                                                                                            // 55
      }                                                                                                               // 56
    }, function (error) {                                                                                             // 57
      console.error(error)                                                                                            // 58
    })                                                                                                                // 59
                                                                                                                      // 60
    if (Meteor.isClient) {                                                                                            // 61
      _jasmineDone = function () {                                                                                    // 62
        ddpParentConnection.call(                                                                                     // 63
          'velocity/reports/completed',                                                                               // 64
          {framework: options.framework},                                                                             // 65
          function () {                                                                                               // 66
            if (options.onComplete) {                                                                                 // 67
              options.onComplete()                                                                                    // 68
            }                                                                                                         // 69
          }                                                                                                           // 70
        )                                                                                                             // 71
      }                                                                                                               // 72
    } else if (Meteor.isServer) {                                                                                     // 73
      _jasmineDone = Meteor.bindEnvironment(function jasmineDone() {                                                  // 74
        if (options.onComplete) {                                                                                     // 75
          options.onComplete()                                                                                        // 76
        }                                                                                                             // 77
      }, function (error) {                                                                                           // 78
        console.error(error)                                                                                          // 79
        if (options.onComplete) {                                                                                     // 80
          options.onComplete()                                                                                        // 81
        }                                                                                                             // 82
      })                                                                                                              // 83
    }                                                                                                                 // 84
                                                                                                                      // 85
    self.jasmineDone = _jasmineDone                                                                                   // 86
                                                                                                                      // 87
    self.suiteStarted = function(result) {                                                                            // 88
      ancestors.unshift(result.description)                                                                           // 89
    }                                                                                                                 // 90
                                                                                                                      // 91
    self.suiteDone = function() {                                                                                     // 92
      ancestors.shift()                                                                                               // 93
    }                                                                                                                 // 94
                                                                                                                      // 95
    self.specStarted = function () {                                                                                  // 96
      timer.start()                                                                                                   // 97
    }                                                                                                                 // 98
                                                                                                                      // 99
    self.specDone = function(result) {                                                                                // 100
      var skipped = result.status === 'disabled' || result.status === 'pending'                                       // 101
      if (!skipped) {                                                                                                 // 102
        saveTestResult(result)                                                                                        // 103
      }                                                                                                               // 104
    }                                                                                                                 // 105
                                                                                                                      // 106
    function filterStack(stack) {                                                                                     // 107
      var filteredStack = stack.split('\n').filter(function(stackLine) {                                              // 108
        return stackLine.indexOf('/node_modules/jasmine-core/') === -1;                                               // 109
      }).join('\n');                                                                                                  // 110
      return filteredStack;                                                                                           // 111
    }                                                                                                                 // 112
                                                                                                                      // 113
    function removeStackTraceClutter(parsedStackTrace) {                                                              // 114
      return _.chain(parsedStackTrace)                                                                                // 115
        .map(_.clone)                                                                                                 // 116
        .map(function makeFileUrlRelative(frame) {                                                                    // 117
          var rootUrl = Meteor.absoluteUrl();                                                                         // 118
          if (frame.file.indexOf(rootUrl) === 0) {                                                                    // 119
            frame.file = frame.file.substr(rootUrl.length);                                                           // 120
          }                                                                                                           // 121
          return frame;                                                                                               // 122
        })                                                                                                            // 123
        .map(function removeCacheBustingQuery(frame) {                                                                // 124
          frame.file = frame.file.replace(/\?[a-z0-9]+$/, '');                                                        // 125
          return frame;                                                                                               // 126
        })                                                                                                            // 127
        .map(function normalizePackageName(frame) {                                                                   // 128
          frame.file = frame.file.replace('local-test:', '');                                                         // 129
          return frame;                                                                                               // 130
        })                                                                                                            // 131
        .map(function removeUselessFunc(frame) {                                                                      // 132
          if (frame.func === 'Object.<anonymous>') {                                                                  // 133
            frame.func = null;                                                                                        // 134
          }                                                                                                           // 135
          return frame;                                                                                               // 136
        })                                                                                                            // 137
        .value();                                                                                                     // 138
    }                                                                                                                 // 139
                                                                                                                      // 140
    function formatMessage(messages) {                                                                                // 141
      var out = '';                                                                                                   // 142
      var already = {};                                                                                               // 143
      var indent = '';                                                                                                // 144
                                                                                                                      // 145
      _.each(messages, function (message) {                                                                           // 146
        var stack = message.stack || [];                                                                              // 147
                                                                                                                      // 148
        var line = indent;                                                                                            // 149
        if (message.file) {                                                                                           // 150
          line+= message.file;                                                                                        // 151
          if (message.line) {                                                                                         // 152
            line += ":" + message.line;                                                                               // 153
            if (message.column) {                                                                                     // 154
              // XXX maybe exclude unless specifically requested (eg,                                                 // 155
              // for an automated tool that's parsing our output?)                                                    // 156
              line += ":" + message.column;                                                                           // 157
            }                                                                                                         // 158
          }                                                                                                           // 159
          line += ": ";                                                                                               // 160
        } else {                                                                                                      // 161
          // not sure how to display messages without a filenanme.. try this?                                         // 162
          line += "error: ";                                                                                          // 163
        }                                                                                                             // 164
        // XXX line wrapping would be nice..                                                                          // 165
        line += message.message;                                                                                      // 166
        if (message.func && stack.length <= 1) {                                                                      // 167
          line += " (at " + message.func + ")";                                                                       // 168
        }                                                                                                             // 169
        line += "\n";                                                                                                 // 170
                                                                                                                      // 171
        if (stack.length > 1) {                                                                                       // 172
          _.each(stack, function (frame) {                                                                            // 173
            // If a nontrivial stack trace (more than just the file and line                                          // 174
            // we already complained about), print it.                                                                // 175
            var where = "";                                                                                           // 176
            if (frame.file) {                                                                                         // 177
              where += frame.file;                                                                                    // 178
              if (frame.line) {                                                                                       // 179
                where += ":" + frame.line;                                                                            // 180
                if (frame.column) {                                                                                   // 181
                  where += ":" + frame.column;                                                                        // 182
                }                                                                                                     // 183
              }                                                                                                       // 184
            }                                                                                                         // 185
                                                                                                                      // 186
            if (! frame.func && ! where)                                                                              // 187
              return; // that's a pretty lame stack frame                                                             // 188
                                                                                                                      // 189
            line += "  at ";                                                                                          // 190
            if (frame.func)                                                                                           // 191
              line += frame.func + " (" + where + ")\n";                                                              // 192
            else                                                                                                      // 193
              line += where + "\n";                                                                                   // 194
          });                                                                                                         // 195
          line += "\n";                                                                                               // 196
        }                                                                                                             // 197
                                                                                                                      // 198
        // Deduplicate messages (only when exact duplicates, including stack)                                         // 199
        if (! (line in already)) {                                                                                    // 200
          out += line;                                                                                                // 201
          already[line] = true;                                                                                       // 202
        }                                                                                                             // 203
      });                                                                                                             // 204
                                                                                                                      // 205
      return out;                                                                                                     // 206
    }                                                                                                                 // 207
  }                                                                                                                   // 208
                                                                                                                      // 209
})(Meteor)                                                                                                            // 210
                                                                                                                      // 211
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/server/integration/ServerIntegrationTestFramework.js                                    //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals Jasmine: true, ServerIntegrationTestFramework: true */                                                     // 1
                                                                                                                      // 2
/**                                                                                                                   // 3
 * Design:                                                                                                            // 4
 * - Let Meteor load the tests                                                                                        // 5
 * - Let Meteor restart the mirror when a file changed.                                                               // 6
 *   This implicates only one test run per mirror run.                                                                // 7
 */                                                                                                                   // 8
                                                                                                                      // 9
var ComponentMocker = Npm.require('component-mocker');                                                                // 10
var jasmineRequire = Npm.require('jasmine-core/lib/jasmine-core/jasmine.js');                                         // 11
                                                                                                                      // 12
var showOnTestDeprecationInfo = _.once(function () {                                                                  // 13
  log.info('You no longer need to wrap your server integration tests in Jasmine.onTest ;-)')                          // 14
});                                                                                                                   // 15
                                                                                                                      // 16
Meteor.methods({                                                                                                      // 17
  'jasmine/showOnTestDeprecationInfo': function () {                                                                  // 18
    showOnTestDeprecationInfo()                                                                                       // 19
  }                                                                                                                   // 20
})                                                                                                                    // 21
                                                                                                                      // 22
var registeredOnTestCallbacks = [];                                                                                   // 23
                                                                                                                      // 24
var onTest = function (func) {                                                                                        // 25
  registeredOnTestCallbacks.push(func)                                                                                // 26
}                                                                                                                     // 27
                                                                                                                      // 28
// Flag for deprecation message                                                                                       // 29
var wasJasmineOnTestCalled = false;                                                                                   // 30
                                                                                                                      // 31
Jasmine = Jasmine || {}                                                                                               // 32
// Need to bring it on the global scope manually                                                                      // 33
// because this package has `debugOnly: true`                                                                         // 34
global.Jasmine = Jasmine                                                                                              // 35
_.extend(Jasmine, {                                                                                                   // 36
  // Deprecated                                                                                                       // 37
  // You no longer need to wrap your tests in Jasmine.onTest.                                                         // 38
  onTest: function (func) {                                                                                           // 39
    onTest(func);                                                                                                     // 40
    wasJasmineOnTestCalled = true;                                                                                    // 41
  }                                                                                                                   // 42
})                                                                                                                    // 43
                                                                                                                      // 44
                                                                                                                      // 45
// Postpone the execution of the test blocks until we run the tests.                                                  // 46
// This makes sure that the whole app is loaded before.                                                               // 47
var jasmineGlobals = [                                                                                                // 48
  'describe',                                                                                                         // 49
  'xdescribe',                                                                                                        // 50
  'fdescribe',                                                                                                        // 51
  'beforeEach',                                                                                                       // 52
  'afterEach',                                                                                                        // 53
  'beforeAll',                                                                                                        // 54
  'afterAll'                                                                                                          // 55
]                                                                                                                     // 56
                                                                                                                      // 57
jasmineGlobals.forEach(function (jasmineGlobal) {                                                                     // 58
  global[jasmineGlobal] = executeOnTestFactory(jasmineGlobal)                                                         // 59
})                                                                                                                    // 60
                                                                                                                      // 61
function executeOnTestFactory(funcName) {                                                                             // 62
  return function (/* arguments */) {                                                                                 // 63
    var args = arguments                                                                                              // 64
    onTest(function () {                                                                                              // 65
      global[funcName].apply(global, args)                                                                            // 66
    })                                                                                                                // 67
  }                                                                                                                   // 68
}                                                                                                                     // 69
                                                                                                                      // 70
                                                                                                                      // 71
ServerIntegrationTestFramework = function (options) {                                                                 // 72
  options = options || {}                                                                                             // 73
                                                                                                                      // 74
  _.defaults(options, {                                                                                               // 75
    name: 'jasmine-server-integration',                                                                               // 76
    regex: '^tests/jasmine/server/integration/.+\\.(js|es6|jsx|coffee|litcoffee|coffee\\.md)$',                       // 77
    sampleTestGenerator: function () {                                                                                // 78
      return [                                                                                                        // 79
        {                                                                                                             // 80
          path: 'jasmine/server/integration/sample/spec/PlayerSpec.js',                                               // 81
          contents: Assets.getText('src/server/integration/sample-tests/sample/spec/PlayerSpec.js')                   // 82
        },                                                                                                            // 83
        {                                                                                                             // 84
          path: 'jasmine/server/integration/sample/spec/SpecMatchers.js',                                             // 85
          contents: Assets.getText('src/server/integration/sample-tests/sample/spec/SpecMatchers.js')                 // 86
        },                                                                                                            // 87
        {                                                                                                             // 88
          path: 'jasmine/server/integration/sample/src/Player.js',                                                    // 89
          contents: Assets.getText('src/server/integration/sample-tests/sample/src/Player.js')                        // 90
        },                                                                                                            // 91
        {                                                                                                             // 92
          path: 'jasmine/server/integration/sample/src/Song.js',                                                      // 93
          contents: Assets.getText('src/server/integration/sample-tests/sample/src/Song.js')                          // 94
        }                                                                                                             // 95
      ]                                                                                                               // 96
    },                                                                                                                // 97
    jasmineRequire: jasmineRequire                                                                                    // 98
  })                                                                                                                  // 99
                                                                                                                      // 100
  JasmineTestFramework.call(this, options)                                                                            // 101
}                                                                                                                     // 102
                                                                                                                      // 103
ServerIntegrationTestFramework.prototype = Object.create(JasmineTestFramework.prototype)                              // 104
                                                                                                                      // 105
_.extend(ServerIntegrationTestFramework.prototype, {                                                                  // 106
                                                                                                                      // 107
  startMirror: function () {                                                                                          // 108
    var mirrorOptions = {                                                                                             // 109
      port: this._getCustomPort(),                                                                                    // 110
      testsPath: 'jasmine/server/integration'                                                                         // 111
    }                                                                                                                 // 112
                                                                                                                      // 113
    if (process.env.JASMINE_SERVER_MIRROR_APP_PATH) {                                                                 // 114
      mirrorOptions.args = [                                                                                          // 115
        '--test-app-path', process.env.JASMINE_SERVER_MIRROR_APP_PATH                                                 // 116
      ]                                                                                                               // 117
    }                                                                                                                 // 118
                                                                                                                      // 119
    var mirrorStarter = new MirrorStarter(this.name)                                                                  // 120
    mirrorStarter.lazyStartMirror(mirrorOptions)                                                                      // 121
  },                                                                                                                  // 122
                                                                                                                      // 123
  _getCustomPort: function () {                                                                                       // 124
    var customPort = parseInt(process.env.JASMINE_SERVER_MIRROR_PORT, 10)                                             // 125
    if (!_.isNaN(customPort)) {                                                                                       // 126
      return customPort                                                                                               // 127
    }                                                                                                                 // 128
  },                                                                                                                  // 129
                                                                                                                      // 130
  setupEnvironment: function () {                                                                                     // 131
    var self = this                                                                                                   // 132
                                                                                                                      // 133
    self.jasmine = self.jasmineRequire.core(self.jasmineRequire)                                                      // 134
    self.env = self.jasmine.getEnv({                                                                                  // 135
      setTimeout: Meteor.setTimeout.bind(Meteor),                                                                     // 136
      clearTimeout: Meteor.clearTimeout.bind(Meteor)                                                                  // 137
    })                                                                                                                // 138
    var jasmineInterface = new JasmineInterface({jasmine: self.jasmine})                                              // 139
                                                                                                                      // 140
    _.extend(global, {                                                                                                // 141
      MeteorStubs: MeteorStubs,                                                                                       // 142
      ComponentMocker: ComponentMocker                                                                                // 143
    })                                                                                                                // 144
                                                                                                                      // 145
    _.extend(global, jasmineInterface)                                                                                // 146
                                                                                                                      // 147
    // Load mock helper                                                                                               // 148
    runCodeInContext(Assets.getText('src/lib/mock.js'), null)                                                         // 149
  },                                                                                                                  // 150
                                                                                                                      // 151
  start: function () {                                                                                                // 152
    var self = this;                                                                                                  // 153
                                                                                                                      // 154
    log.debug('Starting Server Integration mode')                                                                     // 155
                                                                                                                      // 156
    this._connectToMainApp()                                                                                          // 157
                                                                                                                      // 158
    if (isTestPackagesMode()) {                                                                                       // 159
      self.runTests();                                                                                                // 160
    } else {                                                                                                          // 161
      var runServerIntegrationTests = _.once(function () {                                                            // 162
        serverIntegrationMirrorObserver.stop();                                                                       // 163
        self.runTests();                                                                                              // 164
      });                                                                                                             // 165
                                                                                                                      // 166
      var VelocityMirrors = new Meteor.Collection(                                                                    // 167
        'velocityMirrors',                                                                                            // 168
        {connection: this.ddpParentConnection}                                                                        // 169
      );                                                                                                              // 170
      this.ddpParentConnection.subscribe('VelocityMirrors');                                                          // 171
                                                                                                                      // 172
      var serverIntegrationMirrorObserver = VelocityMirrors.find({                                                    // 173
        framework: self.name,                                                                                         // 174
        state: 'ready'                                                                                                // 175
      }).observe({                                                                                                    // 176
        added: runServerIntegrationTests,                                                                             // 177
        changed: runServerIntegrationTests                                                                            // 178
      });                                                                                                             // 179
    }                                                                                                                 // 180
  },                                                                                                                  // 181
                                                                                                                      // 182
  runTests: function () {                                                                                             // 183
    var self = this                                                                                                   // 184
                                                                                                                      // 185
    log.debug('Running Server Integration test mode')                                                                 // 186
                                                                                                                      // 187
    this.ddpParentConnection.call('velocity/reports/reset', {framework: self.name})                                   // 188
                                                                                                                      // 189
    frameworks.serverIntegration.setupEnvironment()                                                                   // 190
                                                                                                                      // 191
    // Load specs that were wrapped with Jasmine.onTest                                                               // 192
    self._runOnTestCallbacks()                                                                                        // 193
                                                                                                                      // 194
    var velocityReporter = new VelocityTestReporter({                                                                 // 195
      mode: 'Server Integration',                                                                                     // 196
      framework: self.name,                                                                                           // 197
      env: self.env,                                                                                                  // 198
      onComplete: self._reportCompleted.bind(self),                                                                   // 199
      timer: new self.jasmine.Timer(),                                                                                // 200
      ddpParentConnection: self.ddpParentConnection                                                                   // 201
    })                                                                                                                // 202
                                                                                                                      // 203
    self.env.addReporter(velocityReporter)                                                                            // 204
    self.env.execute()                                                                                                // 205
  },                                                                                                                  // 206
                                                                                                                      // 207
  _runOnTestCallbacks: function () {                                                                                  // 208
    var self = this                                                                                                   // 209
                                                                                                                      // 210
    if (wasJasmineOnTestCalled) {                                                                                     // 211
      self.ddpParentConnection.call('jasmine/showOnTestDeprecationInfo')                                              // 212
    }                                                                                                                 // 213
                                                                                                                      // 214
    _.forEach(registeredOnTestCallbacks, function (callback) {                                                        // 215
      callback()                                                                                                      // 216
    })                                                                                                                // 217
  },                                                                                                                  // 218
                                                                                                                      // 219
  _connectToMainApp: function () {                                                                                    // 220
    if (!this.ddpParentConnection) {                                                                                  // 221
      if (isTestPackagesMode()) {                                                                                     // 222
        this.ddpParentConnection = Meteor                                                                             // 223
      } else {                                                                                                        // 224
        log.debug('Connect to parent app "' + process.env.PARENT_URL + '" via DDP')                                   // 225
        this.ddpParentConnection = DDP.connect(process.env.PARENT_URL)                                                // 226
      }                                                                                                               // 227
    }                                                                                                                 // 228
  },                                                                                                                  // 229
                                                                                                                      // 230
  _reportCompleted: function () {                                                                                     // 231
    this.ddpParentConnection.call('velocity/reports/completed', {framework: this.name})                               // 232
  }                                                                                                                   // 233
})                                                                                                                    // 234
                                                                                                                      // 235
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/server/lib/mirror-info.js                                                               //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
Meteor.methods({                                                                                                      // 1
  'jasmine/environmentInfo': function () {                                                                            // 2
    var mirrorInfo = {                                                                                                // 3
      isMirror: isMirror(),                                                                                           // 4
      isTestPackagesMode: isTestPackagesMode(),                                                                       // 5
      framework: process.env.FRAMEWORK                                                                                // 6
    };                                                                                                                // 7
                                                                                                                      // 8
    if (isTestPackagesMode()) {                                                                                       // 9
      mirrorInfo.parentUrl = process.env.ROOT_URL                                                                     // 10
    } else {                                                                                                          // 11
      mirrorInfo.parentUrl = process.env.PARENT_URL                                                                   // 12
    }                                                                                                                 // 13
                                                                                                                      // 14
    return mirrorInfo                                                                                                 // 15
  }                                                                                                                   // 16
})                                                                                                                    // 17
                                                                                                                      // 18
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/server/lib/runFileInContext.js                                                          //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals runCodeInContext: true, runFileInContext: true */                                                          // 1
                                                                                                                      // 2
var vm = Npm.require('vm'),                                                                                           // 3
    fs = Npm.require('fs'),                                                                                           // 4
    readFile = Meteor.wrapAsync(fs.readFile)                                                                          // 5
                                                                                                                      // 6
runCodeInContext = function (code, context, filename) {                                                               // 7
  try {                                                                                                               // 8
    if (context) {                                                                                                    // 9
      vm.runInContext(code, context, filename)                                                                        // 10
    } else {                                                                                                          // 11
      vm.runInThisContext(code, filename)                                                                             // 12
    }                                                                                                                 // 13
  } catch(error) {                                                                                                    // 14
    log.error('The code has syntax errors.', error)                                                                   // 15
  }                                                                                                                   // 16
}                                                                                                                     // 17
                                                                                                                      // 18
runFileInContext = function (filename, context) {                                                                     // 19
  var code = readFile(filename, {encoding: 'utf8'})                                                                   // 20
  try {                                                                                                               // 21
    if (context) {                                                                                                    // 22
      vm.runInContext(code, context, filename)                                                                        // 23
    } else {                                                                                                          // 24
      vm.runInThisContext(code, filename)                                                                             // 25
    }                                                                                                                 // 26
  } catch(error) {                                                                                                    // 27
    log.error('The file "' + filename + '" has syntax errors.', error)                                                // 28
  }                                                                                                                   // 29
}                                                                                                                     // 30
                                                                                                                      // 31
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/server/lib/coffee-require.js                                                            //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals coffeeRequire: true */                                                                                     // 1
                                                                                                                      // 2
// coffeeRequire                                                                                                      // 3
var fs = Npm.require('fs'),                                                                                           // 4
    readFile = Meteor.wrapAsync(fs.readFile),                                                                         // 5
    path = Npm.require('path')                                                                                        // 6
                                                                                                                      // 7
// The coffee-script compiler overrides Error.prepareStackTrace, mostly for the                                       // 8
// use of coffee.run which we don't use.  This conflicts with the tool's use of                                       // 9
// Error.prepareStackTrace to properly show error messages in linked code.  Save                                      // 10
// the tool's one and restore it after coffee-script clobbers it.                                                     // 11
var prepareStackTrace = Error.prepareStackTrace;                                                                      // 12
var coffee = Npm.require('coffee-script');                                                                            // 13
Error.prepareStackTrace = prepareStackTrace;                                                                          // 14
                                                                                                                      // 15
/**                                                                                                                   // 16
 * A coffee processor that can add source maps to compiled files                                                      // 17
 *                                                                                                                    // 18
 * This is a modified version of https://github.com/karma-runner/karma-coffee-preprocessor                            // 19
 *                                                                                                                    // 20
 * @method coffeePreprocessor                                                                                         // 21
 * @param {Object} options to pass directly to the coffee-script compiler. See here                                   // 22
 */                                                                                                                   // 23
var coffeePreprocessor = function (options, content, file, done) {                                                    // 24
  var result = null                                                                                                   // 25
  var map                                                                                                             // 26
  var dataUri                                                                                                         // 27
                                                                                                                      // 28
  // Clone the options because coffee.compile mutates them                                                            // 29
  var opts = _.clone(options)                                                                                         // 30
                                                                                                                      // 31
  if (coffee.helpers.isLiterate(file.originalPath)) {                                                                 // 32
    opts.literate = true;                                                                                             // 33
  }                                                                                                                   // 34
                                                                                                                      // 35
  try {                                                                                                               // 36
    result = coffee.compile(content, opts)                                                                            // 37
  } catch (e) {                                                                                                       // 38
    /* jshint camelcase: false */                                                                                     // 39
    console.log('%s\n  at %s:%d', e.message, file.originalPath, e.location.first_line)                                // 40
    /* jshint camelcase: true */                                                                                      // 41
    return done(e, null)                                                                                              // 42
  }                                                                                                                   // 43
                                                                                                                      // 44
  if (result.v3SourceMap) {                                                                                           // 45
    map = JSON.parse(result.v3SourceMap)                                                                              // 46
    map.sources[0] = path.basename(file.originalPath)                                                                 // 47
    map.sourcesContent = [content]                                                                                    // 48
    map.file = path.basename(file.originalPath.replace(/\.(coffee|litcoffee|coffee\.md)$/, '.js'))                    // 49
    file.sourceMap = map                                                                                              // 50
    dataUri = 'data:application/json;charset=utf-8;base64,' + new Buffer(JSON.stringify(map)).toString('base64')      // 51
    done(null, result.js + '\n//@ sourceMappingURL=' + dataUri + '\n')                                                // 52
  } else {                                                                                                            // 53
    done(null, result.js || result)                                                                                   // 54
  }                                                                                                                   // 55
}                                                                                                                     // 56
                                                                                                                      // 57
/**                                                                                                                   // 58
 * Load and execute a coffeescript file.                                                                              // 59
 *                                                                                                                    // 60
 * @method coffeeRequire                                                                                              // 61
 * @param {String} target Path to coffeescript file to load.                                                          // 62
 * @param {Object} context the context to run the CoffeeScript code within.                                           // 63
 */                                                                                                                   // 64
coffeeRequire = function (target, context) {                                                                          // 65
  var file = {originalPath: target},                                                                                  // 66
      code = readFile(target, {encoding: 'utf8'})                                                                     // 67
                                                                                                                      // 68
  coffeePreprocessor({                                                                                                // 69
    bare: true,                                                                                                       // 70
    sourceMap: false                                                                                                  // 71
  }, code, file, function (err, code) {                                                                               // 72
    if (!err) {                                                                                                       // 73
      runCodeInContext(code, context, target)                                                                         // 74
    } else {                                                                                                          // 75
      log.error(err)                                                                                                  // 76
    }                                                                                                                 // 77
  })                                                                                                                  // 78
}                                                                                                                     // 79
                                                                                                                      // 80
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/server/lib/file-loader.js                                                               //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals fileLoader: true, loadOrderSort: false */                                                                  // 1
                                                                                                                      // 2
var appPath = MeteorFilesHelpers.getAppPath(),                                                                        // 3
    fs = Npm.require('fs'),                                                                                           // 4
    readDir = Meteor.wrapAsync(fs.readdir, fs),                                                                       // 5
    path = Npm.require('path'),                                                                                       // 6
    glob = Meteor.wrapAsync(Npm.require('glob'))                                                                      // 7
                                                                                                                      // 8
fileLoader = {                                                                                                        // 9
  loadFiles: loadFiles,                                                                                               // 10
  loadFile: loadFile                                                                                                  // 11
}                                                                                                                     // 12
                                                                                                                      // 13
/**                                                                                                                   // 14
 * Loads a Meteor app's javascript and coffeescript files.                                                            // 15
 * Matches Meteor core's load order.                                                                                  // 16
 *                                                                                                                    // 17
 * Excluded directories: private, public, programs, packages, tests                                                   // 18
 *                                                                                                                    // 19
 * @method loadFiles                                                                                                  // 20
 * @param {Object} context Global context                                                                             // 21
 * @param {Object} [options]                                                                                          // 22
 * @param {Array|String} [options.ignoreDirs] Directories to ignore                                                   // 23
 */                                                                                                                   // 24
function loadFiles(context, options) {                                                                                // 25
  var files = getFiles(options)                                                                                       // 26
  files.sort(loadOrderSort([]))                                                                                       // 27
  log.debug('loadFiles', files)                                                                                       // 28
  _.each(files, function (file) {                                                                                     // 29
    loadFile(file, context)                                                                                           // 30
  })                                                                                                                  // 31
}                                                                                                                     // 32
                                                                                                                      // 33
/**                                                                                                                   // 34
 * Get all files that should be loaded.                                                                               // 35
 * @param options                                                                                                     // 36
 * @returns {Array}                                                                                                   // 37
 */                                                                                                                   // 38
function getFiles(options) {                                                                                          // 39
  options = _.extend({                                                                                                // 40
    ignoreDirs: []                                                                                                    // 41
  }, options)                                                                                                         // 42
                                                                                                                      // 43
  var filePattern = '*.{js,coffee,litcoffee,coffee.md}';                                                              // 44
                                                                                                                      // 45
  // Find files in the root folder                                                                                    // 46
  var files = glob(filePattern,                                                                                       // 47
    {                                                                                                                 // 48
      cwd: appPath,                                                                                                   // 49
      ignore: 'mobile-config.js'                                                                                      // 50
    }                                                                                                                 // 51
  )                                                                                                                   // 52
                                                                                                                      // 53
  // Find files in the sub folders that we don't ignore                                                               // 54
  var shouldIgnore = ['tests', 'private', 'public', 'programs', 'packages']                                           // 55
  shouldIgnore = shouldIgnore.concat(options.ignoreDirs)                                                              // 56
                                                                                                                      // 57
  var relevantDirs = readdirNoDots(appPath)                                                                           // 58
  relevantDirs = _.filter(relevantDirs, function (dir) {                                                              // 59
    return !_.contains(shouldIgnore, dir)                                                                             // 60
  })                                                                                                                  // 61
                                                                                                                      // 62
  files = _.reduce(relevantDirs, function (files, dir) {                                                              // 63
    var newFiles = glob(filePattern,                                                                                  // 64
      {                                                                                                               // 65
        cwd: path.join(appPath, dir),                                                                                 // 66
        matchBase: true                                                                                               // 67
      }                                                                                                               // 68
    )                                                                                                                 // 69
    newFiles = _.map(newFiles, function (filePath) {                                                                  // 70
      return path.join(dir, filePath);                                                                                // 71
    });                                                                                                               // 72
                                                                                                                      // 73
    return files.concat(newFiles)                                                                                     // 74
  }, files)                                                                                                           // 75
                                                                                                                      // 76
  log.debug('getFiles has found the following files', files)                                                          // 77
                                                                                                                      // 78
  return files;                                                                                                       // 79
}                                                                                                                     // 80
                                                                                                                      // 81
function readdirNoDots(path) {                                                                                        // 82
  var entries                                                                                                         // 83
  try {                                                                                                               // 84
    entries = readDir(path);                                                                                          // 85
  } catch (error) {                                                                                                   // 86
    if (error.code === 'ENOENT') {                                                                                    // 87
      return []                                                                                                       // 88
    } else {                                                                                                          // 89
      throw error;                                                                                                    // 90
    }                                                                                                                 // 91
  }                                                                                                                   // 92
  return _.filter(entries, function (entry) {                                                                         // 93
    return entry && entry[0] !== '.'                                                                                  // 94
  })                                                                                                                  // 95
}                                                                                                                     // 96
                                                                                                                      // 97
/**                                                                                                                   // 98
 * Load and execute the target source file.                                                                           // 99
 * Will use node's 'require' if source file has a .js extension or                                                    // 100
 * karma's coffeescript preprocessor if a .coffee/.litcoffee/.coffee.md extension                                     // 101
 *                                                                                                                    // 102
 * @method loadFile                                                                                                   // 103
 * @param {String} target file path to load, relative to meteor app                                                   // 104
 * @param {Object} context the context to load files within.                                                          // 105
 *        If omitted the file will run in this context.                                                               // 106
 */                                                                                                                   // 107
function loadFile (target, context) {                                                                                 // 108
  var filename = path.resolve(appPath, target),                                                                       // 109
      ext                                                                                                             // 110
                                                                                                                      // 111
  if (fs.existsSync(filename)) {                                                                                      // 112
    ext = path.extname(filename)                                                                                      // 113
    if ('.js' === ext) {                                                                                              // 114
      log.debug('loading source file:', filename)                                                                     // 115
      runFileInContext(filename, context)                                                                             // 116
    } else if (/\.(coffee|litcoffee|coffee\.md)$/.test(target)) {                                                     // 117
      log.debug('loading source file:', filename)                                                                     // 118
      coffeeRequire(filename, context)                                                                                // 119
    }                                                                                                                 // 120
  } else {                                                                                                            // 121
    log.error(                                                                                                        // 122
      'loadFile could not load "' + filename + '". ' +                                                                // 123
      'The file does not exist.'                                                                                      // 124
    );                                                                                                                // 125
  }                                                                                                                   // 126
}                                                                                                                     // 127
                                                                                                                      // 128
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/server/lib/load-order-sort.js                                                           //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
var path = Npm.require('path')                                                                                        // 1
                                                                                                                      // 2
/**                                                                                                                   // 3
 * Returns a sort comparator to order files into Meteor app load order.                                               // 4
 * templateExtensions should be a list of extensions like 'html'                                                      // 5
 * which should be loaded before other extensions.                                                                    // 6
 *                                                                                                                    // 7
 * source: Meteor core file                                                                                           // 8
 *   https://github.com/meteor/meteor/blob/devel/tools/packages.js#L47-L97                                            // 9
 *   May 5, 2014                                                                                                      // 10
 *                                                                                                                    // 11
 * @method loadOrderSort                                                                                              // 12
 * @param {Array} [templateExtensions} Optional array of extensions which will                                        // 13
 *                be loaded first.                                                                                    // 14
 * @return {Number} Either 1 or -1 depending on sort result                                                           // 15
 */                                                                                                                   // 16
loadOrderSort = function (templateExtensions) {                                                                       // 17
  var templateExtnames = {}                                                                                           // 18
  _.each(templateExtensions, function (extension) {                                                                   // 19
    templateExtnames['.' + extension] = true                                                                          // 20
  })                                                                                                                  // 21
                                                                                                                      // 22
  return function (a, b) {                                                                                            // 23
    // XXX MODERATELY SIZED HACK --                                                                                   // 24
    // push template files ahead of everything else. this is                                                          // 25
    // important because the user wants to be able to say                                                             // 26
    //   Template.foo.events = { ... }                                                                                // 27
    // in a JS file and not have to worry about ordering it                                                           // 28
    // before the corresponding .html file.                                                                           // 29
    //                                                                                                                // 30
    // maybe all of the templates should go in one file?                                                              // 31
    var isTemplate_a = _.has(templateExtnames, path.extname(a))                                                       // 32
    var isTemplate_b = _.has(templateExtnames, path.extname(b))                                                       // 33
    if (isTemplate_a !== isTemplate_b) {                                                                              // 34
      return (isTemplate_a ? -1 : 1)                                                                                  // 35
    }                                                                                                                 // 36
                                                                                                                      // 37
    // main.* loaded last                                                                                             // 38
    var ismain_a = (path.basename(a).indexOf('main.') === 0)                                                          // 39
    var ismain_b = (path.basename(b).indexOf('main.') === 0)                                                          // 40
    if (ismain_a !== ismain_b) {                                                                                      // 41
      return (ismain_a ? 1 : -1)                                                                                      // 42
    }                                                                                                                 // 43
                                                                                                                      // 44
    // /lib/ loaded first                                                                                             // 45
    var islib_a = (a.indexOf(path.sep + 'lib' + path.sep) !== -1 ||                                                   // 46
                   a.indexOf('lib' + path.sep) === 0)                                                                 // 47
    var islib_b = (b.indexOf(path.sep + 'lib' + path.sep) !== -1 ||                                                   // 48
                   b.indexOf('lib' + path.sep) === 0)                                                                 // 49
    if (islib_a !== islib_b) {                                                                                        // 50
      return (islib_a ? -1 : 1)                                                                                       // 51
    }                                                                                                                 // 52
                                                                                                                      // 53
    // deeper paths loaded first.                                                                                     // 54
    var len_a = a.split(path.sep).length                                                                              // 55
    var len_b = b.split(path.sep).length                                                                              // 56
    if (len_a !== len_b) {                                                                                            // 57
      return (len_a < len_b ? 1 : -1)                                                                                 // 58
    }                                                                                                                 // 59
                                                                                                                      // 60
    // otherwise alphabetical                                                                                         // 61
    return (a < b ? -1 : 1)                                                                                           // 62
  }                                                                                                                   // 63
}                                                                                                                     // 64
                                                                                                                      // 65
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/server/lib/mock-loader.js                                                               //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals mockLoader: true */                                                                                        // 1
                                                                                                                      // 2
var path = Npm.require('path'),                                                                                       // 3
    glob = Npm.require('glob')                                                                                        // 4
                                                                                                                      // 5
mockLoader = {                                                                                                        // 6
  loadUserMocks: function (context) {                                                                                 // 7
    var basePath = path.join(Velocity.getAppPath(), 'tests/jasmine/server/unit')                                      // 8
    this._getMockFiles(basePath).forEach(function (file) {                                                            // 9
      log.debug('loading mock file:', file)                                                                           // 10
      fileLoader.loadFile(file, context)                                                                              // 11
    })                                                                                                                // 12
  },                                                                                                                  // 13
                                                                                                                      // 14
  _getMockFiles: function (basePath) {                                                                                // 15
    var filenamePattern = '**/*-{stub,stubs,mock,mocks}.{js,coffee,litcoffee,coffee.md}'                              // 16
    var files = glob.sync(filenamePattern, {cwd: basePath})                                                           // 17
    files = files.map(function (file) {                                                                               // 18
      return path.join(basePath, file)                                                                                // 19
    })                                                                                                                // 20
    return files                                                                                                      // 21
  }                                                                                                                   // 22
}                                                                                                                     // 23
                                                                                                                      // 24
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/server/unit/included-packages.js                                                        //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals packagesToIncludeInUnitTests: true */                                                                      // 1
                                                                                                                      // 2
// Packages that should be included in unit test mode                                                                 // 3
// and therefore should not be mocked                                                                                 // 4
packagesToIncludeInUnitTests = [                                                                                      // 5
  'lodash',                                                                                                           // 6
  'stevezhu:lodash',                                                                                                  // 7
  'erasaur:meteor-lodash',                                                                                            // 8
  'underscore',                                                                                                       // 9
  'digilord:sugarjs',                                                                                                 // 10
  'momentjs:moment',                                                                                                  // 11
  'mrt:moment',                                                                                                       // 12
  'rzymek:moment',                                                                                                    // 13
  'xolvio:webdriver'                                                                                                  // 14
]                                                                                                                     // 15
                                                                                                                      // 16
var customIncludedPackages =                                                                                          // 17
  process.env.JASMINE_PACKAGES_TO_INCLUDE_IN_UNIT_TESTS                                                               // 18
if (customIncludedPackages) {                                                                                         // 19
  packagesToIncludeInUnitTests = packagesToIncludeInUnitTests                                                         // 20
    .concat(customIncludedPackages.split(','))                                                                        // 21
}                                                                                                                     // 22
                                                                                                                      // 23
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/server/unit/mock-generator.js                                                           //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals MockGenerator: true */                                                                                     // 1
                                                                                                                      // 2
// goal: write all package metadata to file so we can create                                                          // 3
// the package mocks when running out-of-context                                                                      // 4
//                                                                                                                    // 5
// Used to mock packages for the server unit test runner                                                              // 6
                                                                                                                      // 7
var ComponentMocker = Npm.require('component-mocker'),                                                                // 8
    fs = Npm.require('fs'),                                                                                           // 9
    path = Npm.require('path'),                                                                                       // 10
    mkdirp = Npm.require('mkdirp'),                                                                                   // 11
    writeFile = Meteor.wrapAsync(fs.writeFile),                                                                       // 12
    packageMetadata = {}                                                                                              // 13
                                                                                                                      // 14
function shouldIgnorePackage (packageName) {                                                                          // 15
  var packagesToIgnore = [                                                                                            // 16
    'meteor',                                                                                                         // 17
    'minifiers',                                                                                                      // 18
    // Collides with expect of Jasmine                                                                                // 19
    'spacejamio:chai',                                                                                                // 20
    'practicalmeteor:chai'                                                                                            // 21
  ]                                                                                                                   // 22
    .concat(getEnvironmentIgnoredPackages())                                                                          // 23
    .concat(packagesToIncludeInUnitTests)                                                                             // 24
                                                                                                                      // 25
  return _.contains(packagesToIgnore, packageName)                                                                    // 26
}                                                                                                                     // 27
                                                                                                                      // 28
function getEnvironmentIgnoredPackages() {                                                                            // 29
  var packagesToIgnore = process.env.JASMINE_IGNORE_PACKAGES                                                          // 30
  if (packagesToIgnore) {                                                                                             // 31
    return packagesToIgnore.split(',').map(function (packageName) {                                                   // 32
      return packageName.trim()                                                                                       // 33
    });                                                                                                               // 34
  } else {                                                                                                            // 35
    return []                                                                                                         // 36
  }                                                                                                                   // 37
}                                                                                                                     // 38
                                                                                                                      // 39
function shouldIgnoreExport (exportName) {                                                                            // 40
  var exportsToIgnore = ['MongoInternals', 'WebAppInternals']                                                         // 41
                                                                                                                      // 42
  return _.contains(exportsToIgnore, exportName)                                                                      // 43
}                                                                                                                     // 44
                                                                                                                      // 45
MockGenerator = {                                                                                                     // 46
  // Mocks should only be generated once per app run                                                                  // 47
  // because the app restarts when a server file has changed.                                                         // 48
  generateMocks: _.once(function () {                                                                                 // 49
                                                                                                                      // 50
    /*                                                                                                                // 51
     Package = {                                                                                                      // 52
     "meteor": {                                                                                                      // 53
     "Meteor": {                                                                                                      // 54
     // ...                                                                                                           // 55
     }                                                                                                                // 56
     }                                                                                                                // 57
     "roles": {                                                                                                       // 58
     "Roles": {...}                                                                                                   // 59
     },                                                                                                               // 60
     "iron-router": {                                                                                                 // 61
     "Router": {...}                                                                                                  // 62
     }                                                                                                                // 63
     }                                                                                                                // 64
     */                                                                                                               // 65
                                                                                                                      // 66
    _.forEach(Package, function (packageObj, name) {                                                                  // 67
      if (!shouldIgnorePackage(name)) {                                                                               // 68
        var packageExports = {}                                                                                       // 69
                                                                                                                      // 70
        _.forEach(packageObj, function (packageExportObj, packageExportName) {                                        // 71
          if (!shouldIgnoreExport(packageExportName)) {                                                               // 72
            try {                                                                                                     // 73
              packageExports[packageExportName] = ComponentMocker.getMetadata(packageExportObj)                       // 74
            } catch (error) {                                                                                         // 75
              console.error('Could not mock the export ' + packageExportName +                                        // 76
              ' of the package ' + name + '. Will continue anyway.', error, error.stack)                              // 77
            }                                                                                                         // 78
          }                                                                                                           // 79
        })                                                                                                            // 80
                                                                                                                      // 81
        packageMetadata[name] = packageExports                                                                        // 82
      }                                                                                                               // 83
    })                                                                                                                // 84
                                                                                                                      // 85
    // Initially load the global stubs for app code                                                                   // 86
    writeMetadataToFile(                                                                                              // 87
      packageMetadata,                                                                                                // 88
      Assets.getText('src/server/unit/package-stubs.js.tpl'),                                                         // 89
      'tests/jasmine/server/unit/package-stubs.js'                                                                    // 90
    )                                                                                                                 // 91
                                                                                                                      // 92
    // Mocks the globals after each tests                                                                             // 93
    writeMetadataToFile(                                                                                              // 94
      packageMetadata,                                                                                                // 95
      Assets.getText('src/server/unit/metadata-reader.js.tpl'),                                                       // 96
      'tests/jasmine/server/unit/packageMocksSpec.js'                                                                 // 97
    )                                                                                                                 // 98
                                                                                                                      // 99
    function writeMetadataToFile(metadata, template, destination) {                                                   // 100
      var output = _.template(template, {                                                                             // 101
        METADATA: JSON.stringify(metadata, null, '  ')                                                                // 102
      })                                                                                                              // 103
                                                                                                                      // 104
      var outputPath = path.join(MeteorFilesHelpers.getAppPath(), destination)                                        // 105
      mkdirp.sync(path.dirname(outputPath))                                                                           // 106
      writeFile(outputPath, output, {encoding: 'utf8'})                                                               // 107
    }                                                                                                                 // 108
  })                                                                                                                  // 109
}                                                                                                                     // 110
                                                                                                                      // 111
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/server/unit/ServerUnitTestFramework.js                                                  //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals ServerUnitTestFramework: true */                                                                           // 1
                                                                                                                      // 2
var path = Npm.require('path'),                                                                                       // 3
    fs = Npm.require('fs'),                                                                                           // 4
    vm = Npm.require('vm'),                                                                                           // 5
    Future = Npm.require(path.join('fibers', 'future')),                                                              // 6
    ComponentMocker = Npm.require('component-mocker'),                                                                // 7
    jasmineRequire = Npm.require('jasmine-core/lib/jasmine-core/jasmine.js')                                          // 8
                                                                                                                      // 9
ServerUnitTestFramework = function (options) {                                                                        // 10
  options = options || {}                                                                                             // 11
                                                                                                                      // 12
  _.defaults(options, {                                                                                               // 13
    name: 'jasmine-server-unit',                                                                                      // 14
    regex: '^tests/jasmine/server/unit/.+\\.(js|coffee|litcoffee|coffee\\.md)$',                                      // 15
    sampleTestGenerator: function () {                                                                                // 16
      return [                                                                                                        // 17
        {                                                                                                             // 18
          path: 'jasmine/server/unit/sample/spec/PlayerSpec.js',                                                      // 19
          contents: Assets.getText('src/server/unit/sample-tests/sample/spec/PlayerSpec.js')                          // 20
        },                                                                                                            // 21
        {                                                                                                             // 22
          path: 'jasmine/server/unit/sample/spec/SpecMatchers.js',                                                    // 23
          contents: Assets.getText('src/server/unit/sample-tests/sample/spec/SpecMatchers.js')                        // 24
        },                                                                                                            // 25
        {                                                                                                             // 26
          path: 'jasmine/server/unit/sample/src/Player.js',                                                           // 27
          contents: Assets.getText('src/server/unit/sample-tests/sample/src/Player.js')                               // 28
        },                                                                                                            // 29
        {                                                                                                             // 30
          path: 'jasmine/server/unit/sample/src/Song.js',                                                             // 31
          contents: Assets.getText('src/server/unit/sample-tests/sample/src/Song.js')                                 // 32
        }                                                                                                             // 33
      ]                                                                                                               // 34
    },                                                                                                                // 35
    //regex: 'jasmine/.+\\.(js|coffee|litcoffee|coffee\\.md)$',                                                       // 36
    jasmineRequire: jasmineRequire                                                                                    // 37
  })                                                                                                                  // 38
                                                                                                                      // 39
  JasmineTestFramework.call(this, options)                                                                            // 40
}                                                                                                                     // 41
                                                                                                                      // 42
ServerUnitTestFramework.prototype = Object.create(JasmineTestFramework.prototype)                                     // 43
                                                                                                                      // 44
_.extend(ServerUnitTestFramework.prototype, {                                                                         // 45
                                                                                                                      // 46
  _getTestFilesCursor: function () {                                                                                  // 47
    return VelocityTestFiles.find({                                                                                   // 48
      targetFramework: this.name,                                                                                     // 49
      relativePath: {                                                                                                 // 50
        $nin: [                                                                                                       // 51
          'tests/jasmine/server/unit/packageMocksSpec.js',                                                            // 52
          'tests/jasmine/server/unit/package-stubs.js'                                                                // 53
        ]                                                                                                             // 54
      }                                                                                                               // 55
    })                                                                                                                // 56
  },                                                                                                                  // 57
                                                                                                                      // 58
  start: function () {                                                                                                // 59
    var testFilesCursor = this._getTestFilesCursor()                                                                  // 60
                                                                                                                      // 61
    var _runTests  = _.debounce(Meteor.bindEnvironment(this.runTests.bind(this),                                      // 62
      '[JasmineTestFramework.start.runTests]'), 200)                                                                  // 63
                                                                                                                      // 64
    this._observer = testFilesCursor.observe({                                                                        // 65
      added: _runTests,                                                                                               // 66
      changed: _runTests,                                                                                             // 67
      removed: _runTests                                                                                              // 68
    });                                                                                                               // 69
                                                                                                                      // 70
    // Always run tests at least once.                                                                                // 71
    // The CI runner needs a completed event.                                                                         // 72
    _runTests()                                                                                                       // 73
  },                                                                                                                  // 74
                                                                                                                      // 75
  runTests: function executeSpecsUnitMode() {                                                                         // 76
    Meteor.call('velocity/reports/reset', {framework: this.name})                                                     // 77
                                                                                                                      // 78
    if (this._getTestFilesCursor().count() === 0) {                                                                   // 79
      this._reportCompleted()                                                                                         // 80
      return                                                                                                          // 81
    }                                                                                                                 // 82
                                                                                                                      // 83
    MockGenerator.generateMocks()                                                                                     // 84
                                                                                                                      // 85
    var jasmine = this.jasmineRequire.core(this.jasmineRequire)                                                       // 86
    var jasmineInterface = new JasmineInterface({jasmine: jasmine})                                                   // 87
                                                                                                                      // 88
    var testFilePath = path.join(Velocity.getTestsPath(), 'jasmine', 'server', 'unit')                                // 89
                                                                                                                      // 90
    var globalContext = {                                                                                             // 91
      process: process,                                                                                               // 92
      console: console,                                                                                               // 93
      Buffer: Buffer,                                                                                                 // 94
      Npm: Npm,                                                                                                       // 95
      MeteorStubs: MeteorStubs,                                                                                       // 96
      ComponentMocker: ComponentMocker,                                                                               // 97
      // Private state data that only we use                                                                          // 98
      __jasmine: {                                                                                                    // 99
        Meteor: {                                                                                                     // 100
          settings: Meteor.settings                                                                                   // 101
        }                                                                                                             // 102
      }                                                                                                               // 103
    }                                                                                                                 // 104
                                                                                                                      // 105
    var getAsset = function (assetPath, encoding, callback) {                                                         // 106
      var fut;                                                                                                        // 107
      if (! callback) {                                                                                               // 108
        fut = new Future();                                                                                           // 109
        callback = fut.resolver();                                                                                    // 110
      }                                                                                                               // 111
      var _callback = Package.meteor.Meteor.bindEnvironment(function (err, result) {                                  // 112
        if (result && ! encoding) {                                                                                   // 113
          // Sadly, this copies in Node 0.10.                                                                         // 114
          result = new Uint8Array(result);                                                                            // 115
        }                                                                                                             // 116
        callback(err, result);                                                                                        // 117
      }, function (e) {                                                                                               // 118
        console.log('Exception in callback of getAsset', e.stack);                                                    // 119
      });                                                                                                             // 120
                                                                                                                      // 121
      var filePath = path.join(Velocity.getAppPath(), 'private', assetPath);                                          // 122
      fs.readFile(filePath, encoding, _callback);                                                                     // 123
      if (fut) {                                                                                                      // 124
        return fut.wait();                                                                                            // 125
      }                                                                                                               // 126
    };                                                                                                                // 127
                                                                                                                      // 128
    globalContext.__jasmine.Assets = {                                                                                // 129
      getText: function (assetPath, callback) {                                                                       // 130
        return getAsset(assetPath, 'utf8', callback);                                                                 // 131
      },                                                                                                              // 132
      getBinary: function (assetPath, callback) {                                                                     // 133
        return getAsset(assetPath, undefined, callback);                                                              // 134
      }                                                                                                               // 135
    };                                                                                                                // 136
                                                                                                                      // 137
    // Add all available packages that should be included                                                             // 138
    packagesToIncludeInUnitTests.forEach(function (packageName) {                                                     // 139
      var packageGlobals = Package[packageName]                                                                       // 140
      if (packageGlobals) {                                                                                           // 141
        _.forEach(packageGlobals, function (packageGlobal, packageGlobalName) {                                       // 142
          if (!globalContext[packageGlobalName]) {                                                                    // 143
            globalContext[packageGlobalName] = packageGlobal                                                          // 144
          }                                                                                                           // 145
        })                                                                                                            // 146
      }                                                                                                               // 147
    })                                                                                                                // 148
                                                                                                                      // 149
    globalContext.global = globalContext                                                                              // 150
    _.extend(globalContext, jasmineInterface)                                                                         // 151
                                                                                                                      // 152
    // Need to install Meteor here so the app code files don't throw an error                                         // 153
    // when loaded                                                                                                    // 154
    MeteorStubs.install(globalContext)                                                                                // 155
                                                                                                                      // 156
    globalContext.Meteor.isServer = true                                                                              // 157
    globalContext.Meteor.isClient = false                                                                             // 158
    globalContext.Meteor.settings = Meteor.settings                                                                   // 159
    globalContext.Meteor.npmRequire = Meteor.npmRequire                                                               // 160
    globalContext.Assets = globalContext.__jasmine.Assets                                                             // 161
                                                                                                                      // 162
    var context = vm.createContext(globalContext)                                                                     // 163
                                                                                                                      // 164
    // Load mock helper                                                                                               // 165
    runCodeInContext(                                                                                                 // 166
      Assets.getText('src/lib/mock.js'),                                                                              // 167
      context                                                                                                         // 168
    )                                                                                                                 // 169
                                                                                                                      // 170
    // load stubs                                                                                                     // 171
    try {                                                                                                             // 172
      mockLoader.loadUserMocks(context)                                                                               // 173
    }                                                                                                                 // 174
    catch (ex) {                                                                                                      // 175
      console.log('Error loading stubs', ex.message, ex.stack)                                                        // 176
    }                                                                                                                 // 177
                                                                                                                      // 178
    // load Meteor app source files prior to running tests                                                            // 179
    try {                                                                                                             // 180
      fileLoader.loadFiles(context, {ignoreDirs: ['client']})                                                         // 181
    }                                                                                                                 // 182
    catch (ex) {                                                                                                      // 183
      console.log('Error loading app files', ex.message, ex.stack)                                                    // 184
    }                                                                                                                 // 185
                                                                                                                      // 186
    // load MeteorStubs before and after each test                                                                    // 187
    runCodeInContext(                                                                                                 // 188
      Assets.getText('src/server/lib/contextSpec.js'),                                                                // 189
      context                                                                                                         // 190
    )                                                                                                                 // 191
                                                                                                                      // 192
    // Load specs                                                                                                     // 193
    var specs = getSpecFiles(testFilePath)                                                                            // 194
    for (var i = 0; i < specs.length; i++) {                                                                          // 195
      fileLoader.loadFile(specs[i], context)                                                                          // 196
    }                                                                                                                 // 197
                                                                                                                      // 198
    var env = jasmine.getEnv()                                                                                        // 199
                                                                                                                      // 200
    var velocityReporter = new VelocityTestReporter({                                                                 // 201
      mode: 'Server Unit',                                                                                            // 202
      framework: this.name,                                                                                           // 203
      env: env,                                                                                                       // 204
      onComplete: this._reportCompleted.bind(this),                                                                   // 205
      timer: new jasmine.Timer()                                                                                      // 206
    })                                                                                                                // 207
                                                                                                                      // 208
    env.addReporter(velocityReporter)                                                                                 // 209
    env.execute()                                                                                                     // 210
  },                                                                                                                  // 211
                                                                                                                      // 212
  _reportCompleted: function () {                                                                                     // 213
    Meteor.call('velocity/reports/completed', {framework: this.name})                                                 // 214
  }                                                                                                                   // 215
})                                                                                                                    // 216
                                                                                                                      // 217
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/client/unit/ClientUnitTestFramework.js                                                  //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals ClientUnitTestFramework: true, __meteor_runtime_config__: false */                                         // 1
                                                                                                                      // 2
ClientUnitTestFramework = function (options) {                                                                        // 3
  options = options || {}                                                                                             // 4
                                                                                                                      // 5
  _.defaults(options, {                                                                                               // 6
    name: 'jasmine-client-unit',                                                                                      // 7
    regex: '^tests/jasmine/client/unit/.+\\.(js|coffee|litcoffee|coffee\\.md)$',                                      // 8
    sampleTestGenerator: function () {                                                                                // 9
      return [                                                                                                        // 10
        {                                                                                                             // 11
          path: 'jasmine/client/unit/sample/spec/PlayerSpec.js',                                                      // 12
          contents: Assets.getText('src/client/unit/sample-tests/sample/spec/PlayerSpec.js')                          // 13
        },                                                                                                            // 14
        {                                                                                                             // 15
          path: 'jasmine/client/unit/sample/spec/SpecMatchers.js',                                                    // 16
          contents: Assets.getText('src/client/unit/sample-tests/sample/spec/SpecMatchers.js')                        // 17
        },                                                                                                            // 18
        {                                                                                                             // 19
          path: 'jasmine/client/unit/sample/src/Player.js',                                                           // 20
          contents: Assets.getText('src/client/unit/sample-tests/sample/src/Player.js')                               // 21
        },                                                                                                            // 22
        {                                                                                                             // 23
          path: 'jasmine/client/unit/sample/src/Song.js',                                                             // 24
          contents: Assets.getText('src/client/unit/sample-tests/sample/src/Song.js')                                 // 25
        }                                                                                                             // 26
      ]                                                                                                               // 27
    },                                                                                                                // 28
    jasmineRequire: null                                                                                              // 29
  })                                                                                                                  // 30
                                                                                                                      // 31
  this.userKarmaConfig = {}                                                                                           // 32
                                                                                                                      // 33
  JasmineTestFramework.call(this, options)                                                                            // 34
}                                                                                                                     // 35
                                                                                                                      // 36
ClientUnitTestFramework.prototype = Object.create(JasmineTestFramework.prototype)                                     // 37
                                                                                                                      // 38
_.extend(ClientUnitTestFramework.prototype, {                                                                         // 39
                                                                                                                      // 40
  start: function () {                                                                                                // 41
    lazyStart(this.name, this.startKarma.bind(this))                                                                  // 42
  },                                                                                                                  // 43
                                                                                                                      // 44
  startKarma: function () {                                                                                           // 45
    var self = this                                                                                                   // 46
    Karma.start(self.name, this.getKarmaConfig())                                                                     // 47
                                                                                                                      // 48
    // Listen for SIGUSR2/SIGHUP, which signals that a client asset has changed.                                      // 49
                                                                                                                      // 50
    var meteorVersion = MeteorVersion.getSemanticVersion();                                                           // 51
    var reloadSignal = (meteorVersion && PackageVersion.lessThan(meteorVersion, '1.0.4')) ?                           // 52
      'SIGUSR2' :                                                                                                     // 53
      'SIGHUP'                                                                                                        // 54
                                                                                                                      // 55
    process.on(reloadSignal, Meteor.bindEnvironment(function () {                                                     // 56
      // Wait a bit to get the updated file catalog                                                                   // 57
      Meteor.setTimeout(function () {                                                                                 // 58
        log.debug('Client assets have changed. Updating Karma config file.')                                          // 59
        Karma.setConfig(self.name, self.getKarmaConfig())                                                             // 60
      }, 100)                                                                                                         // 61
    }));                                                                                                              // 62
  },                                                                                                                  // 63
                                                                                                                      // 64
  setUserKarmaConfig: function (config) {                                                                             // 65
    var blacklist = [                                                                                                 // 66
      'autoWatch', 'autoWatchBatchDelay',                                                                             // 67
      'basePath', 'browserDisconnectTimeout', 'browserDisconnectTolerance',                                           // 68
      'browserNoActivityTimeout', 'browsers', 'captureTimeout', 'client',                                             // 69
      'exclude', 'files', 'frameworks', 'hostname', 'port', 'proxies', 'singleRun',                                   // 70
      'urlRoot'                                                                                                       // 71
    ]                                                                                                                 // 72
    this.userKarmaConfig = _.omit(config, blacklist)                                                                  // 73
    log.debug('User has changed Karma config. Updating Karma config file.')                                           // 74
    Karma.setConfig(this.name, this.getKarmaConfig())                                                                 // 75
  },                                                                                                                  // 76
                                                                                                                      // 77
  getKarmaConfig: function () {                                                                                       // 78
    var files = this._getPreAppFiles().concat(                                                                        // 79
      this._getPackageFiles(),                                                                                        // 80
      this._getHelperFiles(),                                                                                         // 81
      this._getStubFiles(),                                                                                           // 82
      this._getCssFiles(),                                                                                            // 83
      this._getAppFiles(),                                                                                            // 84
      this._getTestFiles()                                                                                            // 85
    )                                                                                                                 // 86
                                                                                                                      // 87
    var launcherPlugins = {                                                                                           // 88
      'Chrome': 'karma-chrome-launcher',                                                                              // 89
      'ChromeCanary': 'karma-chrome-launcher',                                                                        // 90
      'Firefox': 'karma-firefox-launcher',                                                                            // 91
      'PhantomJS': 'karma-phantomjs-launcher',                                                                        // 92
      'SauceLabs': 'karma-sauce-launcher'                                                                             // 93
    }                                                                                                                 // 94
                                                                                                                      // 95
    var browser = process.env.JASMINE_BROWSER || 'Chrome';                                                            // 96
    var launcherPlugin = launcherPlugins[browser];                                                                    // 97
                                                                                                                      // 98
    /* jshint camelcase: false */                                                                                     // 99
    var startOptions = _.extend({}, this.userKarmaConfig, {                                                           // 100
      port: 9876,                                                                                                     // 101
      basePath: Velocity.getAppPath(),                                                                                // 102
      frameworks: ['jasmine'],                                                                                        // 103
      browsers: [browser],                                                                                            // 104
      plugins: [                                                                                                      // 105
        'karma-jasmine',                                                                                              // 106
        launcherPlugin,                                                                                               // 107
        'karma-coffee-preprocessor'                                                                                   // 108
      ],                                                                                                              // 109
      files: files,                                                                                                   // 110
      client: {                                                                                                       // 111
        args: [_.defaults({                                                                                           // 112
          // Make those values constant to avoid unnecessary Karma restarts                                           // 113
          autoupdateVersion: 'unknown',                                                                               // 114
          autoupdateVersionRefreshable: 'unknown',                                                                    // 115
          autoupdateVersionCordova: 'none'                                                                            // 116
                                                                                                                      // 117
        }, __meteor_runtime_config__)]                                                                                // 118
      },                                                                                                              // 119
      browserDisconnectTimeout: 10000,                                                                                // 120
      browserNoActivityTimeout: 15000,                                                                                // 121
                                                                                                                      // 122
      preprocessors: {                                                                                                // 123
        '**/*.{coffee,litcoffee,coffee.md}': ['coffee']                                                               // 124
      },                                                                                                              // 125
                                                                                                                      // 126
      coffeePreprocessor: {                                                                                           // 127
        options: {                                                                                                    // 128
          bare: true,                                                                                                 // 129
          sourceMap: true                                                                                             // 130
        },                                                                                                            // 131
        transformPath: function (path) {                                                                              // 132
          return path.replace(/\.(coffee|litcoffee|coffee\\.md)$/, '.js');                                            // 133
        }                                                                                                             // 134
      }                                                                                                               // 135
    })                                                                                                                // 136
    /* jshint camelcase: true */                                                                                      // 137
                                                                                                                      // 138
    if (this.userKarmaConfig.plugins) {                                                                               // 139
      startOptions.plugins = startOptions.plugins.concat(this.userKarmaConfig.plugins)                                // 140
    }                                                                                                                 // 141
                                                                                                                      // 142
    if (this.userKarmaConfig.preprocessors) {                                                                         // 143
      _.extend(startOptions.preprocessors, this.userKarmaConfig.preprocessors)                                        // 144
    }                                                                                                                 // 145
                                                                                                                      // 146
    return startOptions                                                                                               // 147
  },                                                                                                                  // 148
                                                                                                                      // 149
  _getPreAppFiles: function () {                                                                                      // 150
    return [                                                                                                          // 151
      this._getAssetPath('src/client/unit/assets/__meteor_runtime_config__.js')                                       // 152
    ]                                                                                                                 // 153
  },                                                                                                                  // 154
                                                                                                                      // 155
  _getPackageFiles: function () {                                                                                     // 156
    return _.chain(WebApp.clientPrograms['web.browser'].manifest)                                                     // 157
      .filter(function (file) {                                                                                       // 158
        return file.type === 'js' && file.path.indexOf('packages/') === 0                                             // 159
      })                                                                                                              // 160
      .filter(function (file) {                                                                                       // 161
        var ignoredFiles = [                                                                                          // 162
          'packages/sanjo_jasmine.js',                                                                                // 163
          'packages/velocity_core.js',                                                                                // 164
          'packages/velocity_test-proxy.js',                                                                          // 165
          'packages/velocity_html-reporter.js'                                                                        // 166
        ]                                                                                                             // 167
        return !_.contains(ignoredFiles, file.path)                                                                   // 168
      })                                                                                                              // 169
      .map(function (file) {                                                                                          // 170
        var mockedFiles = [                                                                                           // 171
          'packages/autoupdate.js',                                                                                   // 172
          'packages/reload.js',                                                                                       // 173
          'packages/meteorhacks_fast-render.js'                                                                       // 174
        ]                                                                                                             // 175
                                                                                                                      // 176
        if (_.contains(mockedFiles, file.path)) {                                                                     // 177
          return this._getAssetPath('src/client/unit/assets/mocks/' + file.path)                                      // 178
        } else {                                                                                                      // 179
          return {                                                                                                    // 180
            pattern: '.meteor/local/build/programs/web.browser/' + file.path,                                         // 181
            nocache: true                                                                                             // 182
          }                                                                                                           // 183
        }                                                                                                             // 184
      }, this)                                                                                                        // 185
      .value()                                                                                                        // 186
  },                                                                                                                  // 187
                                                                                                                      // 188
  _getCssFiles: function () {                                                                                         // 189
    return _.chain(WebApp.clientPrograms['web.browser'].manifest)                                                     // 190
      .filter(function (file) {                                                                                       // 191
        return file.type === 'css'                                                                                    // 192
      })                                                                                                              // 193
      .map(function (file) {                                                                                          // 194
        return {                                                                                                      // 195
          pattern: '.meteor/local/build/programs/web.browser/' + file.path,                                           // 196
          nocache: true                                                                                               // 197
        }                                                                                                             // 198
      })                                                                                                              // 199
      .value()                                                                                                        // 200
  },                                                                                                                  // 201
                                                                                                                      // 202
  _getAppFiles: function () {                                                                                         // 203
    return _.chain(WebApp.clientPrograms['web.browser'].manifest)                                                     // 204
      .filter(function (file) {                                                                                       // 205
        return file.type === 'js' && file.path.indexOf('packages/') !== 0                                             // 206
      })                                                                                                              // 207
      .map(function (file) {                                                                                          // 208
        return {                                                                                                      // 209
          pattern: '.meteor/local/build/programs/web.browser/' + file.path,                                           // 210
          nocache: true                                                                                               // 211
        }                                                                                                             // 212
      })                                                                                                              // 213
      .value()                                                                                                        // 214
  },                                                                                                                  // 215
                                                                                                                      // 216
  _getHelperFiles: function () {                                                                                      // 217
    return [                                                                                                          // 218
      this._getAssetPath('src/client/unit/assets/jasmine-jquery.js'),                                                 // 219
      this._getAssetPath('.npm/package/node_modules/component-mocker/index.js'),                                      // 220
      this._getAssetPath('src/lib/mock.js'),                                                                          // 221
      this._getAssetPath('src/lib/VelocityTestReporter.js'),                                                          // 222
      this._getAssetPath('src/client/unit/assets/adapter.js'),                                                        // 223
      '.meteor/local/build/programs/server/assets/packages/velocity_meteor-stubs/index.js',                           // 224
      this._getAssetPath('src/client/unit/assets/helpers/iron_router.js')                                             // 225
    ]                                                                                                                 // 226
  },                                                                                                                  // 227
                                                                                                                      // 228
  _getStubFiles: function () {                                                                                        // 229
    return [                                                                                                          // 230
      'tests/jasmine/client/unit/**/*-+(stub|stubs|mock|mocks).+(js|coffee|litcoffee|coffee.md)'                      // 231
    ]                                                                                                                 // 232
  },                                                                                                                  // 233
                                                                                                                      // 234
  _getTestFiles: function () {                                                                                        // 235
    // Use a match pattern directly.                                                                                  // 236
    // That allows Karma to detect changes and rerun the tests.                                                       // 237
    return [                                                                                                          // 238
      'tests/jasmine/client/unit/**/*.+(js|coffee|litcoffee|coffee.md)'                                               // 239
    ]                                                                                                                 // 240
  },                                                                                                                  // 241
                                                                                                                      // 242
  _getAssetPath: function (fileName) {                                                                                // 243
    var assetsPath = '.meteor/local/build/programs/server/assets/packages/sanjo_jasmine/'                             // 244
    return assetsPath + fileName;                                                                                     // 245
  }                                                                                                                   // 246
});                                                                                                                   // 247
                                                                                                                      // 248
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/client/integration/ClientIntegrationTestFramework.js                                    //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals ClientIntegrationTestFramework: true */                                                                    // 1
                                                                                                                      // 2
ClientIntegrationTestFramework = function (options) {                                                                 // 3
  options = options || {}                                                                                             // 4
                                                                                                                      // 5
  _.defaults(options, {                                                                                               // 6
    name: 'jasmine-client-integration',                                                                               // 7
    regex: '^tests/jasmine/client/integration/.+\\.(js|es6|jsx|coffee|litcoffee|coffee\\.md)$',                       // 8
    sampleTestGenerator: function () {                                                                                // 9
      return [                                                                                                        // 10
        {                                                                                                             // 11
          path: 'jasmine/client/integration/sample/spec/PlayerSpec.js',                                               // 12
          contents: Assets.getText('src/client/integration/sample-tests/sample/spec/PlayerSpec.js')                   // 13
        },                                                                                                            // 14
        {                                                                                                             // 15
          path: 'jasmine/client/integration/sample/spec/SpecMatchers.js',                                             // 16
          contents: Assets.getText('src/client/integration/sample-tests/sample/spec/SpecMatchers.js')                 // 17
        },                                                                                                            // 18
        {                                                                                                             // 19
          path: 'jasmine/client/integration/sample/src/Player.js',                                                    // 20
          contents: Assets.getText('src/client/integration/sample-tests/sample/src/Player.js')                        // 21
        },                                                                                                            // 22
        {                                                                                                             // 23
          path: 'jasmine/client/integration/sample/src/Song.js',                                                      // 24
          contents: Assets.getText('src/client/integration/sample-tests/sample/src/Song.js')                          // 25
        }                                                                                                             // 26
      ]                                                                                                               // 27
    },                                                                                                                // 28
    jasmineRequire: Meteor.isClient ? window.jasmineRequire : null                                                    // 29
  })                                                                                                                  // 30
                                                                                                                      // 31
  JasmineTestFramework.call(this, options)                                                                            // 32
                                                                                                                      // 33
  if (Meteor.isClient) {                                                                                              // 34
    this._setup()                                                                                                     // 35
  }                                                                                                                   // 36
}                                                                                                                     // 37
                                                                                                                      // 38
ClientIntegrationTestFramework.prototype = Object.create(JasmineTestFramework.prototype)                              // 39
                                                                                                                      // 40
_.extend(ClientIntegrationTestFramework.prototype, {                                                                  // 41
                                                                                                                      // 42
  _setup: function () {                                                                                               // 43
    this.jasmine = this.jasmineRequire.core(this.jasmineRequire)                                                      // 44
    this.jasmineInterface = new JasmineInterface({jasmine: this.jasmine})                                             // 45
    _.extend(window, this.jasmineInterface)                                                                           // 46
  },                                                                                                                  // 47
                                                                                                                      // 48
  startMirror: function () {                                                                                          // 49
    var mirrorStarter = new MirrorStarter(this.name)                                                                  // 50
    var mirrorOptions = {}                                                                                            // 51
                                                                                                                      // 52
    if (isTestPackagesMode()) {                                                                                       // 53
      mirrorStarter.startSelfMirror(mirrorOptions)                                                                    // 54
    } else {                                                                                                          // 55
      _.extend(mirrorOptions, {                                                                                       // 56
        port: this._getCustomPort(),                                                                                  // 57
        testsPath: 'jasmine/client/integration'                                                                       // 58
      })                                                                                                              // 59
                                                                                                                      // 60
      if (process.env.JASMINE_CLIENT_MIRROR_APP_PATH) {                                                               // 61
        mirrorOptions.args = [                                                                                        // 62
          '--test-app-path', process.env.JASMINE_CLIENT_MIRROR_APP_PATH                                               // 63
        ]                                                                                                             // 64
      }                                                                                                               // 65
                                                                                                                      // 66
      mirrorStarter.lazyStartMirror(mirrorOptions)                                                                    // 67
    }                                                                                                                 // 68
  },                                                                                                                  // 69
                                                                                                                      // 70
  _getCustomPort: function () {                                                                                       // 71
    var customPort = parseInt(process.env.JASMINE_MIRROR_PORT, 10)                                                    // 72
    if (!_.isNaN(customPort)) {                                                                                       // 73
      return customPort                                                                                               // 74
    }                                                                                                                 // 75
  },                                                                                                                  // 76
                                                                                                                      // 77
  shouldRunTests: function (mirrorInfo) {                                                                             // 78
    return mirrorInfo.isTestPackagesMode ||                                                                           // 79
           (mirrorInfo.isMirror && mirrorInfo.framework === this.name)                                                // 80
  },                                                                                                                  // 81
                                                                                                                      // 82
  runTests: function () {                                                                                             // 83
    var self = this                                                                                                   // 84
                                                                                                                      // 85
    Meteor.call('jasmine/environmentInfo', function(error, mirrorInfo) {                                              // 86
      if (error) {                                                                                                    // 87
        throw error                                                                                                   // 88
      } else if (self.shouldRunTests(mirrorInfo)) {                                                                   // 89
        Meteor.defer(function() {                                                                                     // 90
          log.info('Running Jasmine tests')                                                                           // 91
                                                                                                                      // 92
          var ddpConnection = mirrorInfo.isTestPackagesMode ?                                                         // 93
            Meteor :                                                                                                  // 94
            DDP.connect(mirrorInfo.parentUrl)                                                                         // 95
          window.initJasmineJquery()                                                                                  // 96
          self._executeClientTests(ddpConnection)                                                                     // 97
        })                                                                                                            // 98
      } else if (!mirrorInfo.isMirror && !self.inIframe()) {                                                          // 99
        self.createMirrorIframe()                                                                                     // 100
      }                                                                                                               // 101
    })                                                                                                                // 102
  },                                                                                                                  // 103
                                                                                                                      // 104
  inIframe: function() {                                                                                              // 105
    try {                                                                                                             // 106
      return window.self !== window.top;                                                                              // 107
    } catch (error) {                                                                                                 // 108
      return true;                                                                                                    // 109
    }                                                                                                                 // 110
  },                                                                                                                  // 111
                                                                                                                      // 112
  createMirrorIframe: function () {                                                                                   // 113
    var self = this                                                                                                   // 114
    var iframeId = 'jasmine-mirror'                                                                                   // 115
                                                                                                                      // 116
    var getMirrorUrl = function (mirrorInfo) {                                                                        // 117
      return mirrorInfo.rootUrl;                                                                                      // 118
    }                                                                                                                 // 119
                                                                                                                      // 120
    var insertMirrorIframe = _.once(function (mirrorInfo) {                                                           // 121
      var iframe = document.createElement('iframe')                                                                   // 122
      iframe.id = iframeId                                                                                            // 123
      iframe.src = getMirrorUrl(mirrorInfo);                                                                          // 124
      // Make the iFrame invisible                                                                                    // 125
      iframe.style.display = 'block'                                                                                  // 126
      iframe.style.position = 'absolute'                                                                              // 127
      iframe.style.width = 0                                                                                          // 128
      iframe.style.height = 0                                                                                         // 129
      iframe.style.border = 0                                                                                         // 130
      document.body.appendChild(iframe)                                                                               // 131
    })                                                                                                                // 132
                                                                                                                      // 133
    var updateMirrorIframe = function (mirrorInfo) {                                                                  // 134
      var iframe = document.getElementById(iframeId)                                                                  // 135
      if (iframe) {                                                                                                   // 136
        iframe.src = getMirrorUrl(mirrorInfo)                                                                         // 137
      } else {                                                                                                        // 138
        insertMirrorIframe(mirrorInfo)                                                                                // 139
      }                                                                                                               // 140
    }                                                                                                                 // 141
                                                                                                                      // 142
    Tracker.autorun(function () {                                                                                     // 143
      var mirror = VelocityMirrors.findOne(                                                                           // 144
        {framework: self.name, state: 'ready'},                                                                       // 145
        {fields: {state: 1, rootUrl: 1, lastModified: 1}}                                                             // 146
      )                                                                                                               // 147
      if (mirror) {                                                                                                   // 148
        updateMirrorIframe(mirror)                                                                                    // 149
      }                                                                                                               // 150
    })                                                                                                                // 151
  },                                                                                                                  // 152
                                                                                                                      // 153
  _executeClientTests: function (ddpConnection) {                                                                     // 154
    var self = this;                                                                                                  // 155
                                                                                                                      // 156
    window.ddpParentConnection = ddpConnection                                                                        // 157
                                                                                                                      // 158
    window.ddpParentConnection.call('velocity/reports/reset', {framework: self.name})                                 // 159
                                                                                                                      // 160
    /**                                                                                                               // 161
     * Since this is being run in a browser and the results should populate to an HTML page, require the HTML-specific Jasmine code, injecting the same reference.
     */                                                                                                               // 163
    self.jasmineRequire.html(self.jasmine)                                                                            // 164
                                                                                                                      // 165
    /**                                                                                                               // 166
     * Create the Jasmine environment. This is used to run all specs in a project.                                    // 167
     */                                                                                                               // 168
    var env = self.jasmine.getEnv()                                                                                   // 169
                                                                                                                      // 170
    /**                                                                                                               // 171
     * ## Runner Parameters                                                                                           // 172
     *                                                                                                                // 173
     * More browser specific code - wrap the query string in an object and to allow for getting/setting parameters from the runner user interface.
     */                                                                                                               // 175
                                                                                                                      // 176
    var queryString = new self.jasmine.QueryString({                                                                  // 177
      getWindowLocation: function () {                                                                                // 178
        return window.location                                                                                        // 179
      }                                                                                                               // 180
    })                                                                                                                // 181
                                                                                                                      // 182
    var catchingExceptions = queryString.getParam('catch')                                                            // 183
    env.catchExceptions(typeof catchingExceptions === 'undefined' ? true : catchingExceptions)                        // 184
                                                                                                                      // 185
    /**                                                                                                               // 186
     * ## Reporters                                                                                                   // 187
     */                                                                                                               // 188
    var velocityReporter = new VelocityTestReporter({                                                                 // 189
      mode: 'Client Integration',                                                                                     // 190
      framework: self.name,                                                                                           // 191
      env: env,                                                                                                       // 192
      timer: new self.jasmine.Timer(),                                                                                // 193
      ddpParentConnection: window.ddpParentConnection                                                                 // 194
    })                                                                                                                // 195
                                                                                                                      // 196
    /**                                                                                                               // 197
     * The `jsApiReporter` also receives spec results, and is used by any environment that needs to extract the results  from JavaScript.
     */                                                                                                               // 199
    env.addReporter(self.jasmineInterface.jsApiReporter)                                                              // 200
    env.addReporter(velocityReporter)                                                                                 // 201
                                                                                                                      // 202
    /**                                                                                                               // 203
     * Filter which specs will be run by matching the start of the full name against the `spec` query param.          // 204
     */                                                                                                               // 205
    var specFilter = new self.jasmine.HtmlSpecFilter({                                                                // 206
      filterString: function () {                                                                                     // 207
        return queryString.getParam('spec')                                                                           // 208
      }                                                                                                               // 209
    })                                                                                                                // 210
                                                                                                                      // 211
    env.specFilter = function (spec) {                                                                                // 212
      return specFilter.matches(spec.getFullName())                                                                   // 213
    }                                                                                                                 // 214
                                                                                                                      // 215
    /**                                                                                                               // 216
     * Setting up timing functions to be able to be overridden. Certain browsers (Safari, IE 8, phantomjs) require this hack.
     */                                                                                                               // 218
    window.setTimeout = window.setTimeout                                                                             // 219
    window.setInterval = window.setInterval                                                                           // 220
    window.clearTimeout = window.clearTimeout                                                                         // 221
    window.clearInterval = window.clearInterval                                                                       // 222
                                                                                                                      // 223
    env.execute()                                                                                                     // 224
  },                                                                                                                  // 225
                                                                                                                      // 226
  _reportResults: function () {                                                                                       // 227
    Meteor.call('velocity/reports/completed', {framework: this.name})                                                 // 228
  }                                                                                                                   // 229
})                                                                                                                    // 230
                                                                                                                      // 231
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/server/lib/get-files.js                                                                 //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals getSpecFiles: true */                                                                                      // 1
                                                                                                                      // 2
var fs = Npm.require('fs')                                                                                            // 3
                                                                                                                      // 4
function getFiles(dir, matcher) {                                                                                     // 5
  var allFiles = []                                                                                                   // 6
  var stat;                                                                                                           // 7
                                                                                                                      // 8
  try {                                                                                                               // 9
    stat = fs.statSync(dir)                                                                                           // 10
  } catch (error) {                                                                                                   // 11
    if (error.code !== 'ENOENT') {                                                                                    // 12
      console.error(error)                                                                                            // 13
    }                                                                                                                 // 14
    return allFiles;                                                                                                  // 15
  }                                                                                                                   // 16
                                                                                                                      // 17
  if (stat.isFile() && dir.match(matcher)) {                                                                          // 18
    allFiles.push(dir)                                                                                                // 19
  } else {                                                                                                            // 20
    var files = fs.readdirSync(dir)                                                                                   // 21
    for (var i = 0, len = files.length; i < len; ++i) {                                                               // 22
      var filename = dir + '/' + files[i]                                                                             // 23
      if (fs.statSync(filename).isFile() && filename.match(matcher)) {                                                // 24
        allFiles.push(filename)                                                                                       // 25
      } else if (fs.statSync(filename).isDirectory()) {                                                               // 26
        var subfiles = getFiles(filename, matcher)                                                                    // 27
        allFiles.push.apply(allFiles, subfiles)                                                                       // 28
      }                                                                                                               // 29
    }                                                                                                                 // 30
  }                                                                                                                   // 31
  return allFiles                                                                                                     // 32
}                                                                                                                     // 33
                                                                                                                      // 34
getSpecFiles = function (dir) {                                                                                       // 35
  return getFiles(dir, new RegExp('\\.(js|coffee|litcoffee|coffee\\.md)$'))                                           // 36
}                                                                                                                     // 37
                                                                                                                      // 38
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sanjo:jasmine/src/registerFrameworks.js                                                                   //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
/* globals frameworks: true */                                                                                        // 1
                                                                                                                      // 2
frameworks = {}                                                                                                       // 3
                                                                                                                      // 4
isMirror = function () {                                                                                              // 5
  return !!process.env.IS_MIRROR;                                                                                     // 6
}                                                                                                                     // 7
                                                                                                                      // 8
isMainApp = function () {                                                                                             // 9
  return !isMirror();                                                                                                 // 10
}                                                                                                                     // 11
                                                                                                                      // 12
isTestPackagesMode = function () {                                                                                    // 13
  return !!process.env.VELOCITY_TEST_PACKAGES;                                                                        // 14
}                                                                                                                     // 15
                                                                                                                      // 16
shouldRunFramework = function (frameworkName) {                                                                       // 17
  return process.env.FRAMEWORK === frameworkName || isTestPackagesMode();                                             // 18
}                                                                                                                     // 19
                                                                                                                      // 20
if (process.env.VELOCITY !== '0') {                                                                                   // 21
                                                                                                                      // 22
  // Server Integration                                                                                               // 23
  if (process.env.JASMINE_SERVER_INTEGRATION !== '0') {                                                               // 24
    frameworks.serverIntegration = new ServerIntegrationTestFramework()                                               // 25
                                                                                                                      // 26
    if (isMainApp()) {                                                                                                // 27
      frameworks.serverIntegration.registerWithVelocity()                                                             // 28
      if (!isTestPackagesMode()) {                                                                                    // 29
        Velocity.startup(function () {                                                                                // 30
          frameworks.serverIntegration.startMirror()                                                                  // 31
        })                                                                                                            // 32
      }                                                                                                               // 33
    }                                                                                                                 // 34
                                                                                                                      // 35
    if (shouldRunFramework('jasmine-server-integration')) {                                                           // 36
      Meteor.startup(function () {                                                                                    // 37
        // Queue our function after all other normal startup functions                                                // 38
        Meteor.startup(function () {                                                                                  // 39
          frameworks.serverIntegration.start()                                                                        // 40
        })                                                                                                            // 41
      })                                                                                                              // 42
    }                                                                                                                 // 43
  }                                                                                                                   // 44
                                                                                                                      // 45
                                                                                                                      // 46
  // Client Integration                                                                                               // 47
  if (process.env.JASMINE_CLIENT_INTEGRATION !== '0') {                                                               // 48
    frameworks.clientIntegration = new ClientIntegrationTestFramework()                                               // 49
                                                                                                                      // 50
    if (isMainApp()) {                                                                                                // 51
      frameworks.clientIntegration.registerWithVelocity()                                                             // 52
      Velocity.startup(function () {                                                                                  // 53
        // In test packages mode this does not really create a new mirror                                             // 54
        // It just registers the app as mirror.                                                                       // 55
        frameworks.clientIntegration.startMirror()                                                                    // 56
      })                                                                                                              // 57
    }                                                                                                                 // 58
  }                                                                                                                   // 59
                                                                                                                      // 60
                                                                                                                      // 61
  // Client Unit                                                                                                      // 62
  if (process.env.JASMINE_CLIENT_UNIT !== '0' && !isTestPackagesMode()) {                                             // 63
    frameworks.clientUnit = new ClientUnitTestFramework()                                                             // 64
                                                                                                                      // 65
    if (isMainApp()) {                                                                                                // 66
      frameworks.clientUnit.registerWithVelocity()                                                                    // 67
      Velocity.startup(function () {                                                                                  // 68
        frameworks.clientUnit.start()                                                                                 // 69
      })                                                                                                              // 70
    }                                                                                                                 // 71
  }                                                                                                                   // 72
                                                                                                                      // 73
                                                                                                                      // 74
  // Server Unit                                                                                                      // 75
  if (process.env.JASMINE_SERVER_UNIT !== '0' && !isTestPackagesMode()) {                                             // 76
    frameworks.serverUnit = new ServerUnitTestFramework()                                                             // 77
                                                                                                                      // 78
    if (isMainApp()) {                                                                                                // 79
      frameworks.serverUnit.registerWithVelocity()                                                                    // 80
      Velocity.startup(function () {                                                                                  // 81
        frameworks.serverUnit.start()                                                                                 // 82
      })                                                                                                              // 83
    }                                                                                                                 // 84
  }                                                                                                                   // 85
                                                                                                                      // 86
}                                                                                                                     // 87
                                                                                                                      // 88
Jasmine.setKarmaConfig = function (config) {                                                                          // 89
  if (frameworks.clientUnit && isMainApp()) {                                                                         // 90
    frameworks.clientUnit.setUserKarmaConfig(config)                                                                  // 91
  }                                                                                                                   // 92
}                                                                                                                     // 93
                                                                                                                      // 94
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['sanjo:jasmine'] = {
  Jasmine: Jasmine
};

})();

//# sourceMappingURL=sanjo_jasmine.js.map
