(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var _ = Package.underscore._;
var check = Package.check.check;
var Match = Package.check.Match;
var loglevel = Package['practicalmeteor:loglevel'].loglevel;

/* Package-scope variables */
var LongRunningChildProcess, log, findAppDir, __coffeescriptShare;

(function () {

///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                           //
// packages/sanjo:long-running-child-process/lib/log.js                                                      //
//                                                                                                           //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                             //
log = loglevel.createPackageLogger(                                                                          // 1
  '[sanjo:long-running-child-process]',                                                                      // 2
  process.env.LONG_RUNNING_CHILD_PROCESS_LOG_LEVEL || 'info'                                                 // 3
)                                                                                                            // 4
                                                                                                             // 5
///////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                           //
// packages/sanjo:long-running-child-process/lib/meteor/files.js                                             //
//                                                                                                           //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                             //
/**                                                                                                          // 1
 * Copied from Meteor tools/files.js.                                                                        // 2
 *                                                                                                           // 3
 * Includes:                                                                                                 // 4
 * - Helper to find the app root path                                                                        // 5
 */                                                                                                          // 6
                                                                                                             // 7
var path = Npm.require('path');                                                                              // 8
var fs = Npm.require('fs');                                                                                  // 9
                                                                                                             // 10
// given a predicate function and a starting path, traverse upwards                                          // 11
// from the path until we find a path that satisfies the predicate.                                          // 12
//                                                                                                           // 13
// returns either the path to the lowest level directory that passed                                         // 14
// the test or null for none found. if starting path isn't given, use                                        // 15
// cwd.                                                                                                      // 16
var findUpwards = function (predicate, startPath) {                                                          // 17
  var testDir = startPath || process.cwd();                                                                  // 18
  while (testDir) {                                                                                          // 19
    if (predicate(testDir)) {                                                                                // 20
      break;                                                                                                 // 21
    }                                                                                                        // 22
    var newDir = path.dirname(testDir);                                                                      // 23
    if (newDir === testDir) {                                                                                // 24
      testDir = null;                                                                                        // 25
    } else {                                                                                                 // 26
      testDir = newDir;                                                                                      // 27
    }                                                                                                        // 28
  }                                                                                                          // 29
  if (!testDir)                                                                                              // 30
    return null;                                                                                             // 31
                                                                                                             // 32
  return testDir;                                                                                            // 33
};                                                                                                           // 34
                                                                                                             // 35
// Determine if 'filepath' (a path, or omit for cwd) is within an app                                        // 36
// directory. If so, return the top-level app directory.                                                     // 37
findAppDir = function (filepath) {                                                                           // 38
  var isAppDir = function (filepath) {                                                                       // 39
    // XXX once we are done with the transition to engine, this should                                       // 40
    // change to: `return fs.existsSync(path.join(filepath, '.meteor',                                       // 41
    // 'release'))`                                                                                          // 42
                                                                                                             // 43
    // .meteor/packages can be a directory, if .meteor is a warehouse                                        // 44
    // directory.  since installing meteor initializes a warehouse at                                        // 45
    // $HOME/.meteor, we want to make sure your home directory (and all                                      // 46
    // subdirectories therein) don't count as being within a meteor app.                                     // 47
    try { // use try/catch to avoid the additional syscall to fs.existsSync                                  // 48
      return fs.statSync(path.join(filepath, '.meteor', 'packages')).isFile();                               // 49
    } catch (e) {                                                                                            // 50
      return false;                                                                                          // 51
    }                                                                                                        // 52
  };                                                                                                         // 53
                                                                                                             // 54
  return findUpwards(isAppDir, filepath);                                                                    // 55
};                                                                                                           // 56
                                                                                                             // 57
///////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                           //
// packages/sanjo:long-running-child-process/lib/LongRunningChildProcess.coffee.js                           //
//                                                                                                           //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                             //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
var assert, child_process, fs, path;

fs = Npm.require('fs-extra');

path = Npm.require('path');

assert = Npm.require('assert');

child_process = Npm.require('child_process');

if (this.sanjo == null) {
  this.sanjo = {};
}

sanjo.LongRunningChildProcess = (function() {
  LongRunningChildProcess.prototype.taskName = null;

  LongRunningChildProcess.prototype.child = null;

  LongRunningChildProcess.prototype.pid = null;

  LongRunningChildProcess.prototype.dead = false;

  function LongRunningChildProcess(taskName) {
    log.debug("LongRunningChildProcess.constructor(taskName=" + taskName + ")");
    this.taskName = taskName;
    this.pid = this.readPid();
  }

  LongRunningChildProcess.prototype.getTaskName = function() {
    return this.taskName;
  };

  LongRunningChildProcess.prototype.getChild = function() {
    return this.child;
  };

  LongRunningChildProcess.prototype.getPid = function() {
    return this.pid;
  };

  LongRunningChildProcess.prototype._setPid = function(pid) {
    log.debug("LongRunningChildProcess._setPid(pid=" + pid + ")");
    this.pid = pid;
    log.debug("Saving " + this.taskName + " pid " + pid + " to " + (this._getPidFilePath()));
    return fs.outputFile(this._getPidFilePath(), "" + pid);
  };

  LongRunningChildProcess.prototype.isDead = function() {
    return this.dead;
  };

  LongRunningChildProcess.prototype.isRunning = function() {
    var err, pid;
    log.debug('LongRunningChildProcess.isRunning()');
    pid = this.getPid();
    if (!pid) {
      log.debug("LongRunningChildProcess.isRunning returns false");
      return false;
    }
    try {
      process.kill(pid, 0);
      log.debug("LongRunningChildProcess.isRunning returns true");
      return true;
    } catch (_error) {
      err = _error;
      log.trace(err);
      log.debug("LongRunningChildProcess.isRunning returns false");
      return false;
    }
  };

  LongRunningChildProcess.prototype._getMeteorPid = function() {
    var parentPid, parentPidIndex;
    parentPid = null;
    parentPidIndex = _.indexOf(process.argv, '--parent-pid');
    if (parentPidIndex !== -1) {
      parentPid = process.argv[parentPidIndex + 1];
      log.debug("The pid of the main Meteor app process is " + parentPid);
    } else if (process.env.METEOR_PARENT_PID) {
      parentPid = process.env.METEOR_PARENT_PID;
      log.debug("The pid of the main Meteor app process is " + parentPid);
    } else {
      log.error('Could not find the pid of the main Meteor app process');
    }
    return parentPid;
  };

  LongRunningChildProcess.prototype._getMeteorAppPath = function() {
    if (!this.appPath) {
      this.appPath = path.resolve(findAppDir());
    }
    return this.appPath;
  };

  LongRunningChildProcess.prototype._getMeteorLocalPath = function() {
    return path.join(this._getMeteorAppPath(), '.meteor/local');
  };

  LongRunningChildProcess.prototype._getPidFilePath = function() {
    return path.join(this._getMeteorLocalPath(), "run/" + this.taskName + ".pid");
  };

  LongRunningChildProcess.prototype._getLogFilePath = function() {
    return path.join(this._getMeteorLocalPath(), "log/" + this.taskName + ".log");
  };

  LongRunningChildProcess.prototype._getSpawnScriptPath = function() {
    return path.join(this._getMeteorLocalPath(), 'build/programs/server/assets/packages/' + 'sanjo_long-running-child-process/lib/spawnScript.js');
  };

  LongRunningChildProcess.prototype.readPid = function() {
    var err, pid;
    log.debug('LongRunningChildProcess.readPid()');
    try {
      pid = parseInt(fs.readFileSync(this._getPidFilePath(), {
        encoding: 'utf8'
      }, 10));
      log.debug("LongRunningChildProcess.readPid returns " + pid);
      return pid;
    } catch (_error) {
      err = _error;
      log.debug('LongRunningChildProcess.readPid returns null');
      return null;
    }
  };

  LongRunningChildProcess.prototype.spawn = function(options) {
    var command, commandArgs, env, logFile, nodeDir, nodePath, spawnOptions, spawnScript, stdio;
    log.debug("LongRunningChildProcess.spawn()", options);
    check(options, Match.ObjectIncluding({
      command: String,
      args: [Match.Any],
      options: Match.Optional(Match.ObjectIncluding({
        cwd: Match.Optional(Match.OneOf(String, void 0)),
        env: Match.Optional(Object),
        stdio: Match.Optional(Match.OneOf(String, [Match.Any]))
      }))
    }));
    if (!options.options) {
      options.options = {};
    }
    if (this.isRunning()) {
      return false;
    }
    logFile = this._getLogFilePath();
    fs.ensureDirSync(path.dirname(logFile));
    if (options.options.stdio) {
      stdio = options.options.stdio;
    } else {
      this.fout = fs.openSync(logFile, 'w');
      stdio = ['ignore', this.fout, this.fout];
    }
    nodePath = process.execPath;
    nodeDir = path.dirname(nodePath);
    env = _.clone(options.options.env || process.env);
    env.PATH = nodeDir + ':' + (env.PATH || process.env.PATH);
    if (process.env.LONG_RUNNING_CHILD_PROCESS_LOG_LEVEL && !env.LONG_RUNNING_CHILD_PROCESS_LOG_LEVEL) {
      env.LONG_RUNNING_CHILD_PROCESS_LOG_LEVEL = process.env.LONG_RUNNING_CHILD_PROCESS_LOG_LEVEL;
    }
    spawnOptions = {
      cwd: options.options.cwd || this._getMeteorAppPath(),
      env: env,
      detached: true,
      stdio: stdio
    };
    command = path.basename(options.command);
    spawnScript = this._getSpawnScriptPath();
    commandArgs = [spawnScript, this._getMeteorPid(), this.taskName, options.command].concat(options.args);
    fs.chmodSync(spawnScript, 0x164);
    log.debug("LongRunningChildProcess.spawn is spawning '" + command + "'");
    this.child = child_process.spawn(nodePath, commandArgs, spawnOptions);
    this.dead = false;
    this._setPid(this.child.pid);
    this.child.on("exit", (function(_this) {
      return function(code) {
        log.debug("LongRunningChildProcess: child_process.on 'exit': command=" + command + " code=" + code);
        if (_this.fout) {
          return fs.closeSync(_this.fout);
        }
      };
    })(this));
    return true;
  };

  LongRunningChildProcess.prototype.kill = function(signal) {
    var err, pid;
    if (signal == null) {
      signal = "SIGINT";
    }
    log.debug("LongRunningChildProcess.kill(signal=" + signal + ")");
    if (!this.dead) {
      try {
        if (this.child != null) {
          this.child.kill(signal);
        } else {
          pid = this.getPid();
          process.kill(pid, signal);
        }
        this.dead = true;
        this.pid = null;
        return fs.removeSync(this._getPidFilePath());
      } catch (_error) {
        err = _error;
        return log.warn("Error: While killing process:\n", err);
      }
    }
  };

  return LongRunningChildProcess;

})();

if (process.env.IS_MIRROR === 'true') {
  sanjo.LongRunningChildProcess.fs = fs;
  sanjo.LongRunningChildProcess.path = path;
  sanjo.LongRunningChildProcess.assert = assert;
  sanjo.LongRunningChildProcess.child_process = child_process;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                           //
// packages/sanjo:long-running-child-process/main.js                                                         //
//                                                                                                           //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                             //
/* globals LongRunningChildProcess: true */                                                                  // 1
                                                                                                             // 2
LongRunningChildProcess = sanjo.LongRunningChildProcess                                                      // 3
                                                                                                             // 4
///////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['sanjo:long-running-child-process'] = {
  LongRunningChildProcess: LongRunningChildProcess
};

})();

//# sourceMappingURL=sanjo_long-running-child-process.js.map
