(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var WebApp = Package.webapp.WebApp;
var main = Package.webapp.main;
var WebAppInternals = Package.webapp.WebAppInternals;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var check = Package.check.check;
var Match = Package.check.Match;
var _ = Package.underscore._;
var chokidar = Package['velocity:chokidar'].chokidar;
var VelocityMeteorInternals = Package['velocity:meteor-internals'].VelocityMeteorInternals;
var SourceMapSupport = Package['velocity:source-map-support'].SourceMapSupport;
var LongRunningChildProcess = Package['sanjo:long-running-child-process'].LongRunningChildProcess;
var MeteorFilesHelpers = Package['sanjo:meteor-files-helpers'].MeteorFilesHelpers;

/* Package-scope variables */
var Velocity, VelocityTestFiles, VelocityFixtureFiles, VelocityTestReports, VelocityAggregateReports, VelocityLogs, VelocityMirrors, VelocityOptions, VelocityInternals, DEBUG, CONTINUOUS_INTEGRATION;

(function () {

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                               //
// packages/velocity:core/src/source_map_support.js                                                              //
//                                                                                                               //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                 //
SourceMapSupport.install();                                                                                      // 1
                                                                                                                 // 2
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                               //
// packages/velocity:core/src/polyfills.js                                                                       //
//                                                                                                               //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                 //
'use strict';                                                                                                    // 1
                                                                                                                 // 2
// PhantomJS 1.x does not support Function.bind.                                                                 // 3
// This is a very commonly used function and                                                                     // 4
// the resulting errors are very hard to debug right now.                                                        // 5
// For this reason we include it in velocity:core.                                                               // 6
if (!Function.prototype.bind) {                                                                                  // 7
  Function.prototype.bind = function(otherThis) {                                                                // 8
    return _.bind(this, otherThis);                                                                              // 9
  };                                                                                                             // 10
}                                                                                                                // 11
                                                                                                                 // 12
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                               //
// packages/velocity:core/src/globals.js                                                                         //
//                                                                                                               //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                 //
/* globals                                                                                                       // 1
   Velocity: true,                                                                                               // 2
   VelocityInternals: true                                                                                       // 3
*/                                                                                                               // 4
                                                                                                                 // 5
/**                                                                                                              // 6
 * The `Velocity` object provides a common API for test frameworks to report                                     // 7
 * test results.  Frameworks can also request assets, such as a copy of the                                      // 8
 * user's application (the 'mirror') in which tests can be safely run without                                    // 9
 * impacting on-going development.                                                                               // 10
 *                                                                                                               // 11
 * Test results and log activity are reported via                                                                // 12
 * {{#crossLink "Meteor.methods"}}Meteor methods{{/crossLink}}.                                                  // 13
 *                                                                                                               // 14
 * @class Velocity                                                                                               // 15
 */                                                                                                              // 16
Velocity = {};                                                                                                   // 17
                                                                                                                 // 18
VelocityInternals = {};                                                                                          // 19
                                                                                                                 // 20
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                               //
// packages/velocity:core/src/collections.js                                                                     //
//                                                                                                               //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                 //
/*jshint -W117 */                                                                                                // 1
/* global                                                                                                        // 2
 VelocityTestFiles: true,                                                                                        // 3
 VelocityFixtureFiles: true,                                                                                     // 4
 VelocityTestReports: true,                                                                                      // 5
 VelocityAggregateReports: true,                                                                                 // 6
 VelocityLogs: true,                                                                                             // 7
 VelocityMirrors: true,                                                                                          // 8
 VelocityOptions: true                                                                                           // 9
 */                                                                                                              // 10
                                                                                                                 // 11
/**                                                                                                              // 12
 * @class Collections                                                                                            // 13
 */                                                                                                              // 14
                                                                                                                 // 15
var collectionOptions = {};                                                                                      // 16
                                                                                                                 // 17
if (Meteor.isServer) {                                                                                           // 18
  var velocityMongoUrl = process.env.VELOCITY_MONGO_URL;                                                         // 19
  if (velocityMongoUrl) {                                                                                        // 20
    collectionOptions._driver = new MongoInternals.RemoteCollectionDriver(velocityMongoUrl);                     // 21
  }                                                                                                              // 22
}                                                                                                                // 23
                                                                                                                 // 24
/**                                                                                                              // 25
 * TODO: Needs description and example records                                                                   // 26
 *                                                                                                               // 27
 * @property VelocityTestFiles                                                                                   // 28
 * @type Mongo.Collection                                                                                        // 29
 */                                                                                                              // 30
VelocityTestFiles = new Mongo.Collection('velocityTestFiles', collectionOptions);                                // 31
/**                                                                                                              // 32
 * TODO: Needs description and example records                                                                   // 33
 *                                                                                                               // 34
 * @property VelocityFixtureFiles                                                                                // 35
 * @type Mongo.Collection                                                                                        // 36
 */                                                                                                              // 37
VelocityFixtureFiles = new Mongo.Collection('velocityFixtureFiles', collectionOptions);                          // 38
/**                                                                                                              // 39
 * TODO: Needs description and example records                                                                   // 40
 *                                                                                                               // 41
 * @property VelocityTestReports                                                                                 // 42
 * @type Mongo.Collection                                                                                        // 43
 */                                                                                                              // 44
VelocityTestReports = new Mongo.Collection('velocityTestReports', collectionOptions);                            // 45
/**                                                                                                              // 46
 * TODO: Needs description and example records                                                                   // 47
 *                                                                                                               // 48
 * @property VelocityAggregateReports                                                                            // 49
 * @type Mongo.Collection                                                                                        // 50
 */                                                                                                              // 51
VelocityAggregateReports = new Mongo.Collection('velocityAggregateReports', collectionOptions);                  // 52
/**                                                                                                              // 53
 * TODO: Needs description and example records                                                                   // 54
 *                                                                                                               // 55
 * @property VelocityLogs                                                                                        // 56
 * @type Mongo.Collection                                                                                        // 57
 */                                                                                                              // 58
VelocityLogs = new Mongo.Collection('velocityLogs', collectionOptions);                                          // 59
/**                                                                                                              // 60
 * TODO: Needs description and example records                                                                   // 61
 *                                                                                                               // 62
 * @property VelocityMirrors                                                                                     // 63
 * @type Mongo.Collection                                                                                        // 64
 */                                                                                                              // 65
VelocityMirrors = new Mongo.Collection('velocityMirrors', collectionOptions);                                    // 66
/**                                                                                                              // 67
 * TODO: Needs description and example records                                                                   // 68
 *                                                                                                               // 69
 * @property VelocityOptions                                                                                     // 70
 * @type Mongo.Collection                                                                                        // 71
 */                                                                                                              // 72
VelocityOptions = new Mongo.Collection('velocityOptions', collectionOptions);                                    // 73
                                                                                                                 // 74
                                                                                                                 // 75
(function () {                                                                                                   // 76
  'use strict';                                                                                                  // 77
                                                                                                                 // 78
  if (Meteor.isServer) {                                                                                         // 79
    Meteor.publish('VelocityTestFiles', function () {                                                            // 80
      return VelocityTestFiles.find({});                                                                         // 81
    });                                                                                                          // 82
    Meteor.publish('VelocityFixtureFiles', function () {                                                         // 83
      return VelocityFixtureFiles.find({});                                                                      // 84
    });                                                                                                          // 85
    Meteor.publish('VelocityTestReports', function () {                                                          // 86
      return VelocityTestReports.find({});                                                                       // 87
    });                                                                                                          // 88
    Meteor.publish('VelocityAggregateReports', function () {                                                     // 89
      return VelocityAggregateReports.find({});                                                                  // 90
    });                                                                                                          // 91
    Meteor.publish('VelocityLogs', function () {                                                                 // 92
      return VelocityLogs.find({});                                                                              // 93
    });                                                                                                          // 94
    Meteor.publish('VelocityMirrors', function () {                                                              // 95
      return VelocityMirrors.find({});                                                                           // 96
    });                                                                                                          // 97
    Meteor.publish('VelocityOptions', function () {                                                              // 98
      return VelocityOptions.find({});                                                                           // 99
    });                                                                                                          // 100
  }                                                                                                              // 101
                                                                                                                 // 102
  if (Meteor.isClient) {                                                                                         // 103
    Meteor.subscribe('VelocityTestFiles');                                                                       // 104
    Meteor.subscribe('VelocityFixtureFiles');                                                                    // 105
    Meteor.subscribe('VelocityTestReports');                                                                     // 106
    Meteor.subscribe('VelocityAggregateReports');                                                                // 107
    Meteor.subscribe('VelocityLogs');                                                                            // 108
    Meteor.subscribe('VelocityMirrors');                                                                         // 109
    Meteor.subscribe('VelocityOptions');                                                                         // 110
  }                                                                                                              // 111
})();                                                                                                            // 112
                                                                                                                 // 113
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                               //
// packages/velocity:core/src/helpers.js                                                                         //
//                                                                                                               //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                 //
/* globals VelocityInternals: true */                                                                            // 1
                                                                                                                 // 2
'use strict';                                                                                                    // 3
                                                                                                                 // 4
var files = VelocityMeteorInternals.files;                                                                       // 5
                                                                                                                 // 6
VelocityInternals.isWindows = function () {                                                                      // 7
  return process.platform === 'win32';                                                                           // 8
};                                                                                                               // 9
                                                                                                                 // 10
VelocityInternals.isDirectory = function (path) {                                                                // 11
  var stat = files.statOrNull(path);                                                                             // 12
  return stat && stat.isDirectory();                                                                             // 13
};                                                                                                               // 14
                                                                                                                 // 15
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                               //
// packages/velocity:core/src/core.js                                                                            //
//                                                                                                               //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                 //
/*jshint -W117, -W030, -W016, -W084 */                                                                           // 1
/* global                                                                                                        // 2
 DEBUG:true                                                                                                      // 3
 */                                                                                                              // 4
                                                                                                                 // 5
DEBUG = !!process.env.VELOCITY_DEBUG;                                                                            // 6
CONTINUOUS_INTEGRATION = process.env.VELOCITY_CI;                                                                // 7
                                                                                                                 // 8
/**                                                                                                              // 9
 * @module Velocity                                                                                              // 10
 * @class Velocity                                                                                               // 11
 */                                                                                                              // 12
(function () {                                                                                                   // 13
  'use strict';                                                                                                  // 14
                                                                                                                 // 15
//////////////////////////////////////////////////////////////////////                                           // 16
// Init                                                                                                          // 17
//                                                                                                               // 18
                                                                                                                 // 19
  DEBUG && console.log('[velocity] adding velocity core');                                                       // 20
  CONTINUOUS_INTEGRATION && console.log('[velocity] is in continuous integration mode');                         // 21
                                                                                                                 // 22
  var _ = Npm.require('lodash'),                                                                                 // 23
      files = VelocityMeteorInternals.files,                                                                     // 24
      fs = Npm.require('fs-extra'),                                                                              // 25
      mkdirp = Meteor.wrapAsync(fs.mkdirp, fs),                                                                  // 26
      _config = {},                                                                                              // 27
      _watcher,                                                                                                  // 28
      _velocityStarted = false,                                                                                  // 29
      _velocityStartupFunctions = [],                                                                            // 30
      FIXTURE_REG_EXP = new RegExp('-fixture.(js|coffee)$');                                                     // 31
                                                                                                                 // 32
                                                                                                                 // 33
  _removeTerminatedMirrors();                                                                                    // 34
                                                                                                                 // 35
  _setReusableMirrors();                                                                                         // 36
                                                                                                                 // 37
  if (process.env.NODE_ENV === 'development' &&                                                                  // 38
    process.env.VELOCITY !== '0' &&                                                                              // 39
    !process.env.IS_MIRROR                                                                                       // 40
  ) {                                                                                                            // 41
    Meteor.startup(function initializeVelocity () {                                                              // 42
      DEBUG && console.log('[velocity] Server startup');                                                         // 43
      DEBUG && console.log('[velocity] app dir', Velocity.getAppPath());                                         // 44
      DEBUG && console.log('[velocity] config =', JSON.stringify(_config, null, 2));                             // 45
                                                                                                                 // 46
      //kick-off everything                                                                                      // 47
      _resetAll();                                                                                               // 48
                                                                                                                 // 49
      _initFileWatcher(_config, _triggerVelocityStartupFunctions);                                               // 50
                                                                                                                 // 51
      _launchContinuousIntegration(_config);                                                                     // 52
                                                                                                                 // 53
    });                                                                                                          // 54
  }                                                                                                              // 55
                                                                                                                 // 56
//////////////////////////////////////////////////////////////////////                                           // 57
// Public Methods                                                                                                // 58
//                                                                                                               // 59
                                                                                                                 // 60
  _.extend(Velocity, {                                                                                           // 61
                                                                                                                 // 62
    /**                                                                                                          // 63
     * Run code when Velocity is started.                                                                        // 64
     *                                                                                                           // 65
     * Velocity is considered started when the file watcher has                                                  // 66
     * completed the scan of the file system.                                                                    // 67
     *                                                                                                           // 68
     * @method startup                                                                                           // 69
     * @return {function} A function to run on startup                                                           // 70
     */                                                                                                          // 71
    startup: function (func) {                                                                                   // 72
      if (_velocityStarted) {                                                                                    // 73
        DEBUG && console.log('[velocity] Velocity already started. Immediately calling func');                   // 74
        func();                                                                                                  // 75
      } else {                                                                                                   // 76
        DEBUG && console.log('[velocity] Velocity not started. Queueing func');                                  // 77
        _velocityStartupFunctions.push(func);                                                                    // 78
      }                                                                                                          // 79
    },                                                                                                           // 80
                                                                                                                 // 81
    /**                                                                                                          // 82
     * Get the application root path.                                                                            // 83
     *                                                                                                           // 84
     * @method getAppPath                                                                                        // 85
     * @return {String} app root path                                                                            // 86
     */                                                                                                          // 87
    getAppPath: function () {                                                                                    // 88
      var appPath = files.findAppDir();                                                                          // 89
      if (appPath) {                                                                                             // 90
        appPath = files.pathResolve(appPath);                                                                    // 91
      }                                                                                                          // 92
                                                                                                                 // 93
      return files.convertToOSPath(appPath);                                                                     // 94
    },                                                                                                           // 95
                                                                                                                 // 96
                                                                                                                 // 97
    /**                                                                                                          // 98
     * Get path to application's or application package's 'tests' directory                                      // 99
     *                                                                                                           // 100
     * @method getTestsPath                                                                                      // 101
     * @param {String} packageName optional package name                                                         // 102
     * @return {String} application's tests directory                                                            // 103
     */                                                                                                          // 104
    getTestsPath: function (packageName) {                                                                       // 105
      return files.convertToOSPath(                                                                              // 106
        files.pathJoin(packageName ? Velocity.getPackagePath(packageName) : Velocity.getAppPath(), 'tests')      // 107
      );                                                                                                         // 108
    },                                                                                                           // 109
                                                                                                                 // 110
    /**                                                                                                          // 111
     * Get path to application's 'packages' directory                                                            // 112
     *                                                                                                           // 113
     * @method getPackagesPath                                                                                   // 114
     * @return {String} application's packages directory                                                         // 115
     */                                                                                                          // 116
    getPackagesPath: function () {                                                                               // 117
      return files.convertToOSPath(files.pathJoin(Velocity.getAppPath(), 'packages'));                           // 118
    },                                                                                                           // 119
                                                                                                                 // 120
    /**                                                                                                          // 121
     * Get path to application's package directory                                                               // 122
     *                                                                                                           // 123
     * @method getPackagesPath                                                                                   // 124
     * @param {String} packageName package name                                                                  // 125
     * @return {String} application's packages directory                                                         // 126
     */                                                                                                          // 127
    getPackagePath: function (packageName) {                                                                     // 128
      return files.convertToOSPath(files.pathJoin(Velocity.getPackagesPath(), packageName));                     // 129
    },                                                                                                           // 130
                                                                                                                 // 131
                                                                                                                 // 132
    /**                                                                                                          // 133
     * A collection of callbacks to be executed after all tests have completed                                   // 134
     * and the aggregate test results have been reported.                                                        // 135
     *                                                                                                           // 136
     * See {{#crossLink 'Velocity/addPostProcessor:method'}}{{/crossLink}}                                       // 137
     *                                                                                                           // 138
     * @property postProcessors                                                                                  // 139
     * @type Array                                                                                               // 140
     * @default []                                                                                               // 141
     */                                                                                                          // 142
    postProcessors: [],                                                                                          // 143
                                                                                                                 // 144
    /**                                                                                                          // 145
     * Add a callback which will execute after all tests have completed                                          // 146
     * and after the aggregate test results have been reported.                                                  // 147
     *                                                                                                           // 148
     * @method addPostProcessor                                                                                  // 149
     * @param {Function} processor                                                                               // 150
     */                                                                                                          // 151
    addPostProcessor: function (processor) {                                                                     // 152
      Velocity.postProcessors.push(processor);                                                                   // 153
    },                                                                                                           // 154
                                                                                                                 // 155
    /**                                                                                                          // 156
     * Get a message that displays where bugs in Velocity core itself should                                     // 157
     * be reported.                                                                                              // 158
     *                                                                                                           // 159
     * @method getReportGithubIssueMessage                                                                       // 160
     * @return {String} message with bug repo url                                                                // 161
     */                                                                                                          // 162
    getReportGithubIssueMessage: function () {                                                                   // 163
      return 'Please report the issue here: ' +                                                                  // 164
        'https://github.com/meteor-velocity/velocity/issues';                                                    // 165
    },                                                                                                           // 166
                                                                                                                 // 167
    /**                                                                                                          // 168
     * Registers a testing framework plugin.                                                                     // 169
     *                                                                                                           // 170
     * @method registerTestingFramework                                                                          // 171
     * @param {String} name The name of the testing framework.                                                   // 172
     * @param {Object} [options] Options for the testing framework.                                              // 173
     *   @param {String} [options.regex] The regular expression for test files                                   // 174
     *                    that should be assigned to the testing framework.                                      // 175
     *                    The path relative to the tests folder is matched                                       // 176
     *                    against it. Default: 'name/.+\.js$' (name is                                           // 177
     *                    the testing framework name).                                                           // 178
     *   @param {String} [options.disableAutoReset]   Velocity's reset cycle                                     // 179
     *                    will skip reports and logs for this framework.                                         // 180
     *                    It is up to the framework to clean up its ****!                                        // 181
     *   @param {Function} [options.sampleTestGenerator] sampleTestGenerator                                     // 182
     *                    returns an array of fileObjects with the following                                     // 183
     *                    fields:                                                                                // 184
     *                      path - String - relative path to place test files                                    // 185
     *                                      (from PROJECT/tests)                                                 // 186
     *                      contents - String - contents to put in the test file                                 // 187
     *                                          at the corresponding path                                        // 188
     */                                                                                                          // 189
    registerTestingFramework: function (name, options) {                                                         // 190
      DEBUG && console.log('[velocity] Register framework ' + name + ' with regex ' + options.regex);            // 191
      _config[name] = _parseTestingFrameworkOptions(name, options);                                              // 192
      // make sure the appropriate aggregate records are added                                                   // 193
      VelocityAggregateReports.insert({                                                                          // 194
        name: name,                                                                                              // 195
        result: 'pending'                                                                                        // 196
      });                                                                                                        // 197
    },                                                                                                           // 198
                                                                                                                 // 199
    /**                                                                                                          // 200
     * Unregister a testing framework.  Mostly used for internal testing                                         // 201
     * of core Velocity functions.                                                                               // 202
     *                                                                                                           // 203
     * @method unregisterTestingFramework                                                                        // 204
     * @param {String} name Name of framework to unregister                                                      // 205
     */                                                                                                          // 206
    unregisterTestingFramework: function (name) {                                                                // 207
      VelocityTestReports.remove({framework: name});                                                             // 208
      VelocityLogs.remove({framework: name});                                                                    // 209
      VelocityAggregateReports.remove({name: name});                                                             // 210
      VelocityTestFiles.remove({targetFramework: name});                                                         // 211
                                                                                                                 // 212
      delete _config[name];                                                                                      // 213
    }                                                                                                            // 214
  });                                                                                                            // 215
                                                                                                                 // 216
                                                                                                                 // 217
//////////////////////////////////////////////////////////////////////                                           // 218
// Meteor Methods                                                                                                // 219
//                                                                                                               // 220
                                                                                                                 // 221
  /**                                                                                                            // 222
   * Most communication with Velocity core is done via the following                                             // 223
   * Meteor methods.                                                                                             // 224
   *                                                                                                             // 225
   * @class Meteor.methods                                                                                       // 226
   */                                                                                                            // 227
  Meteor.methods({                                                                                               // 228
                                                                                                                 // 229
    /**                                                                                                          // 230
     * Registers a testing framework plugin via a Meteor method.                                                 // 231
     *                                                                                                           // 232
     * @method velocity/register/framework                                                                       // 233
     * @param {String} name The name of the testing framework.                                                   // 234
     * @param {Object} [options] Options for the testing framework.                                              // 235
     *   @param {String} [options.regex] The regular expression for test files                                   // 236
     *                    that should be assigned to the testing framework.                                      // 237
     *                    The path relative to the tests folder is matched                                       // 238
     *                    against it. Default: 'name/.+\.js$' (name is                                           // 239
     *                    the testing framework name).                                                           // 240
     *   @param {String} [options.disableAutoReset]   Velocity's reset cycle                                     // 241
     *                    will skip reports and logs for this framework.                                         // 242
     *                    It is up to the framework to clean up its ****!                                        // 243
     *   @param {Function} [options.sampleTestGenerator] sampleTestGenerator                                     // 244
     *                    returns an array of fileObjects with the following                                     // 245
     *                    fields:                                                                                // 246
     *                      path - String - relative path to place test files                                    // 247
     *                                      (from PROJECT/tests)                                                 // 248
     *                      contents - String - contents to put in the test file                                 // 249
     *                                          at the corresponding path                                        // 250
     */                                                                                                          // 251
    'velocity/register/framework': function (name, options) {                                                    // 252
      options = options || {};                                                                                   // 253
      check(name, String);                                                                                       // 254
      check(options, {                                                                                           // 255
        disableAutoReset: Match.Optional(Boolean),                                                               // 256
        regex: Match.Optional(RegExp),                                                                           // 257
        sampleTestGenerator: Match.Optional(Function)                                                            // 258
      });                                                                                                        // 259
                                                                                                                 // 260
      _config[name] = _parseTestingFrameworkOptions(name, options);                                              // 261
                                                                                                                 // 262
      // make sure the appropriate aggregate records are added                                                   // 263
      _reset(name);                                                                                              // 264
    },                                                                                                           // 265
                                                                                                                 // 266
                                                                                                                 // 267
    /**                                                                                                          // 268
     * Clear all test reports, aggregate reports, and logs.                                                      // 269
     *                                                                                                           // 270
     * @method velocity/reset                                                                                    // 271
     */                                                                                                          // 272
    'velocity/reset': function (name) {                                                                          // 273
      check(name, String);                                                                                       // 274
      _reset(name);                                                                                              // 275
    },                                                                                                           // 276
                                                                                                                 // 277
                                                                                                                 // 278
    //////////////////////////////////////////////////////////////////////                                       // 279
    // Reports                                                                                                   // 280
    //                                                                                                           // 281
                                                                                                                 // 282
    /**                                                                                                          // 283
     * Record the results of an individual test run; a simple collector of                                       // 284
     * test data.                                                                                                // 285
     *                                                                                                           // 286
     * The `data` object is stored in its entirety; any field may be passed in.                                  // 287
     * The optional fields documented here are suggestions based on what the                                     // 288
     * standard html-reporter supports.  Whether or not a field is actually                                      // 289
     * used is up to the specific test reporter that the user has installed.                                     // 290
     *                                                                                                           // 291
     * @method velocity/reports/submit                                                                           // 292
     * @param {Object} data                                                                                      // 293
     *   @param {String} data.name Name of the test that was executed.                                           // 294
     *   @param {String} data.framework Name of a testing framework.                                             // 295
     *                                  For example, 'jasmine' or 'mocha'.                                       // 296
     *   @param {String} data.result The results of the test.  Standard values                                   // 297
     *                               are 'passed' and 'failed'.  Different test                                  // 298
     *                               reporters can support other values.  For                                    // 299
     *                               example, the aggregate tests collection uses                                // 300
     *                               'pending' to indicate that results are still                                // 301
     *                               coming in.                                                                  // 302
     *   @param {String} [data.id] Used to update a specific test result.  If not                                // 303
     *                             provided, frameworks can use the                                              // 304
     *                             `velocity/reports/reset` Meteor method to                                     // 305
     *                             clear all tests.                                                              // 306
     *   @param {Array} [data.ancestors] The hierarchy of suites and blocks above                                // 307
     *                                   this test. For example,                                                 // 308
     *                                ['Template', 'leaderboard', 'selected_name']                               // 309
     *   @param {Date} [data.timestamp] The time that the test started for this                                  // 310
     *                                  result.                                                                  // 311
     *   @param {Number} [data.duration] The test duration in milliseconds.                                      // 312
     *   @param {String} [data.browser] Which browser did the test run in?                                       // 313
     *   @param {String} [data.failureType] For example, 'expect' or 'assert'                                    // 314
     *   @param {String} [data.failureMessage]                                                                   // 315
     *   @param {String} [data.failureStackTrace] The stack trace associated with                                // 316
     *                                            the failure                                                    // 317
     */                                                                                                          // 318
    'velocity/reports/submit': function (data) {                                                                 // 319
      check(data, Match.ObjectIncluding({                                                                        // 320
        name: String,                                                                                            // 321
        framework: String,                                                                                       // 322
        result: String,                                                                                          // 323
        id: Match.Optional(String),                                                                              // 324
        ancestors: Match.Optional([String]),                                                                     // 325
        timestamp: Match.Optional(Match.OneOf(Date, String)),                                                    // 326
        duration: Match.Optional(Number),                                                                        // 327
        browser: Match.Optional(String),                                                                         // 328
        failureType: Match.Optional(Match.Any),                                                                  // 329
        failureMessage: Match.Optional(String),                                                                  // 330
        failureStackTrace: Match.Optional(Match.Any)                                                             // 331
      }));                                                                                                       // 332
                                                                                                                 // 333
      data.timestamp = data.timestamp ? new Date(data.timestamp) : new Date();                                   // 334
      data.id = data.id || Random.id();                                                                          // 335
                                                                                                                 // 336
      VelocityTestReports.upsert(data.id, {$set: data});                                                         // 337
                                                                                                                 // 338
      _updateAggregateReports();                                                                                 // 339
    },                                                                                                           // 340
                                                                                                                 // 341
                                                                                                                 // 342
    /**                                                                                                          // 343
     * Frameworks must call this method to inform Velocity they have completed                                   // 344
     * their current test runs. Velocity uses this flag when running in CI mode.                                 // 345
     *                                                                                                           // 346
     * @method velocity/reports/completed                                                                        // 347
     * @param {Object} data                                                                                      // 348
     *   @param {String} data.framework Name of a test framework.  Ex. 'jasmine'                                 // 349
     */                                                                                                          // 350
    'velocity/reports/completed': function (data) {                                                              // 351
      check(data, {                                                                                              // 352
        framework: String                                                                                        // 353
      });                                                                                                        // 354
                                                                                                                 // 355
      VelocityAggregateReports.upsert({'name': data.framework},                                                  // 356
        {$set: {'result': 'completed'}});                                                                        // 357
      _updateAggregateReports();                                                                                 // 358
    },                                                                                                           // 359
                                                                                                                 // 360
                                                                                                                 // 361
    /**                                                                                                          // 362
     * Clear test and aggregate reports, either for a specific framework or for                                  // 363
     * all frameworks.                                                                                           // 364
     *                                                                                                           // 365
     * @method velocity/reports/reset                                                                            // 366
     * @param {Object} [options]                                                                                 // 367
     *   @param {String} [options.framework] The name of a specific framework                                    // 368
     *                    to clear results for.  Ex. 'jasmine' or 'mocha'                                        // 369
     *   @param {Array} [options.notIn] A list of test Ids which should be kept                                  // 370
     *                                  (not cleared).  These Ids must match the                                 // 371
     *                                  ones passed to `velocity/reports/submit`.                                // 372
     */                                                                                                          // 373
    'velocity/reports/reset': function (options) {                                                               // 374
      var query = {};                                                                                            // 375
                                                                                                                 // 376
      options = options || {};                                                                                   // 377
      check(options, {                                                                                           // 378
        framework: Match.Optional(String),                                                                       // 379
        notIn: Match.Optional([String])                                                                          // 380
      });                                                                                                        // 381
                                                                                                                 // 382
      if (options.framework) {                                                                                   // 383
        query.framework = options.framework;                                                                     // 384
        VelocityAggregateReports.upsert({name: options.framework},                                               // 385
          {$set: {result: 'pending'}});                                                                          // 386
      }                                                                                                          // 387
                                                                                                                 // 388
      if (options.notIn) {                                                                                       // 389
        query = _.assign(query, {_id: {$nin: options.notIn}});                                                   // 390
      }                                                                                                          // 391
                                                                                                                 // 392
      VelocityTestReports.remove(query);                                                                         // 393
                                                                                                                 // 394
      _updateAggregateReports();                                                                                 // 395
    },                                                                                                           // 396
                                                                                                                 // 397
                                                                                                                 // 398
                                                                                                                 // 399
    //////////////////////////////////////////////////////////////////////                                       // 400
    // Logs                                                                                                      // 401
    //                                                                                                           // 402
                                                                                                                 // 403
    /**                                                                                                          // 404
     * Log a message to the Velocity log store.  This provides a central                                         // 405
     * location for different reporters to query for test framework log                                          // 406
     * entries.                                                                                                  // 407
     *                                                                                                           // 408
     * @method velocity/logs/submit                                                                              // 409
     * @param {Object} options                                                                                   // 410
     *   @param {String} options.framework The name of the test framework                                        // 411
     *   @param {String} options.message The message to log                                                      // 412
     *   @param {String} [options.level] Log level.  Ex. 'error'. Default: 'info'                                // 413
     *   @param {Date} [options.timestamp]                                                                       // 414
     */                                                                                                          // 415
    'velocity/logs/submit': function (options) {                                                                 // 416
      check(options, {                                                                                           // 417
        framework: String,                                                                                       // 418
        message: String,                                                                                         // 419
        level: Match.Optional(String),                                                                           // 420
        timestamp: Match.Optional(Match.OneOf(Date, String))                                                     // 421
      });                                                                                                        // 422
                                                                                                                 // 423
      VelocityLogs.insert({                                                                                      // 424
        framework: options.framework,                                                                            // 425
        message: options.message,                                                                                // 426
        level: options.level || 'info',                                                                          // 427
        timestamp: options.timestamp ? new Date(options.timestamp) : new Date()                                  // 428
      });                                                                                                        // 429
    },                                                                                                           // 430
                                                                                                                 // 431
    /**                                                                                                          // 432
     * Clear log entries, either for a specific framework or for                                                 // 433
     * all frameworks.                                                                                           // 434
     *                                                                                                           // 435
     * @method velocity/logs/reset                                                                               // 436
     * @param {Object} [options]                                                                                 // 437
     *   @param {String} [options.framework] The name of a specific framework                                    // 438
     *                                       to clear logs for.  Ex. 'mocha'                                     // 439
     */                                                                                                          // 440
    'velocity/logs/reset': function (options) {                                                                  // 441
      options = options || {};                                                                                   // 442
      check(options, {                                                                                           // 443
        framework: Match.Optional(String)                                                                        // 444
      });                                                                                                        // 445
                                                                                                                 // 446
      var query = {};                                                                                            // 447
      if (options.framework) {                                                                                   // 448
        query.framework = options.framework;                                                                     // 449
      }                                                                                                          // 450
      VelocityLogs.remove(query);                                                                                // 451
    },                                                                                                           // 452
                                                                                                                 // 453
                                                                                                                 // 454
                                                                                                                 // 455
                                                                                                                 // 456
    /**                                                                                                          // 457
     * Copy sample tests from frameworks `sample-tests` directories                                              // 458
     * to the user's application's `tests` directory.                                                            // 459
     *                                                                                                           // 460
     * @method velocity/copySampleTests                                                                          // 461
     *                                                                                                           // 462
     * @param {Object} options                                                                                   // 463
     *   @param {String} options.framework Framework name. Ex. 'jasmine', 'mocha'                                // 464
     */                                                                                                          // 465
    'velocity/copySampleTests': function (options) {                                                             // 466
      var sampleTestGenerator,                                                                                   // 467
          sampleTests;                                                                                           // 468
                                                                                                                 // 469
      options = options || {};                                                                                   // 470
      check(options, {                                                                                           // 471
        framework: String                                                                                        // 472
      });                                                                                                        // 473
                                                                                                                 // 474
      this.unblock();                                                                                            // 475
                                                                                                                 // 476
      sampleTestGenerator = _config[options.framework].sampleTestGenerator;                                      // 477
      if (sampleTestGenerator) {                                                                                 // 478
        sampleTests = sampleTestGenerator(options);                                                              // 479
                                                                                                                 // 480
        DEBUG && console.log('[velocity] found ', sampleTests.length,                                            // 481
          'sample test files for', options.framework);                                                           // 482
                                                                                                                 // 483
        sampleTests.forEach(function (testFile) {                                                                // 484
          var fullTestPath = files.pathJoin(Velocity.getTestsPath(), testFile.path),                             // 485
              testDir = files.pathDirname(fullTestPath);                                                         // 486
                                                                                                                 // 487
          mkdirp(files.convertToOSPath(testDir));                                                                // 488
          files.writeFile(fullTestPath, testFile.contents);                                                      // 489
        });                                                                                                      // 490
      }                                                                                                          // 491
    },  // end copySampleTests                                                                                   // 492
                                                                                                                 // 493
    /**                                                                                                          // 494
     * Finds a test file with TODO status                                                                        // 495
     * changes the status to 'DOING', and returns it                                                             // 496
     *                                                                                                           // 497
     * @method velocity/returnTODOTestAndMarkItAsDOING                                                           // 498
     *                                                                                                           // 499
     * @param {Object} options                                                                                   // 500
     *   @param {String} options.framework Framework name. Ex. 'jasmine', 'mocha'                                // 501
     */                                                                                                          // 502
    'velocity/returnTODOTestAndMarkItAsDOING': function(options) {                                               // 503
      check(options, {                                                                                           // 504
        framework: String                                                                                        // 505
      });                                                                                                        // 506
                                                                                                                 // 507
      var _query = {                                                                                             // 508
        targetFramework: options.framework,                                                                      // 509
        status: 'TODO'                                                                                           // 510
      };                                                                                                         // 511
                                                                                                                 // 512
      var _update = {                                                                                            // 513
        $set: {status: 'DOING'}                                                                                  // 514
      };                                                                                                         // 515
                                                                                                                 // 516
                                                                                                                 // 517
      var collectionObj = VelocityTestFiles.rawCollection();                                                     // 518
      var wrappedFunc = Meteor.wrapAsync(collectionObj.findAndModify,                                            // 519
        collectionObj);                                                                                          // 520
      var _TODOtest = wrappedFunc(_query, {}, _update, {});                                                      // 521
                                                                                                                 // 522
      return _TODOtest;                                                                                          // 523
    },                                                                                                           // 524
                                                                                                                 // 525
    /**                                                                                                          // 526
     * Marks test file as DONE                                                                                   // 527
     *                                                                                                           // 528
     * @method velocity/featureTestDone                                                                          // 529
     *                                                                                                           // 530
     * @param {Object} options                                                                                   // 531
     *   @param {String} options.featureId id of test                                                            // 532
     */                                                                                                          // 533
    'velocity/featureTestDone': function (options) {                                                             // 534
      check(options, {                                                                                           // 535
        featureId: String                                                                                        // 536
      });                                                                                                        // 537
                                                                                                                 // 538
      VelocityTestFiles.update({                                                                                 // 539
        _id: options.featureId                                                                                   // 540
      }, {                                                                                                       // 541
        $set: {status: 'DONE'}                                                                                   // 542
      });                                                                                                        // 543
                                                                                                                 // 544
    },                                                                                                           // 545
                                                                                                                 // 546
    /**                                                                                                          // 547
     * Marks test file as TODO                                                                                   // 548
     *                                                                                                           // 549
     * @method velocity/featureTestFailed                                                                        // 550
     *                                                                                                           // 551
     * @param {Object} options                                                                                   // 552
     *   @param {String} options.featureId id of test                                                            // 553
     */                                                                                                          // 554
    'velocity/featureTestFailed': function (options) {                                                           // 555
      check(options, {                                                                                           // 556
        featureId: String                                                                                        // 557
      });                                                                                                        // 558
                                                                                                                 // 559
      VelocityTestFiles.update({                                                                                 // 560
        _id: options.featureId                                                                                   // 561
      }, {                                                                                                       // 562
        $set: {                                                                                                  // 563
          status: 'TODO',                                                                                        // 564
          brokenPreviously: true                                                                                 // 565
        }                                                                                                        // 566
      });                                                                                                        // 567
                                                                                                                 // 568
    }                                                                                                            // 569
                                                                                                                 // 570
  });  // end Meteor methods                                                                                     // 571
                                                                                                                 // 572
                                                                                                                 // 573
                                                                                                                 // 574
                                                                                                                 // 575
//////////////////////////////////////////////////////////////////////                                           // 576
// Private functions                                                                                             // 577
//                                                                                                               // 578
                                                                                                                 // 579
  function _triggerVelocityStartupFunctions () {                                                                 // 580
    _velocityStarted = true;                                                                                     // 581
    DEBUG && console.log('[velocity] Triggering queued startup functions');                                      // 582
    var func;                                                                                                    // 583
    while (func = _velocityStartupFunctions.pop()) {                                                             // 584
      func();                                                                                                    // 585
    }                                                                                                            // 586
  }                                                                                                              // 587
                                                                                                                 // 588
  function _parseTestingFrameworkOptions (name, options) {                                                       // 589
    options = options || {};                                                                                     // 590
    _.defaults(options, {                                                                                        // 591
      name: name,                                                                                                // 592
      regex: name + '/.+\\.js$'                                                                                  // 593
    });                                                                                                          // 594
                                                                                                                 // 595
    options._regexp = new RegExp(options.regex);                                                                 // 596
                                                                                                                 // 597
    return options;                                                                                              // 598
  }                                                                                                              // 599
                                                                                                                 // 600
                                                                                                                 // 601
  // Runs each test framework once when in continous integration mode.                                           // 602
  function _launchContinuousIntegration () {                                                                     // 603
                                                                                                                 // 604
    if (CONTINUOUS_INTEGRATION) {                                                                                // 605
      _.forEach(_getTestFrameworkNames(), function (testFramework) {                                             // 606
        Meteor.call('velocity/logs/reset', {framework: testFramework}, function () {                             // 607
                                                                                                                 // 608
          Meteor.call(testFramework + '/reset', function () {});                                                 // 609
          Meteor.call(testFramework + '/run', function () {});                                                   // 610
        });                                                                                                      // 611
      });                                                                                                        // 612
    }                                                                                                            // 613
  }                                                                                                              // 614
                                                                                                                 // 615
  /**                                                                                                            // 616
   * Initialize the directory/file watcher.                                                                      // 617
   *                                                                                                             // 618
   * @method _initFileWatcher                                                                                    // 619
   * @param {Object} config See {{#crossLink 'Velocity/registerTestingFramework:method'}}{{/crossLink}}          // 620
   * @param {function} callback  Called after the watcher completes its first scan and is ready                  // 621
   * @private                                                                                                    // 622
   */                                                                                                            // 623
  function _initFileWatcher (config, callback) {                                                                 // 624
    var paths,                                                                                                   // 625
        packagesPath;                                                                                            // 626
                                                                                                                 // 627
    VelocityTestFiles.remove({});                                                                                // 628
    VelocityFixtureFiles.remove({});                                                                             // 629
                                                                                                                 // 630
    paths = [Velocity.getTestsPath()];                                                                           // 631
    packagesPath = Velocity.getPackagesPath();                                                                   // 632
                                                                                                                 // 633
    if (VelocityInternals.isDirectory(packagesPath)) {                                                           // 634
      var packageNames = files.readdir(packagesPath),                                                            // 635
          packageTestsPaths = _.chain(packageNames)                                                              // 636
            .filter(_isPackageWithTests)                                                                         // 637
            .map(Velocity.getTestsPath)                                                                          // 638
            .value();                                                                                            // 639
      paths.push.apply(paths, packageTestsPaths);                                                                // 640
    }                                                                                                            // 641
                                                                                                                 // 642
    paths = _.map(paths, files.convertToOSPath);                                                                 // 643
                                                                                                                 // 644
    DEBUG && console.log('[velocity] Add paths to watcher', paths);                                              // 645
                                                                                                                 // 646
    _watcher = chokidar.watch(paths, {                                                                           // 647
      ignored: /[\/\\](\.|node_modules)/,                                                                        // 648
      persistent: true                                                                                           // 649
    });                                                                                                          // 650
    _watcher.on('add', Meteor.bindEnvironment(function (filePath) {                                              // 651
      var relativePath,                                                                                          // 652
          packageRelativePath,                                                                                   // 653
          targetFramework,                                                                                       // 654
          data;                                                                                                  // 655
                                                                                                                 // 656
      filePath = files.convertToStandardPath(files.pathNormalize(filePath));                                     // 657
      relativePath = _getRelativePath(filePath);                                                                 // 658
                                                                                                                 // 659
      // if this is a fixture file, put it in the fixtures collection                                            // 660
      if (FIXTURE_REG_EXP.test(relativePath)) {                                                                  // 661
        DEBUG && console.log('[velocity] Found fixture file', relativePath);                                     // 662
        VelocityFixtureFiles.insert({                                                                            // 663
          _id: filePath,                                                                                         // 664
          absolutePath: filePath,                                                                                // 665
          relativePath: relativePath,                                                                            // 666
          lastModified: Date.now()                                                                               // 667
        });                                                                                                      // 668
        // bail early                                                                                            // 669
        return;                                                                                                  // 670
      }                                                                                                          // 671
                                                                                                                 // 672
      DEBUG && console.log('[velocity] Search framework for path', relativePath);                                // 673
                                                                                                                 // 674
      packageRelativePath = (relativePath.indexOf('packages') === 0) ?                                           // 675
        relativePath.split('/').slice(2).join('/') :                                                             // 676
        relativePath;                                                                                            // 677
                                                                                                                 // 678
      // test against each test framework's regexp matcher, use first one that matches                           // 679
      targetFramework = _.find(config, function (framework) {                                                    // 680
        return framework._regexp.test(packageRelativePath);                                                      // 681
      });                                                                                                        // 682
                                                                                                                 // 683
      if (targetFramework) {                                                                                     // 684
        DEBUG && console.log('[velocity] Target framework for', relativePath, 'is', targetFramework.name);       // 685
                                                                                                                 // 686
        data = {                                                                                                 // 687
          _id: filePath,                                                                                         // 688
          name: files.pathBasename(filePath),                                                                    // 689
          absolutePath: filePath,                                                                                // 690
          relativePath: relativePath,                                                                            // 691
          targetFramework: targetFramework.name,                                                                 // 692
          lastModified: Date.now()                                                                               // 693
        };                                                                                                       // 694
                                                                                                                 // 695
        VelocityTestFiles.insert(data);                                                                          // 696
      } else {                                                                                                   // 697
        DEBUG && console.log('[velocity] No framework registered for', relativePath);                            // 698
      }                                                                                                          // 699
    }));  // end watcher.on 'add'                                                                                // 700
                                                                                                                 // 701
    _watcher.on('change', Meteor.bindEnvironment(function (filePath) {                                           // 702
      DEBUG && console.log('[velocity] File changed:', _getRelativePath(filePath));                              // 703
                                                                                                                 // 704
      // Since we key on filePath and we only add files we're interested in,                                     // 705
      // we don't have to worry about inadvertently updating records for files                                   // 706
      // we don't care about.                                                                                    // 707
      filePath = files.convertToStandardPath(files.pathNormalize(filePath));                                     // 708
      VelocityTestFiles.update(filePath, {$set: {lastModified: Date.now()}});                                    // 709
    }));                                                                                                         // 710
                                                                                                                 // 711
    _watcher.on('unlink', Meteor.bindEnvironment(function (filePath) {                                           // 712
      filePath = files.convertToStandardPath(files.pathNormalize(filePath));                                     // 713
      DEBUG && console.log('[velocity] File removed:',                                                           // 714
        _getRelativePath(filePath));                                                                             // 715
                                                                                                                 // 716
      VelocityTestFiles.remove(filePath);                                                                        // 717
    }));                                                                                                         // 718
                                                                                                                 // 719
    _watcher.on('ready', Meteor.bindEnvironment(function () {                                                    // 720
      DEBUG && console.log('[velocity] File scan complete, now watching',                                        // 721
        Velocity.getTestsPath().substring(Velocity.getAppPath().length));                                        // 722
                                                                                                                 // 723
      callback && callback();                                                                                    // 724
    }));                                                                                                         // 725
                                                                                                                 // 726
  }  // end _initFileWatcher                                                                                     // 727
                                                                                                                 // 728
                                                                                                                 // 729
  function _isPackageWithTests(packageName) {                                                                    // 730
    return packageName !== 'tests-proxy' &&                                                                      // 731
      VelocityInternals.isDirectory(Velocity.getTestsPath(packageName));                                         // 732
  }                                                                                                              // 733
                                                                                                                 // 734
                                                                                                                 // 735
  /**                                                                                                            // 736
   * Clear test reports, aggregate reports, and logs for a specific framework.                                   // 737
   *                                                                                                             // 738
   * @method _reset                                                                                              // 739
   * @param {String} name Framework to reset                                                                     // 740
   * @private                                                                                                    // 741
   */                                                                                                            // 742
  function _reset (name) {                                                                                       // 743
    DEBUG && console.log('[velocity] resetting', name);                                                          // 744
                                                                                                                 // 745
    VelocityLogs.remove({framework: name});                                                                      // 746
    VelocityTestReports.remove({framework: name});                                                               // 747
    VelocityAggregateReports.remove({name: name});                                                               // 748
                                                                                                                 // 749
    VelocityAggregateReports.insert({                                                                            // 750
      name: name,                                                                                                // 751
      result: 'pending'                                                                                          // 752
    });                                                                                                          // 753
  }                                                                                                              // 754
                                                                                                                 // 755
  /**                                                                                                            // 756
   * Clear all test reports, aggregate reports, and logs.                                                        // 757
   *                                                                                                             // 758
   * @method _reset                                                                                              // 759
   * @param {Object} config See {{#crossLink 'Velocity/registerTestingFramework:method'}}{{/crossLink}}          // 760
   * @private                                                                                                    // 761
   */                                                                                                            // 762
  function _resetAll () {                                                                                        // 763
    var allFrameworks,                                                                                           // 764
        frameworksToIgnore;                                                                                      // 765
                                                                                                                 // 766
    DEBUG && console.log('[velocity] resetting the world');                                                      // 767
                                                                                                                 // 768
    allFrameworks = _getTestFrameworkNames();                                                                    // 769
                                                                                                                 // 770
    // ignore frameworks that have opted-out                                                                     // 771
    frameworksToIgnore = _(_config)                                                                              // 772
      .where({disableAutoReset: true})                                                                           // 773
      .pluck('name')                                                                                             // 774
      .value();                                                                                                  // 775
                                                                                                                 // 776
    DEBUG && console.log('[velocity] frameworks with disable auto reset:',                                       // 777
      frameworksToIgnore);                                                                                       // 778
                                                                                                                 // 779
    VelocityAggregateReports.remove({});                                                                         // 780
    VelocityLogs.remove({framework: {$nin: frameworksToIgnore}});                                                // 781
    VelocityTestReports.remove({framework: {$nin: frameworksToIgnore}});                                         // 782
                                                                                                                 // 783
    _.forEach(allFrameworks, function (testFramework) {                                                          // 784
      VelocityAggregateReports.insert({                                                                          // 785
        name: testFramework,                                                                                     // 786
        result: 'pending'                                                                                        // 787
      });                                                                                                        // 788
    });                                                                                                          // 789
  }                                                                                                              // 790
                                                                                                                 // 791
                                                                                                                 // 792
  /**                                                                                                            // 793
   * If any one test has failed, mark the aggregate test result as failed.                                       // 794
   *                                                                                                             // 795
   * @method _updateAggregateReports                                                                             // 796
   * @private                                                                                                    // 797
   */                                                                                                            // 798
  function _updateAggregateReports () {                                                                          // 799
    var aggregateResult,                                                                                         // 800
        completedFrameworksCount,                                                                                // 801
        allFrameworks = _getTestFrameworkNames();                                                                // 802
                                                                                                                 // 803
    VelocityAggregateReports.upsert({name: 'aggregateResult'},                                                   // 804
      {$set: {result: 'pending'}});                                                                              // 805
    VelocityAggregateReports.upsert({name: 'aggregateComplete'},                                                 // 806
      {$set: {result: 'pending'}});                                                                              // 807
                                                                                                                 // 808
    // if all of our test reports have valid results                                                             // 809
    if (!VelocityTestReports.findOne({result: ''})) {                                                            // 810
                                                                                                                 // 811
      // pessimistically set passed state, ensuring all other states                                             // 812
      // take precedence in order below                                                                          // 813
      aggregateResult =                                                                                          // 814
        VelocityTestReports.findOne({result: 'failed'}) ||                                                       // 815
        VelocityTestReports.findOne({result: 'undefined'}) ||                                                    // 816
        VelocityTestReports.findOne({result: 'skipped'}) ||                                                      // 817
        VelocityTestReports.findOne({result: 'pending'}) ||                                                      // 818
        VelocityTestReports.findOne({result: 'passed'}) ||                                                       // 819
        {result: 'pending'};                                                                                     // 820
                                                                                                                 // 821
      // update the global status                                                                                // 822
      VelocityAggregateReports.update({name: 'aggregateResult'},                                                 // 823
        {$set: {result: aggregateResult.result}});                                                               // 824
    }                                                                                                            // 825
                                                                                                                 // 826
                                                                                                                 // 827
    // Check if all test frameworks have completed successfully                                                  // 828
    completedFrameworksCount = VelocityAggregateReports.find({                                                   // 829
      name: {$in: allFrameworks},                                                                                // 830
      result: 'completed'                                                                                        // 831
    }).count();                                                                                                  // 832
                                                                                                                 // 833
    if (allFrameworks.length === completedFrameworksCount) {                                                     // 834
      VelocityAggregateReports.update({name: 'aggregateComplete'},                                               // 835
        {$set: {'result': 'completed'}});                                                                        // 836
      _.each(Velocity.postProcessors, function (processor) {                                                     // 837
        processor();                                                                                             // 838
      });                                                                                                        // 839
    }                                                                                                            // 840
  }                                                                                                              // 841
                                                                                                                 // 842
  function _getRelativePath (filePath) {                                                                         // 843
    var relativePath = filePath.substring(Velocity.getAppPath().length);                                         // 844
                                                                                                                 // 845
    if (relativePath[0] === '/') {                                                                               // 846
      relativePath = relativePath.substring(1);                                                                  // 847
    }                                                                                                            // 848
    return relativePath;                                                                                         // 849
  }                                                                                                              // 850
                                                                                                                 // 851
  function _getTestFrameworkNames () {                                                                           // 852
    return _.pluck(_config, 'name');                                                                             // 853
  }                                                                                                              // 854
                                                                                                                 // 855
  function _removeTerminatedMirrors() {                                                                          // 856
    // Remove terminated mirrors from previous runs                                                              // 857
    // This is needed for `meteor --test` to work properly                                                       // 858
    VelocityMirrors.find({}).forEach(function(mirror) {                                                          // 859
      try {                                                                                                      // 860
        process.kill(mirror.pid, 0);                                                                             // 861
      } catch (error) {                                                                                          // 862
        VelocityMirrors.remove({pid: mirror.pid});                                                               // 863
      }                                                                                                          // 864
    });                                                                                                          // 865
  }                                                                                                              // 866
                                                                                                                 // 867
  function _setReusableMirrors() {                                                                               // 868
    Velocity.reusableMirrors = [];                                                                               // 869
    VelocityMirrors.find({}).forEach(function(mirror) {                                                          // 870
      mirror.reused = false;                                                                                     // 871
      Velocity.reusableMirrors.push(mirror);                                                                     // 872
    });                                                                                                          // 873
  }                                                                                                              // 874
                                                                                                                 // 875
})();                                                                                                            // 876
                                                                                                                 // 877
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                               //
// packages/velocity:core/src/core-shared.js                                                                     //
//                                                                                                               //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                 //
/*jshint -W117 */                                                                                                // 1
                                                                                                                 // 2
(function () {                                                                                                   // 3
  'use strict';                                                                                                  // 4
                                                                                                                 // 5
  //////////////////////////////////////////////////////////////////////                                         // 6
  // Public Methods                                                                                              // 7
  //                                                                                                             // 8
                                                                                                                 // 9
  /**                                                                                                            // 10
   * Mirrors can share the same codebase as the main process.                                                    // 11
   * This method will run provided code inside a mirror only.                                                    // 12
   *                                                                                                             // 13
   * where: client / server                                                                                      // 14
   *                                                                                                             // 15
   * @method onTest                                                                                              // 16
   * @for Velocity                                                                                               // 17
   * @param {Function} code                                                                                      // 18
   */                                                                                                            // 19
  Velocity.onTest = function (code) {                                                                            // 20
    Meteor.call('velocity/isMirror', function (err, res) {                                                       // 21
      if (res) {                                                                                                 // 22
        code();                                                                                                  // 23
      }                                                                                                          // 24
    });                                                                                                          // 25
  };                                                                                                             // 26
                                                                                                                 // 27
  if (Meteor.isServer) {                                                                                         // 28
    /**                                                                                                          // 29
     * See <a href="Meteor.methods.html#method_velocity/setOption">velocity/setOption</a>                        // 30
     *                                                                                                           // 31
     * @method setOption                                                                                         // 32
     */                                                                                                          // 33
    Velocity.setOption = function (name, value) {                                                                // 34
      Meteor.call('velocity/setOption', name, value);                                                            // 35
    };                                                                                                           // 36
                                                                                                                 // 37
    /**                                                                                                          // 38
     * See <a href="Meteor.methods.html#method_velocity/setOptions">velocity/setOptions</a>                      // 39
     *                                                                                                           // 40
     * @method setOptions                                                                                        // 41
     */                                                                                                          // 42
    Velocity.setOptions = function (options) {                                                                   // 43
      Meteor.call('velocity/setOptions', options);                                                               // 44
    };                                                                                                           // 45
                                                                                                                 // 46
    /**                                                                                                          // 47
     * See <a href="Meteor.methods.html#method_velocity/getOption">velocity/getOption</a>                        // 48
     *                                                                                                           // 49
     * @method getOption                                                                                         // 50
     * @for Velocity                                                                                             // 51
     */                                                                                                          // 52
    Velocity.getOption = function (name) {                                                                       // 53
      return Meteor.call('velocity/getOption', name);                                                            // 54
    };                                                                                                           // 55
  }                                                                                                              // 56
                                                                                                                 // 57
                                                                                                                 // 58
  Meteor.methods({                                                                                               // 59
    /**                                                                                                          // 60
     * Set an option.                                                                                            // 61
     *                                                                                                           // 62
     * @method velocity/setOption                                                                                // 63
     * @for Meteor.methods                                                                                       // 64
     * @param {String} name The name of the option.                                                              // 65
     * @param {*} value The value of the option.                                                                 // 66
     */                                                                                                          // 67
    'velocity/setOption': function (name, value) {                                                               // 68
      check(name, String);                                                                                       // 69
      check(value, Match.Any);                                                                                   // 70
                                                                                                                 // 71
      VelocityOptions.upsert(                                                                                    // 72
        {name: name},                                                                                            // 73
        {$set: {name: name, value: value}}                                                                       // 74
      );                                                                                                         // 75
    },                                                                                                           // 76
                                                                                                                 // 77
    /**                                                                                                          // 78
     * Set multiple options.                                                                                     // 79
     *                                                                                                           // 80
     * @method velocity/setOptions                                                                               // 81
     * @param options Hash with options (name: value).                                                           // 82
     */                                                                                                          // 83
    'velocity/setOptions': function (options) {                                                                  // 84
      check(options, Object);                                                                                    // 85
                                                                                                                 // 86
      for (var name in options) {                                                                                // 87
        if (options.hasOwnProperty(name)) {                                                                      // 88
          Meteor.call('velocity/setOption', name, options[name]);                                                // 89
        }                                                                                                        // 90
      }                                                                                                          // 91
    },                                                                                                           // 92
                                                                                                                 // 93
    /**                                                                                                          // 94
     * Get an option                                                                                             // 95
     *                                                                                                           // 96
     * @method velocity/getOption                                                                                // 97
     * @param {String} name The name of the option.                                                              // 98
     * @return {*} The value of the option or null.                                                              // 99
     */                                                                                                          // 100
    'velocity/getOption': function (name) {                                                                      // 101
      check(name, String);                                                                                       // 102
                                                                                                                 // 103
      var option = VelocityOptions.findOne({name: name});                                                        // 104
      return option ? option.value : null;                                                                       // 105
    },                                                                                                           // 106
  });                                                                                                            // 107
                                                                                                                 // 108
                                                                                                                 // 109
  if (Meteor.isServer) {                                                                                         // 110
    Meteor.methods({                                                                                             // 111
      /**                                                                                                        // 112
       * Exposes the VELOCITY environment variable.                                                              // 113
       *                                                                                                         // 114
       * @method velocity/isEnabled                                                                              // 115
       * @for Meteor.methods                                                                                     // 116
       * @return {Boolean} true if VELOCITY environment variable is truthy.                                      // 117
       *                   false if VELOCITY environment variable is falsy.                                      // 118
       *                   Default: true                                                                         // 119
       */                                                                                                        // 120
      'velocity/isEnabled': function () {                                                                        // 121
        var type = typeof process.env.VELOCITY;                                                                  // 122
                                                                                                                 // 123
        switch (type) {                                                                                          // 124
          case 'undefined':                                                                                      // 125
            return true;                                                                                         // 126
          case 'string':                                                                                         // 127
            if (process.env.VELOCITY.toLowerCase() === 'false' ||                                                // 128
                parseInt(process.env.VELOCITY) === 0) {                                                          // 129
              return false;                                                                                      // 130
            }                                                                                                    // 131
            return true;                                                                                         // 132
          default:                                                                                               // 133
            return !!process.env.VELOCITY;                                                                       // 134
        }                                                                                                        // 135
      }                                                                                                          // 136
    });                                                                                                          // 137
  }                                                                                                              // 138
                                                                                                                 // 139
})();                                                                                                            // 140
                                                                                                                 // 141
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                               //
// packages/velocity:core/src/mirrors/Mirror.js                                                                  //
//                                                                                                               //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                 //
/*jshint -W030 */                                                                                                // 1
/* global                                                                                                        // 2
 DEBUG:true                                                                                                      // 3
 */                                                                                                              // 4
                                                                                                                 // 5
DEBUG = !!process.env.VELOCITY_DEBUG;                                                                            // 6
                                                                                                                 // 7
(function () {                                                                                                   // 8
                                                                                                                 // 9
  'use strict';                                                                                                  // 10
                                                                                                                 // 11
  var _ = Npm.require('lodash'),                                                                                 // 12
      url = Npm.require('url'),                                                                                  // 13
      mongodbUri = Npm.require('mongodb-uri'),                                                                   // 14
      freeport = Npm.require('freeport'),                                                                        // 15
      tmp = Npm.require('tmp'),                                                                                  // 16
      files = VelocityMeteorInternals.files,                                                                     // 17
      _mirrorChildProcesses = {};                                                                                // 18
  Npm.require('colors');                                                                                         // 19
                                                                                                                 // 20
  // Specifies the Meteor release that we use for mirrors                                                        // 21
  Velocity.mirrorMeteorReleaseName = 'velocity:METEOR';                                                          // 22
  Velocity.mirrorMeteorVersion = '1.1.0.3_2';                                                                    // 23
  Velocity.mirrorMeteorRelease =                                                                                 // 24
    Velocity.mirrorMeteorReleaseName + '@' + Velocity.mirrorMeteorVersion;                                       // 25
  Velocity.mirrorMeteorToolReleaseName = 'velocity:meteor-tool';                                                 // 26
  Velocity.mirrorMeteorToolVersion = '1.1.4_2';                                                                  // 27
  Velocity.mirrorMeteorToolRelease =                                                                             // 28
    Velocity.mirrorMeteorToolReleaseName + '@' + Velocity.mirrorMeteorToolVersion;                               // 29
                                                                                                                 // 30
////////////////////////////////////////////////////////////////////////                                         // 31
// Meteor Methods                                                                                                // 32
//                                                                                                               // 33
                                                                                                                 // 34
                                                                                                                 // 35
  //////////////////////////////////////////////////////////////////////                                         // 36
  // Most communication with Velocity core is done via the following                                             // 37
  // Meteor methods.                                                                                             // 38
  //                                                                                                             // 39
  Meteor.methods({                                                                                               // 40
                                                                                                                 // 41
    /**                                                                                                          // 42
     * Starts a new mirror if it has not already been started, and reuses an                                     // 43
     * existing one if it is already started.                                                                    // 44
     *                                                                                                           // 45
     * This method will update the `VelocityMirrors` collection with once the mirror is ready.                   // 46
     *                                                                                                           // 47
     * @method velocity/mirrors/request                                                                          // 48
     * @for Meteor.methods                                                                                       // 49
     * @param {Object} options                  Options for the mirror.                                          // 50
     * @param {String} options.framework        The name of the calling framework                                // 51
     * @param {String} [options.testsPath]      The path to tests for this framework.                            // 52
     *                                          For example 'jasmine/server/unit'.                               // 53
     *                                          Don't include a leading or trailing slash.                       // 54
     * @param {String} [options.args]           Additional arguments that the mirror is called with              // 55
     *                                          It accepts all the options that are available for `meteor run`.  // 56
     * @param {Object} [options.env]            Additional environment variables that the mirror is called with. // 57
     * @param {Number} [options.port]           Use a specific port.  Default is random, free port.              // 58
     * @param {String} [options.rootUrlPath]    Adds this string to the end of the root url in the               // 59
     *                                          VelocityMirrors collection. eg. `/?jasmine=true`                 // 60
     * @param {Number} [options.nodes]          The number of mirrors required. This is used by                  // 61
     *                                          distributable frameworks. Default is 1                           // 62
     * @param {Boolean} [options.handshake]     Specifies whether or not this mirror should perform              // 63
     *                                          a DDP handshake with the parent. Distributable                   // 64
     *                                          frameworks can use this to get mirrors to behave                 // 65
     *                                          like workers. The default is true                                // 66
     *                                                                                                           // 67
     */                                                                                                          // 68
    'velocity/mirrors/request': function (options) {                                                             // 69
      check(options, {                                                                                           // 70
        framework: String,                                                                                       // 71
        testsPath: Match.Optional(String),                                                                       // 72
        args: Match.Optional([Match.Any]),                                                                       // 73
        env: Match.Optional(Object),                                                                             // 74
        port: Match.Optional(Number),                                                                            // 75
        rootUrlPath: Match.Optional(String),                                                                     // 76
        nodes: Match.Optional(Number),                                                                           // 77
        handshake: Match.Optional(Boolean)                                                                       // 78
      });                                                                                                        // 79
                                                                                                                 // 80
      this.unblock();                                                                                            // 81
                                                                                                                 // 82
      _startMirrors(options);                                                                                    // 83
    },                                                                                                           // 84
                                                                                                                 // 85
    /**                                                                                                          // 86
     * Stores metadata about the mirror.                                                                         // 87
     * Before a mirror implementation starts, it needs to call                                                   // 88
     * this method to let Velocity know it is starting up.                                                       // 89
     *                                                                                                           // 90
     * @method velocity/mirrors/init                                                                             // 91
     * @param {Object} options                                                                                   // 92
     *   @param {String} options.framework The name of the test framework                                        // 93
     *                                     making the request                                                    // 94
     *   @param {Number} options.port The port this mirror is running on                                         // 95
     *   @param {String} options.mongoUrl The mongo url this mirror is using                                     // 96
     *   @param {String} options.host The root url of this mirror without any                                    // 97
     *                        additional paths. Used for making DDP connections                                  // 98
     *   @param {String} options.rootUrl The root url of this mirror, which also                                 // 99
     *                           includes the path and params                                                    // 100
     *   @param {String} options.rootUrlPath Adds this string to the end of                                      // 101
     *                           the root url in the VelocityMirrors                                             // 102
     *                           collection. To be used by test frameworks to                                    // 103
     *                           recognize when they are executing in a mirror.                                  // 104
     *                           eg. `/?jasmine=true`                                                            // 105
     * @param {Object} [extra] Any additional metadata the implementing mirror                                   // 106
     *                         would like to store in the Velocity mirrors                                       // 107
     *                         collection.                                                                       // 108
     */                                                                                                          // 109
    'velocity/mirrors/init': function (options, extra) {                                                         // 110
      check(options, {                                                                                           // 111
        framework: String,                                                                                       // 112
        port: Number,                                                                                            // 113
        mongoUrl: String,                                                                                        // 114
        host: String,                                                                                            // 115
        rootUrl: String,                                                                                         // 116
        rootUrlPath: String,                                                                                     // 117
        pid: Number                                                                                              // 118
      });                                                                                                        // 119
      check(extra, Match.Optional(Object));                                                                      // 120
                                                                                                                 // 121
      if (extra) {                                                                                               // 122
        _.extend(options, extra);                                                                                // 123
      }                                                                                                          // 124
                                                                                                                 // 125
                                                                                                                 // 126
      var _upsertQuery = {                                                                                       // 127
        framework: options.framework,                                                                            // 128
        port: options.port                                                                                       // 129
      };                                                                                                         // 130
                                                                                                                 // 131
      var _options = _.extend(options, {                                                                         // 132
        state: 'starting'                                                                                        // 133
      });                                                                                                        // 134
                                                                                                                 // 135
      VelocityMirrors.upsert(_upsertQuery,                                                                       // 136
        _options);                                                                                               // 137
    },                                                                                                           // 138
                                                                                                                 // 139
    /**                                                                                                          // 140
     * Lets Velocity know the mirror has started successfully                                                    // 141
     *                                                                                                           // 142
     * @method velocity/mirrors/register                                                                         // 143
     * @param {Object} options                                                                                   // 144
     *   @param {String} options.framework The name of the test framework                                        // 145
     *                                     making the request                                                    // 146
     *   @param {String} options.host The root url of this mirror without any                                    // 147
     *                                additional paths. Must include port. Used                                  // 148
     *                                for making DDP connections                                                 // 149
     */                                                                                                          // 150
    'velocity/mirrors/register': function (options) {                                                            // 151
      check(options, Match.ObjectIncluding({                                                                     // 152
        framework: String,                                                                                       // 153
        host: String                                                                                             // 154
      }));                                                                                                       // 155
                                                                                                                 // 156
      DEBUG && console.log('[velocity] Mirror registered. Handshaking with mirror...');                          // 157
                                                                                                                 // 158
      this.unblock();                                                                                            // 159
                                                                                                                 // 160
      // TODO: Should the host really include the port?                                                          // 161
      var mirrorConnection = DDP.connect(options.host, {                                                         // 162
        // Don't show the user connection errors when not in debug mode.                                         // 163
        // We will normally eventually connect to the mirror after                                               // 164
        // a connection error has been shown.                                                                    // 165
        _dontPrintErrors: !DEBUG                                                                                 // 166
      });                                                                                                        // 167
      mirrorConnection.onReconnect = function () {                                                               // 168
        DEBUG && console.log('[velocity] Connected to mirror, setting state to ready', options);                 // 169
        mirrorConnection.call('velocity/parentHandshake', function(e, r) {                                       // 170
          DEBUG && console.log('[velocity] Parent Handshake response', e, r);                                    // 171
        });                                                                                                      // 172
        mirrorConnection.disconnect();                                                                           // 173
                                                                                                                 // 174
        var _updateQuery = {                                                                                     // 175
          framework: options.framework,                                                                          // 176
          port: parseInt(options.port)                                                                           // 177
        };                                                                                                       // 178
        VelocityMirrors.update(_updateQuery, {                                                                   // 179
          $set: {                                                                                                // 180
            state: 'ready',                                                                                      // 181
            lastModified: Date.now()                                                                             // 182
          }                                                                                                      // 183
        });                                                                                                      // 184
                                                                                                                 // 185
      };                                                                                                         // 186
    },                                                                                                           // 187
                                                                                                                 // 188
    /**                                                                                                          // 189
     * Exposes the IS_MIRROR flag.                                                                               // 190
     *                                                                                                           // 191
     * @method velocity/isMirror                                                                                 // 192
     * @for Meteor.methods                                                                                       // 193
     * @return {Boolean} true if currently running in mirror                                                     // 194
     */                                                                                                          // 195
    'velocity/isMirror': function () {                                                                           // 196
      return !!process.env.IS_MIRROR;                                                                            // 197
    }                                                                                                            // 198
                                                                                                                 // 199
  });  // end Meteor methods                                                                                     // 200
                                                                                                                 // 201
                                                                                                                 // 202
                                                                                                                 // 203
//////////////////////////////////////////////////////////////////////                                           // 204
// Private functions                                                                                             // 205
//                                                                                                               // 206
                                                                                                                 // 207
  function _startMirrors (options) {                                                                             // 208
    options = _.extend({                                                                                         // 209
      nodes: 1                                                                                                   // 210
    }, options);                                                                                                 // 211
    DEBUG && console.log('[velocity]', options.nodes, 'mirror(s) requested');                                    // 212
    // only respect a provided port if a single mirror is requested                                              // 213
    if (options.port && options.nodes === 1) {                                                                   // 214
      _startMirror(options);                                                                                     // 215
    } else {                                                                                                     // 216
      _reuseMirrors();                                                                                           // 217
      _startUninitializedMirrorsWithFreePorts();                                                                 // 218
    }                                                                                                            // 219
                                                                                                                 // 220
    function _reuseMirrors() {                                                                                   // 221
      options.unitializedNodes = options.nodes;                                                                  // 222
      var _reusableMirrorsForFramework = _.filter(Velocity.reusableMirrors, function(rmp) {                      // 223
        return rmp.framework === options.framework && rmp.reused === false;                                      // 224
      });                                                                                                        // 225
                                                                                                                 // 226
      _reusableMirrorsForFramework.forEach(function(rmff) {                                                      // 227
        rmff.reused = true;                                                                                      // 228
                                                                                                                 // 229
        options.port = rmff.port;                                                                                // 230
        _startMirror(options);                                                                                   // 231
                                                                                                                 // 232
        options.unitializedNodes--;                                                                              // 233
                                                                                                                 // 234
      });                                                                                                        // 235
                                                                                                                 // 236
    }                                                                                                            // 237
                                                                                                                 // 238
    function _startUninitializedMirrorsWithFreePorts() {                                                         // 239
      var startWithFreePort = Meteor.bindEnvironment(function(err, port) {                                       // 240
        options.port = port;                                                                                     // 241
        _startMirror(options);                                                                                   // 242
      });                                                                                                        // 243
                                                                                                                 // 244
      for (var i = 0; i < options.unitializedNodes; i++) {                                                       // 245
        freeport(startWithFreePort);                                                                             // 246
      }                                                                                                          // 247
    }                                                                                                            // 248
                                                                                                                 // 249
  }                                                                                                              // 250
                                                                                                                 // 251
  function _startMirror (options) {                                                                              // 252
                                                                                                                 // 253
    // TODO, options is passed as a reference, maybe we should pass a copy instead                               // 254
                                                                                                                 // 255
    options.handshake = options.handshake === undefined ? true : options.handshake;                              // 256
    options.rootUrlPath = (options.rootUrlPath || '');                                                           // 257
    options.host = _getMirrorUrl(options.port);                                                                  // 258
    options.rootUrl = options.host;                                                                              // 259
                                                                                                                 // 260
    var environment = _getEnvironmentVariables(options);                                                         // 261
                                                                                                                 // 262
    // append the port to the mirror log if there are multiple mirrors                                           // 263
    var processName = environment.FRAMEWORK;                                                                     // 264
    if (options.nodes > 1) {                                                                                     // 265
      processName = environment.FRAMEWORK + '_' + environment.PORT;                                              // 266
    }                                                                                                            // 267
                                                                                                                 // 268
    var mirrorChild = _getMirrorChild(environment.FRAMEWORK, processName);                                       // 269
    if (mirrorChild.isRunning()) {                                                                               // 270
      return;                                                                                                    // 271
    }                                                                                                            // 272
                                                                                                                 // 273
    var command = VelocityInternals.isWindows() ? 'meteor.bat' : 'meteor';                                       // 274
    var args = [                                                                                                 // 275
      'run',                                                                                                     // 276
      '--test-app',                                                                                              // 277
      '--port', String(environment.PORT)                                                                         // 278
    ];                                                                                                           // 279
                                                                                                                 // 280
    if (options.testsPath) {                                                                                     // 281
      args.push('--include-tests', files.convertToStandardPath(options.testsPath));                              // 282
    }                                                                                                            // 283
                                                                                                                 // 284
    if (Meteor.settings) {                                                                                       // 285
      var settingsPath = _generateSettingsFile();                                                                // 286
      args.push('--settings', settingsPath);                                                                     // 287
    }                                                                                                            // 288
                                                                                                                 // 289
    if (options.args) {                                                                                          // 290
      args.push.apply(args, options.args);                                                                       // 291
    }                                                                                                            // 292
                                                                                                                 // 293
    // Make it possible to debug a mirror                                                                        // 294
    if (                                                                                                         // 295
      process.env.VELOCITY_DEBUG_MIRROR &&                                                                       // 296
      process.env.VELOCITY_DEBUG_MIRROR === environment.FRAMEWORK &&                                             // 297
      !_.contains(options.args, '--debug-port')                                                                  // 298
    ) {                                                                                                          // 299
      var debugPort = '5858';                                                                                    // 300
      args.push('--debug-port', debugPort);                                                                      // 301
      console.log('[velocity] Your mirror is now paused and ready for debugging!');                              // 302
      console.log();                                                                                             // 303
      console.log('[velocity] To debug the server process using a graphical debugging interface,');              // 304
      console.log('[velocity] visit this URL in your web browser:');                                             // 305
      console.log('[velocity] http://localhost:8080/debug?port=' + debugPort);                                   // 306
    }                                                                                                            // 307
                                                                                                                 // 308
    // Allow to use checked out meteor for spawning mirrors                                                      // 309
    // for development on our Meteor fork                                                                        // 310
    if (!process.env.VELOCITY_USE_CHECKED_OUT_METEOR) {                                                          // 311
      args.push('--release', Velocity.mirrorMeteorRelease);                                                      // 312
    }                                                                                                            // 313
                                                                                                                 // 314
    mirrorChild.spawn({                                                                                          // 315
      command: command,                                                                                          // 316
      args: args,                                                                                                // 317
      options: {                                                                                                 // 318
        cwd: process.env.VELOCITY_APP_PATH || process.env.PWD,                                                   // 319
        env: environment                                                                                         // 320
      }                                                                                                          // 321
    });                                                                                                          // 322
                                                                                                                 // 323
    DEBUG && console.log(                                                                                        // 324
      '[velocity] Mirror process forked with pid',                                                               // 325
      mirrorChild.getPid()                                                                                       // 326
    );                                                                                                           // 327
                                                                                                                 // 328
                                                                                                                 // 329
    console.log(('[velocity] ' +                                                                                 // 330
      environment.FRAMEWORK + ' is starting a mirror at ' +                                                      // 331
      environment.ROOT_URL + '.'                                                                                 // 332
    ).yellow);                                                                                                   // 333
                                                                                                                 // 334
    var isMeteorToolInstalled = MeteorFilesHelpers.isPackageInstalled(                                           // 335
      Velocity.mirrorMeteorToolReleaseName,                                                                      // 336
      Velocity.mirrorMeteorToolVersion                                                                           // 337
    );                                                                                                           // 338
    if (!isMeteorToolInstalled) {                                                                                // 339
      console.log(                                                                                               // 340
        '[velocity] *** Meteor Tools is installing ***',                                                         // 341
        '\nThis takes a few minutes the first time.'.yellow                                                      // 342
      );                                                                                                         // 343
    }                                                                                                            // 344
                                                                                                                 // 345
    console.log(('[velocity] You can see the mirror logs at: tail -f ' +                                         // 346
    files.convertToOSPath(files.pathJoin(Velocity.getAppPath(),                                                  // 347
      '.meteor', 'local', 'log', processName + '.log'))).yellow);                                                // 348
                                                                                                                 // 349
    Meteor.call('velocity/mirrors/init', {                                                                       // 350
      framework: environment.FRAMEWORK,                                                                          // 351
      port: environment.PORT,                                                                                    // 352
      mongoUrl: environment.MONGO_URL,                                                                           // 353
      host: environment.HOST,                                                                                    // 354
      rootUrl: environment.ROOT_URL,                                                                             // 355
      rootUrlPath: environment.ROOT_URL_PATH,                                                                    // 356
      pid: mirrorChild.getPid()                                                                                  // 357
    });                                                                                                          // 358
  }                                                                                                              // 359
                                                                                                                 // 360
  function _getMirrorChild (framework, processName) {                                                            // 361
    var _processName = processName || framework;                                                                 // 362
    var mirrorChild = _mirrorChildProcesses[_processName];                                                       // 363
    if (!mirrorChild) {                                                                                          // 364
      mirrorChild = new sanjo.LongRunningChildProcess(_processName);                                             // 365
      _mirrorChildProcesses[_processName] = mirrorChild;                                                         // 366
    }                                                                                                            // 367
    return mirrorChild;                                                                                          // 368
  }                                                                                                              // 369
                                                                                                                 // 370
  /**                                                                                                            // 371
   * Returns the MongoDB URL for the given database.                                                             // 372
   *                                                                                                             // 373
   * @method _getMongoUrl                                                                                        // 374
   * @param {Object} database                                                                                    // 375
   * @return {String} MongoDB Url                                                                                // 376
   * @private                                                                                                    // 377
   */                                                                                                            // 378
  function _getMongoUrl (database) {                                                                             // 379
    var parts = mongodbUri.parse(process.env.VELOCITY_MONGO_URL || process.env.MONGO_URL);                       // 380
    parts.database += '-' + database;                                                                            // 381
    return mongodbUri.format(parts);                                                                             // 382
  }                                                                                                              // 383
                                                                                                                 // 384
  /**                                                                                                            // 385
   * Return URL for the mirror with the given port.                                                              // 386
   *                                                                                                             // 387
   * @method _getMirrorUrl                                                                                       // 388
   * @param {Number} port Mirror port                                                                            // 389
   * @return {String} Mirror URL                                                                                 // 390
   * @private                                                                                                    // 391
   */                                                                                                            // 392
  function _getMirrorUrl (port) {                                                                                // 393
    var rootUrlParts = url.parse(Meteor.absoluteUrl());                                                          // 394
    return url.format({                                                                                          // 395
      protocol: rootUrlParts.protocol,                                                                           // 396
      slashes: rootUrlParts.slashes,                                                                             // 397
      hostname: rootUrlParts.hostname,                                                                           // 398
      port: port,                                                                                                // 399
      pathname: rootUrlParts.pathname                                                                            // 400
    });                                                                                                          // 401
  }                                                                                                              // 402
                                                                                                                 // 403
  /**                                                                                                            // 404
   * Return the environment variables that a mirror should run with                                              // 405
   *                                                                                                             // 406
   * @method _getEnvironmentVariables                                                                            // 407
   * @param {Object} options Required fields:                                                                    // 408
   *   @param {String} options.framework The name of the test framework                                          // 409
   *                                     making the request                                                      // 410
   *   @param {Number} options.port The port this mirror is running on                                           // 411
   *   @param {String} options.host The root url of this mirror without any                                      // 412
   *                        additional paths. Used for making DDP connections                                    // 413
   *   @param {String} options.rootUrl The root url of this mirror, which also                                   // 414
   *                           includes the path and params                                                      // 415
   *   @param {String} options.rootUrlPath Adds this string to the end of                                        // 416
   *                           the root url in the VelocityMirrors                                               // 417
   *                           collection. To be used by test frameworks to                                      // 418
   *                           recognize when they are executing in a mirror.                                    // 419
   *                           eg. `/?jasmine=true`                                                              // 420
   *   @param {Boolean} options.handshake Specifies whether or not this mirror                                   // 421
   *                                      should perform a DDP handshake with                                    // 422
   *                                      the parent. Distributable frameworks                                   // 423
   *                                      can use this to get mirrors to behave                                  // 424
   *                                      like workers.                                                          // 425
   *   @param {Object} [options.env] Additional environment variables that the                                   // 426
   *                                 mirror is called with.                                                      // 427
   * @return {Object} environment variables                                                                      // 428
   * @private                                                                                                    // 429
   */                                                                                                            // 430
  function _getEnvironmentVariables (options) {                                                                  // 431
    var env = {                                                                                                  // 432
      PORT: options.port,                                                                                        // 433
      // PORT gets overridden by Meteor so we save the mirror port in                                            // 434
      // MIRROR_PORT too.                                                                                        // 435
      MIRROR_PORT: options.port,                                                                                 // 436
      HOST: options.host,                                                                                        // 437
      ROOT_URL_PATH: options.rootUrlPath,                                                                        // 438
      ROOT_URL: options.rootUrl,                                                                                 // 439
      FRAMEWORK: options.framework,                                                                              // 440
      MONGO_URL: _getMongoUrl(options.framework),                                                                // 441
      PARENT_URL: process.env.ROOT_URL,                                                                          // 442
      IS_MIRROR: true,                                                                                           // 443
      HANDSHAKE: options.handshake,                                                                              // 444
      VELOCITY_MAIN_APP_PATH: Velocity.getAppPath(),                                                             // 445
      METEOR_SETTINGS: JSON.stringify(_.extend({}, Meteor.settings))                                             // 446
    };                                                                                                           // 447
                                                                                                                 // 448
    if (options.env) {                                                                                           // 449
      _.defaults(env, options.env);                                                                              // 450
    }                                                                                                            // 451
                                                                                                                 // 452
    _.defaults(env, process.env);                                                                                // 453
                                                                                                                 // 454
    return env;                                                                                                  // 455
  }                                                                                                              // 456
                                                                                                                 // 457
  var _generateSettingsFile = _.memoize(function () {                                                            // 458
    var tmpObject = tmp.fileSync();                                                                              // 459
    files.writeFile(tmpObject.name, JSON.stringify(Meteor.settings));                                            // 460
    return tmpObject.name;                                                                                       // 461
  });                                                                                                            // 462
                                                                                                                 // 463
                                                                                                                 // 464
})();                                                                                                            // 465
                                                                                                                 // 466
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                               //
// packages/velocity:core/src/mirrors/mirrorRegistrar.js                                                         //
//                                                                                                               //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                 //
/*jshint -W030 */                                                                                                // 1
/* globals                                                                                                       // 2
 DEBUG: true,                                                                                                    // 3
 WebApp: false                                                                                                   // 4
 */                                                                                                              // 5
                                                                                                                 // 6
DEBUG = !!process.env.VELOCITY_DEBUG;                                                                            // 7
                                                                                                                 // 8
(function () {                                                                                                   // 9
  'use strict';                                                                                                  // 10
                                                                                                                 // 11
  // between this line and the velocity/parentHandshake, is the time the mirror                                  // 12
  // starts initializing and is ready                                                                            // 13
                                                                                                                 // 14
  Meteor.methods({                                                                                               // 15
                                                                                                                 // 16
    /**                                                                                                          // 17
     * This is the best indicator of the mirror's ready status, so it's used                                     // 18
     * to inform the user when there may be delays                                                               // 19
     *                                                                                                           // 20
     * @method velocity/parentHandshake                                                                          // 21
     * @for Meteor.methods                                                                                       // 22
     */                                                                                                          // 23
    'velocity/parentHandshake': function () {                                                                    // 24
      console.log('[velocity] Established connection with Velocity.');                                           // 25
    }                                                                                                            // 26
                                                                                                                 // 27
  });                                                                                                            // 28
                                                                                                                 // 29
                                                                                                                 // 30
  //////////////////////////////////////////////////////////////////////                                         // 31
  // This code will run inside a mirror and connects the mirror to                                               // 32
  // velocity via ddp once the mirror starts. Velocity will then                                                 // 33
  // inform frameworks this mirror is ready.                                                                     // 34
  //                                                                                                             // 35
  if (process.env.IS_MIRROR) {                                                                                   // 36
    if (process.env.HANDSHAKE) {                                                                                 // 37
      WebApp.onListening(function () {                                                                           // 38
        DEBUG && console.log('[velocity] Mirror started. Connecting via DDP to parent');                         // 39
                                                                                                                 // 40
        var velocityConnection = DDP.connect(process.env.PARENT_URL);                                            // 41
        velocityConnection.onReconnect = function () {                                                           // 42
          DEBUG && console.log('[velocity] Mirror connected to parent. Registering mirror...');                  // 43
          velocityConnection.call('velocity/mirrors/register', {                                                 // 44
            framework: process.env.FRAMEWORK,                                                                    // 45
            host: process.env.HOST,                                                                              // 46
            port: process.env.MIRROR_PORT                                                                        // 47
          }, function (error) {                                                                                  // 48
            if (error) {                                                                                         // 49
              console.error(                                                                                     // 50
                '[velocity] Could not connect to parent via DDP. ' +                                             // 51
                'Please restart your app and try again. ' +                                                      // 52
                'If this happens often please report it as issue to velocity:core.',                             // 53
                error                                                                                            // 54
              );                                                                                                 // 55
            }                                                                                                    // 56
            // Disconnect because we no longer need the connection                                               // 57
            velocityConnection.disconnect();                                                                     // 58
          });                                                                                                    // 59
        };                                                                                                       // 60
                                                                                                                 // 61
      });                                                                                                        // 62
    } else {                                                                                                     // 63
      DEBUG && console.log('[velocity] Mirror', process.env.MIRROR_PORT , 'configured not to handshake');        // 64
    }                                                                                                            // 65
  }                                                                                                              // 66
                                                                                                                 // 67
})();                                                                                                            // 68
                                                                                                                 // 69
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['velocity:core'] = {
  Velocity: Velocity,
  VelocityTestFiles: VelocityTestFiles,
  VelocityFixtureFiles: VelocityFixtureFiles,
  VelocityTestReports: VelocityTestReports,
  VelocityAggregateReports: VelocityAggregateReports,
  VelocityLogs: VelocityLogs,
  VelocityMirrors: VelocityMirrors,
  VelocityOptions: VelocityOptions
};

})();

//# sourceMappingURL=velocity_core.js.map
