(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var _ = Package.underscore._;

/* Package-scope variables */
var VelocityMeteorInternals;

(function () {

//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
// packages/velocity:meteor-internals/main.js                                           //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
                                                                                        //
VelocityMeteorInternals = {}                                                            // 1
                                                                                        // 2
//////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
// packages/velocity:meteor-internals/tools/parse-stack.js                              //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
                                                                                        //
var exports = {};                                                                       // 1
VelocityMeteorInternals.parseStack = exports;                                           // 2
                                                                                        // 3
// Decorator. Mark the point at which a stack trace returned by                         // 4
// parse() should stop: no frames earlier than this point will be                       // 5
// included in the parsed stack. Confusingly, in the argot of the                       // 6
// times, you'd say that frames "higher up" than this or "above" this                   // 7
// will not be returned, but you'd also say that those frames are "at                   // 8
// the bottom of the stack". Frames below the bottom are the outer                      // 9
// context of the framework running the user's code.                                    // 10
exports.markBottom = function (f) {                                                     // 11
  return function __bottom_mark__ () {                                                  // 12
    return f.apply(this, arguments);                                                    // 13
  };                                                                                    // 14
};                                                                                      // 15
                                                                                        // 16
//////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
// packages/velocity:meteor-internals/tools/buildmessage.js                             //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
                                                                                        //
// Given a function f, return a "marked" version of f. The mark                         // 1
// indicates that stack traces should stop just above f. So if you                      // 2
// mark a user-supplied callback function before calling it, you'll be                  // 3
// able to show the user just the "user portion" of the stack trace                     // 4
// (the part inside their own code, and not all of the innards of the                   // 5
// code that called it).                                                                // 6
var markBoundary = function (f) {                                                       // 7
  return VelocityMeteorInternals.parseStack.markBottom(f);                              // 8
};                                                                                      // 9
                                                                                        // 10
                                                                                        // 11
VelocityMeteorInternals.buildmessage = {                                                // 12
  markBoundary: markBoundary                                                            // 13
};                                                                                      // 14
                                                                                        // 15
//////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
// packages/velocity:meteor-internals/tools/files.js                                    //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
                                                                                        //
/**                                                                                     // 1
 * Copied from Meteor tools/files.js.                                                   // 2
 *                                                                                      // 3
 * Includes:                                                                            // 4
 * - Helper to find the app root path                                                   // 5
 * - Helper to run JavaScript                                                           // 6
 */                                                                                     // 7
                                                                                        // 8
///                                                                                     // 9
/// utility functions for files and directories. includes both generic                  // 10
/// helper functions (such as rm_recursive), and meteor-specific ones                   // 11
/// (such as testing whether an directory is a meteor app)                              // 12
///                                                                                     // 13
                                                                                        // 14
var fs = Npm.require("fs");                                                             // 15
var path = Npm.require('path');                                                         // 16
var Fiber = Npm.require('fibers');                                                      // 17
var Future = Npm.require('fibers/future');                                              // 18
var sourcemap = Npm.require('source-map');                                              // 19
var sourcemap_support = Npm.require('source-map-support');                              // 20
                                                                                        // 21
var files = {};                                                                         // 22
VelocityMeteorInternals.files = files;                                                  // 23
                                                                                        // 24
var parsedSourceMaps = {};                                                              // 25
var nextStackFilenameCounter = 1;                                                       // 26
var retrieveSourceMap = function (pathForSourceMap) {                                   // 27
  if (_.has(parsedSourceMaps, pathForSourceMap))                                        // 28
    return {map: parsedSourceMaps[pathForSourceMap]};                                   // 29
  return null;                                                                          // 30
};                                                                                      // 31
                                                                                        // 32
sourcemap_support.install({                                                             // 33
  // Use the source maps specified to runJavaScript instead of parsing source           // 34
  // code for them.                                                                     // 35
  retrieveSourceMap: retrieveSourceMap,                                                 // 36
  // For now, don't fix the source line in uncaught exceptions, because we              // 37
  // haven't fixed handleUncaughtExceptions in source-map-support to properly           // 38
  // locate the source files.                                                           // 39
  handleUncaughtExceptions: false                                                       // 40
});                                                                                     // 41
                                                                                        // 42
// given a predicate function and a starting path, traverse upwards                     // 43
// from the path until we find a path that satisfies the predicate.                     // 44
//                                                                                      // 45
// returns either the path to the lowest level directory that passed                    // 46
// the test or null for none found. if starting path isn't given, use                   // 47
// cwd.                                                                                 // 48
var findUpwards = function (predicate, startPath) {                                     // 49
  var testDir = startPath || files.cwd();                                               // 50
  while (testDir) {                                                                     // 51
    if (predicate(testDir)) {                                                           // 52
      break;                                                                            // 53
    }                                                                                   // 54
    var newDir = files.pathDirname(testDir);                                            // 55
    if (newDir === testDir) {                                                           // 56
      testDir = null;                                                                   // 57
    } else {                                                                            // 58
      testDir = newDir;                                                                 // 59
    }                                                                                   // 60
  }                                                                                     // 61
  if (!testDir)                                                                         // 62
    return null;                                                                        // 63
                                                                                        // 64
  return testDir;                                                                       // 65
};                                                                                      // 66
                                                                                        // 67
files.cwd = function () {                                                               // 68
  return files.convertToStandardPath(process.cwd());                                    // 69
};                                                                                      // 70
                                                                                        // 71
// Determine if 'filepath' (a path, or omit for cwd) is within an app                   // 72
// directory. If so, return the top-level app directory.                                // 73
files.findAppDir = function (filepath) {                                                // 74
  var isAppDir = function (filepath) {                                                  // 75
    // XXX once we are done with the transition to engine, this should                  // 76
    // change to: `return files.exists(path.join(filepath, '.meteor',                   // 77
    // 'release'))`                                                                     // 78
                                                                                        // 79
    // .meteor/packages can be a directory, if .meteor is a warehouse                   // 80
    // directory.  since installing meteor initializes a warehouse at                   // 81
    // $HOME/.meteor, we want to make sure your home directory (and all                 // 82
    // subdirectories therein) don't count as being within a meteor app.                // 83
    try { // use try/catch to avoid the additional syscall to files.exists              // 84
      return files.stat(                                                                // 85
        files.pathJoin(filepath, '.meteor', 'packages')).isFile();                      // 86
    } catch (e) {                                                                       // 87
      return false;                                                                     // 88
    }                                                                                   // 89
  };                                                                                    // 90
                                                                                        // 91
  return findUpwards(isAppDir, filepath);                                               // 92
};                                                                                      // 93
                                                                                        // 94
files.findPackageDir = function (filepath) {                                            // 95
  var isPackageDir = function (filepath) {                                              // 96
    try {                                                                               // 97
      return files.stat(files.pathJoin(filepath, 'package.js')).isFile();               // 98
    } catch (e) {                                                                       // 99
      return false;                                                                     // 100
    }                                                                                   // 101
  };                                                                                    // 102
                                                                                        // 103
  return findUpwards(isPackageDir, filepath);                                           // 104
};                                                                                      // 105
                                                                                        // 106
// Like statSync, but null if file not found                                            // 107
files.statOrNull = function (path) {                                                    // 108
  try {                                                                                 // 109
    return files.stat(path);                                                            // 110
  } catch (e) {                                                                         // 111
    if (e.code == "ENOENT" || e.code == "ENOTDIR")                                      // 112
      return null;                                                                      // 113
    throw e;                                                                            // 114
  }                                                                                     // 115
};                                                                                      // 116
                                                                                        // 117
// Return the result of evaluating `code` using                                         // 118
// `runInThisContext`. `code` will be wrapped in a closure. You can                     // 119
// pass additional values to bind in the closure in `options.symbols`,                  // 120
// the keys being the symbols to bind and the values being their                        // 121
// values. `options.filename` is the filename to use in exceptions                      // 122
// that come from inside this code. `options.sourceMap` is an optional                  // 123
// source map that represents the file.                                                 // 124
//                                                                                      // 125
// The really special thing about this function is that if a parse                      // 126
// error occurs, we will raise an exception of type                                     // 127
// files.FancySyntaxError, from which you may read 'message', 'file',                   // 128
// 'line', and 'column' attributes ... v8 is normally reluctant to                      // 129
// reveal this information but will write it to stderr if you pass it                   // 130
// an undocumented flag. Unforunately though node doesn't have dup2 so                  // 131
// we can't intercept the write. So instead we use a completely                         // 132
// different parser with a better error handling API. Ah well.  The                     // 133
// underlying V8 issue is:                                                              // 134
//   https://code.google.com/p/v8/issues/detail?id=1281                                 // 135
files.runJavaScript = function (code, options) {                                        // 136
  if (typeof code !== 'string')                                                         // 137
    throw new Error("code must be a string");                                           // 138
                                                                                        // 139
  options = options || {};                                                              // 140
  var filename = options.filename || "<anonymous>";                                     // 141
  var keys = [], values = [];                                                           // 142
  // don't assume that _.keys and _.values are guaranteed to                            // 143
  // enumerate in the same order                                                        // 144
  _.each(options.symbols, function (value, name) {                                      // 145
    keys.push(name);                                                                    // 146
    values.push(value);                                                                 // 147
  });                                                                                   // 148
                                                                                        // 149
  var stackFilename = filename;                                                         // 150
  if (options.sourceMap) {                                                              // 151
    // We want to generate an arbitrary filename that we use to associate the           // 152
    // file with its source map.                                                        // 153
    stackFilename = "<runJavaScript-" + nextStackFilenameCounter++ + ">";               // 154
  }                                                                                     // 155
                                                                                        // 156
  var chunks = [];                                                                      // 157
  var header = "(function(" + keys.join(',') + "){";                                    // 158
  chunks.push(header);                                                                  // 159
  if (options.sourceMap) {                                                              // 160
    var consumer = new sourcemap.SourceMapConsumer(options.sourceMap);                  // 161
    chunks.push(sourcemap.SourceNode.fromStringWithSourceMap(                           // 162
      code, consumer));                                                                 // 163
  } else {                                                                              // 164
    chunks.push(code);                                                                  // 165
  }                                                                                     // 166
  // \n is necessary in case final line is a //-comment                                 // 167
  chunks.push("\n})");                                                                  // 168
                                                                                        // 169
  var wrapped;                                                                          // 170
  var parsedSourceMap = null;                                                           // 171
  if (options.sourceMap) {                                                              // 172
    var node = new sourcemap.SourceNode(null, null, null, chunks);                      // 173
    var results = node.toStringWithSourceMap({                                          // 174
      file: stackFilename                                                               // 175
    });                                                                                 // 176
    wrapped = results.code;                                                             // 177
    parsedSourceMap = results.map.toJSON();                                             // 178
    if (options.sourceMapRoot) {                                                        // 179
      // Add the specified root to any root that may be in the file.                    // 180
      parsedSourceMap.sourceRoot = files.pathJoin(                                      // 181
        options.sourceMapRoot, parsedSourceMap.sourceRoot || '');                       // 182
    }                                                                                   // 183
    // source-map-support doesn't ever look at the sourcesContent field, so             // 184
    // there's no point in keeping it in memory.                                        // 185
    delete parsedSourceMap.sourcesContent;                                              // 186
    parsedSourceMaps[stackFilename] = parsedSourceMap;                                  // 187
  } else {                                                                              // 188
    wrapped = chunks.join('');                                                          // 189
  };                                                                                    // 190
                                                                                        // 191
  try {                                                                                 // 192
    // See #runInThisContext                                                            // 193
    //                                                                                  // 194
    // XXX it'd be nice to runInNewContext so that the code can't mess                  // 195
    // with our globals, but objects that come out of runInNewContext                   // 196
    // have bizarro antimatter prototype chains and break 'instanceof                   // 197
    // Array'. for now, steer clear                                                     // 198
    //                                                                                  // 199
    // Pass 'true' as third argument if we want the parse error on                      // 200
    // stderr (which we don't).                                                         // 201
    var script = Npm.require('vm').createScript(wrapped, stackFilename);                // 202
  } catch (nodeParseError) {                                                            // 203
    if (!(nodeParseError instanceof SyntaxError))                                       // 204
      throw nodeParseError;                                                             // 205
    // Got a parse error. Unfortunately, we can't actually get the                      // 206
    // location of the parse error from the SyntaxError; Node has some                  // 207
    // hacky support for displaying it over stderr if you pass an                       // 208
    // undocumented third argument to stackFilename, but that's not                     // 209
    // what we want. See                                                                // 210
    //    https://github.com/joyent/node/issues/3452                                    // 211
    // for more information. One thing to try (and in fact, what an                     // 212
    // early version of this function did) is to actually fork a new                    // 213
    // node to run the code and parse its output. We instead run an                     // 214
    // entirely different JS parser, from the esprima project, but                      // 215
    // which at least has a nice API for reporting errors.                              // 216
    var esprima = Npm.require('esprima');                                               // 217
    try {                                                                               // 218
      esprima.parse(wrapped);                                                           // 219
    } catch (esprimaParseError) {                                                       // 220
      // Is this actually an Esprima syntax error?                                      // 221
      if (!('index' in esprimaParseError &&                                             // 222
        'lineNumber' in esprimaParseError &&                                            // 223
        'column' in esprimaParseError &&                                                // 224
        'description' in esprimaParseError)) {                                          // 225
        throw esprimaParseError;                                                        // 226
      }                                                                                 // 227
      var err = new files.FancySyntaxError;                                             // 228
                                                                                        // 229
      err.message = esprimaParseError.description;                                      // 230
                                                                                        // 231
      if (parsedSourceMap) {                                                            // 232
        // XXX this duplicates code in computeGlobalReferences                          // 233
        var consumer2 = new sourcemap.SourceMapConsumer(parsedSourceMap);               // 234
        var original = consumer2.originalPositionFor({                                  // 235
          line: esprimaParseError.lineNumber,                                           // 236
          column: esprimaParseError.column - 1                                          // 237
        });                                                                             // 238
        if (original.source) {                                                          // 239
          err.file = original.source;                                                   // 240
          err.line = original.line;                                                     // 241
          err.column = original.column + 1;                                             // 242
          throw err;                                                                    // 243
        }                                                                               // 244
      }                                                                                 // 245
                                                                                        // 246
      err.file = filename;  // *not* stackFilename                                      // 247
      err.line = esprimaParseError.lineNumber;                                          // 248
      err.column = esprimaParseError.column;                                            // 249
      // adjust errors on line 1 to account for our header                              // 250
      if (err.line === 1) {                                                             // 251
        err.column -= header.length;                                                    // 252
      }                                                                                 // 253
      throw err;                                                                        // 254
    }                                                                                   // 255
                                                                                        // 256
    // What? Node thought that this was a parse error and esprima didn't? Eh,           // 257
    // just throw Node's error and don't care too much about the line numbers           // 258
    // being right.                                                                     // 259
    throw nodeParseError;                                                               // 260
  }                                                                                     // 261
                                                                                        // 262
  var func = script.runInThisContext();                                                 // 263
                                                                                        // 264
  return (VelocityMeteorInternals.buildmessage.markBoundary(func)).apply(null, values); // 265
};                                                                                      // 266
                                                                                        // 267
// - message: an error message from the parser                                          // 268
// - file: filename                                                                     // 269
// - line: 1-based                                                                      // 270
// - column: 1-based                                                                    // 271
files.FancySyntaxError = function () {};                                                // 272
                                                                                        // 273
// Summary of cross platform file system handling strategy                              // 274
                                                                                        // 275
// There are three main pain points for handling files on Windows: slashes in           // 276
// paths, line endings in text files, and colons/invalid characters in paths.           // 277
                                                                                        // 278
// 1. Slashes in file paths                                                             // 279
                                                                                        // 280
//   We have decided to store all paths inside the tool as unix-style paths in          // 281
//   the style of CYGWIN. This means that all paths have forward slashes on all         // 282
//   platforms, and C:\ is converted to /c/ on Windows.                                 // 283
                                                                                        // 284
//   All of the methods in files.js know how to convert from these unixy paths          // 285
//   to whatever type of path the underlying system prefers.                            // 286
                                                                                        // 287
//   The reason we chose this strategy because it was easier to make sure to use        // 288
//   files.js everywhere instead of node's fs than to make sure every part of           // 289
//   the tool correctly uses system-specific path separators. In addition, there        // 290
//   are some parts of the tool where it is very hard to tell which strings are         // 291
//   used as URLs and which are used as file paths. In some cases, a string can         // 292
//   be used as both, meaning it has to have forward slashes no matter what.            // 293
                                                                                        // 294
// 2. Line endings in text files                                                        // 295
                                                                                        // 296
//   We have decided to convert all files read by the tool to Unix-style line           // 297
//   endings for the same reasons as slashes above. In many parts of the tool,          // 298
//   we assume that '\n' is the line separator, and it can be hard to find all          // 299
//   of the places and decide whether it is appropriate to use os.EOL. We do not        // 300
//   convert anything on write. We will wait and see if anyone complains.               // 301
                                                                                        // 302
// 3. Colons and other invalid characters in file paths                                 // 303
                                                                                        // 304
//   This is not handled automatically by files.js. You need to be careful to           // 305
//   escape any colons in package names, etc, before using a string as a file           // 306
//   path.                                                                              // 307
                                                                                        // 308
//   A helpful file to import for this purpose is colon-converter.js, which also        // 309
//   knows how to convert various configuration file formats.                           // 310
                                                                                        // 311
/**                                                                                     // 312
 * Wrap a function from node's fs module to use the right slashes for this OS           // 313
 * and run in a fiber, then assign it to the "files" namespace. Each call               // 314
 * creates a files.func that runs asynchronously with Fibers (yielding and              // 315
 * until the call is done), unless run outside a Fiber or in noYieldsAllowed, in        // 316
 * which case it uses fs.funcSync.                                                      // 317
 *                                                                                      // 318
 * @param  {String} fsFuncName         The name of the node fs function to wrap         // 319
 * @param  {Number[]} pathArgIndices Indices of arguments that have paths, these        // 320
 * arguments will be converted to the correct OS slashes                                // 321
 * @param  {Object} options        Some options for lesser-used cases                   // 322
 * @param {Boolean} options.noErr If true, the callback of the wrapped function         // 323
 * doesn't have a first "error" argument, for example in fs.exists.                     // 324
 * @param {Function} options.modifyReturnValue Pass in a function to modify the         // 325
 * return value                                                                         // 326
 */                                                                                     // 327
function wrapFsFunc(fsFuncName, pathArgIndices, options) {                              // 328
  options = options || {};                                                              // 329
                                                                                        // 330
  var fsFunc = fs[fsFuncName];                                                          // 331
  var fsFuncSync = fs[fsFuncName + "Sync"];                                             // 332
                                                                                        // 333
  function wrapper() {                                                                  // 334
    var argc = arguments.length;                                                        // 335
    var args = new Array(argc);                                                         // 336
    for (var i = 0; i < argc; ++i) {                                                    // 337
      args[i] = arguments[i];                                                           // 338
    }                                                                                   // 339
                                                                                        // 340
    for (var j = pathArgIndices.length - 1; j >= 0; --j) {                              // 341
      i = pathArgIndices[j];                                                            // 342
      args[i] = files.convertToOSPath(args[i]);                                         // 343
    }                                                                                   // 344
                                                                                        // 345
    if (Fiber.current &&                                                                // 346
      Fiber.yield && ! Fiber.yield.disallowed) {                                        // 347
      var fut = new Future;                                                             // 348
                                                                                        // 349
      args.push(function callback(err, value) {                                         // 350
        if (options.noErr) {                                                            // 351
          fut.return(err);                                                              // 352
        } else if (err) {                                                               // 353
          fut.throw(err);                                                               // 354
        } else {                                                                        // 355
          fut.return(value);                                                            // 356
        }                                                                               // 357
      });                                                                               // 358
                                                                                        // 359
      fsFunc.apply(fs, args);                                                           // 360
                                                                                        // 361
      var result = fut.wait();                                                          // 362
      return options.modifyReturnValue                                                  // 363
        ? options.modifyReturnValue(result)                                             // 364
        : result;                                                                       // 365
    }                                                                                   // 366
                                                                                        // 367
    // If we're not in a Fiber, run the sync version of the fs.* method.                // 368
    var result = fsFuncSync.apply(fs, args);                                            // 369
    return options.modifyReturnValue                                                    // 370
      ? options.modifyReturnValue(result)                                               // 371
      : result;                                                                         // 372
  }                                                                                     // 373
                                                                                        // 374
  wrapper.displayName = fsFuncName;                                                     // 375
  return files[fsFuncName] = wrapper;                                                   // 376
}                                                                                       // 377
                                                                                        // 378
wrapFsFunc("writeFile", [0]);                                                           // 379
wrapFsFunc("appendFile", [0]);                                                          // 380
wrapFsFunc("readFile", [0], {                                                           // 381
  modifyReturnValue: function (fileData) {                                              // 382
    if (_.isString(fileData)) {                                                         // 383
      return files.convertToStandardLineEndings(fileData);                              // 384
    }                                                                                   // 385
                                                                                        // 386
    return fileData;                                                                    // 387
  }                                                                                     // 388
});                                                                                     // 389
wrapFsFunc("stat", [0]);                                                                // 390
wrapFsFunc("lstat", [0]);                                                               // 391
wrapFsFunc("exists", [0], {noErr: true});                                               // 392
wrapFsFunc("rename", [0, 1]);                                                           // 393
                                                                                        // 394
if (process.platform === "win32") {                                                     // 395
  var rename = files.rename;                                                            // 396
                                                                                        // 397
  files.rename = function (from, to) {                                                  // 398
    // retries are necessarily only on Windows, because the rename call can fail        // 399
    // with EBUSY, which means the file is "busy"                                       // 400
    var maxTries = 10;                                                                  // 401
    var success = false;                                                                // 402
    while (! success && maxTries-- > 0) {                                               // 403
      try {                                                                             // 404
        rename(from, to);                                                               // 405
        success = true;                                                                 // 406
      } catch (err) {                                                                   // 407
        if (err.code !== 'EPERM')                                                       // 408
          throw err;                                                                    // 409
      }                                                                                 // 410
    }                                                                                   // 411
    if (! success) {                                                                    // 412
      files.cp_r(from, to);                                                             // 413
      files.rm_recursive(from);                                                         // 414
    }                                                                                   // 415
  };                                                                                    // 416
}                                                                                       // 417
                                                                                        // 418
// Warning: doesn't convert slashes in the second 'cache' arg                           // 419
wrapFsFunc("realpath", [0], {                                                           // 420
  modifyReturnValue: files.convertToStandardPath                                        // 421
});                                                                                     // 422
                                                                                        // 423
wrapFsFunc("readdir", [0], {                                                            // 424
  modifyReturnValue: function (entries) {                                               // 425
    return _.map(entries, files.convertToStandardPath);                                 // 426
  }                                                                                     // 427
});                                                                                     // 428
                                                                                        // 429
wrapFsFunc("rmdir", [0]);                                                               // 430
wrapFsFunc("mkdir", [0]);                                                               // 431
wrapFsFunc("unlink", [0]);                                                              // 432
wrapFsFunc("chmod", [0]);                                                               // 433
wrapFsFunc("open", [0]);                                                                // 434
                                                                                        // 435
// XXX this doesn't give you the second argument to the callback                        // 436
wrapFsFunc("read", []);                                                                 // 437
wrapFsFunc("write", []);                                                                // 438
wrapFsFunc("close", []);                                                                // 439
wrapFsFunc("symlink", [0, 1]);                                                          // 440
wrapFsFunc("readlink", [0]);                                                            // 441
                                                                                        // 442
// These don't need to be Fiberized                                                     // 443
files.createReadStream = function () {                                                  // 444
  var args = _.toArray(arguments);                                                      // 445
  args[0] = files.convertToOSPath(args[0]);                                             // 446
  return fs.createReadStream.apply(fs, args);                                           // 447
};                                                                                      // 448
                                                                                        // 449
files.createWriteStream = function () {                                                 // 450
  var args = _.toArray(arguments);                                                      // 451
  args[0] = files.convertToOSPath(args[0]);                                             // 452
  return fs.createWriteStream.apply(fs, args);                                          // 453
};                                                                                      // 454
                                                                                        // 455
files.watchFile = function () {                                                         // 456
  var args = _.toArray(arguments);                                                      // 457
  args[0] = files.convertToOSPath(args[0]);                                             // 458
  return fs.watchFile.apply(fs, args);                                                  // 459
};                                                                                      // 460
                                                                                        // 461
files.unwatchFile = function () {                                                       // 462
  var args = _.toArray(arguments);                                                      // 463
  args[0] = files.convertToOSPath(args[0]);                                             // 464
  return fs.unwatchFile.apply(fs, args);                                                // 465
};                                                                                      // 466
                                                                                        // 467
//////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
// packages/velocity:meteor-internals/tools/server/mini-files.js                        //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
                                                                                        //
var _ = Npm.require("underscore");                                                      // 1
var os = Npm.require("os");                                                             // 2
var path = Npm.require("path");                                                         // 3
                                                                                        // 4
// All of these functions are attached to files.js for the tool;                        // 5
// they live here because we need them in boot.js as well to avoid duplicating          // 6
// a lot of the code.                                                                   // 7
//                                                                                      // 8
// Note that this file does NOT contain any of the "perform I/O maybe                   // 9
// synchronously" functions from files.js; this is intentional, because we want         // 10
// to make it very hard to accidentally use fs.*Sync functions in the app server        // 11
// after bootup (since they block all concurrency!)                                     // 12
var files = {};                                                                         // 13
                                                                                        // 14
var toPosixPath = function (p, partialPath) {                                           // 15
  // Sometimes, you can have a path like \Users\IEUser on windows, and this             // 16
  // actually means you want C:\Users\IEUser                                            // 17
  if (p[0] === "\\" && (! partialPath)) {                                               // 18
    p = process.env.SystemDrive + p;                                                    // 19
  }                                                                                     // 20
                                                                                        // 21
  p = p.replace(/\\/g, '/');                                                            // 22
  if (p[1] === ':' && ! partialPath) {                                                  // 23
    // transform "C:/bla/bla" to "/c/bla/bla"                                           // 24
    p = '/' + p[0] + p.slice(2);                                                        // 25
  }                                                                                     // 26
                                                                                        // 27
  return p;                                                                             // 28
};                                                                                      // 29
                                                                                        // 30
var toDosPath = function (p, partialPath) {                                             // 31
  if (p[0] === '/' && ! partialPath) {                                                  // 32
    if (! /^\/[A-Za-z](\/|$)/.test(p))                                                  // 33
      throw new Error("Surprising path: " + p);                                         // 34
    // transform a previously windows path back                                         // 35
    // "/C/something" to "c:/something"                                                 // 36
    p = p[1] + ":" + p.slice(2);                                                        // 37
  }                                                                                     // 38
                                                                                        // 39
  p = p.replace(/\//g, '\\');                                                           // 40
  return p;                                                                             // 41
};                                                                                      // 42
                                                                                        // 43
                                                                                        // 44
var convertToOSPath = function (standardPath, partialPath) {                            // 45
  if (process.platform === "win32") {                                                   // 46
    return toDosPath(standardPath, partialPath);                                        // 47
  }                                                                                     // 48
                                                                                        // 49
  return standardPath;                                                                  // 50
};                                                                                      // 51
                                                                                        // 52
var convertToStandardPath = function (osPath, partialPath) {                            // 53
  if (process.platform === "win32") {                                                   // 54
    return toPosixPath(osPath, partialPath);                                            // 55
  }                                                                                     // 56
                                                                                        // 57
  return osPath;                                                                        // 58
}                                                                                       // 59
                                                                                        // 60
var convertToOSLineEndings = function (fileContents) {                                  // 61
  return fileContents.replace(/\n/g, os.EOL);                                           // 62
};                                                                                      // 63
                                                                                        // 64
var convertToStandardLineEndings = function (fileContents) {                            // 65
  // Convert all kinds of end-of-line chars to linuxy "\n".                             // 66
  return fileContents.replace(new RegExp("\r\n", "g"), "\n")                            // 67
                     .replace(new RegExp("\r", "g"), "\n");                             // 68
};                                                                                      // 69
                                                                                        // 70
                                                                                        // 71
// wrappings for path functions that always run as they were on unix (using             // 72
// forward slashes)                                                                     // 73
var wrapPathFunction = function (name, partialPaths) {                                  // 74
  var f = path[name];                                                                   // 75
  return function (/* args */) {                                                        // 76
    if (process.platform === 'win32') {                                                 // 77
      var args = _.toArray(arguments);                                                  // 78
      args = _.map(args, function (p, i) {                                              // 79
        // if partialPaths is turned on (for path.join mostly)                          // 80
        // forget about conversion of absolute paths for Windows                        // 81
        return toDosPath(p, partialPaths);                                              // 82
      });                                                                               // 83
      return toPosixPath(f.apply(path, args), partialPaths);                            // 84
    } else {                                                                            // 85
      return f.apply(path, arguments);                                                  // 86
    }                                                                                   // 87
  };                                                                                    // 88
};                                                                                      // 89
                                                                                        // 90
files.pathJoin = wrapPathFunction("join", true);                                        // 91
files.pathNormalize = wrapPathFunction("normalize");                                    // 92
files.pathRelative = wrapPathFunction("relative");                                      // 93
files.pathResolve = wrapPathFunction("resolve");                                        // 94
files.pathDirname = wrapPathFunction("dirname");                                        // 95
files.pathBasename = wrapPathFunction("basename");                                      // 96
files.pathExtname = wrapPathFunction("extname");                                        // 97
files.pathSep = '/';                                                                    // 98
files.pathDelimiter = ':';                                                              // 99
files.pathOsDelimiter = path.delimiter;                                                 // 100
                                                                                        // 101
files.convertToStandardPath = convertToStandardPath;                                    // 102
files.convertToOSPath = convertToOSPath;                                                // 103
files.convertToWindowsPath = toDosPath;                                                 // 104
files.convertToPosixPath = toPosixPath;                                                 // 105
                                                                                        // 106
files.convertToStandardLineEndings = convertToStandardLineEndings;                      // 107
files.convertToOSLineEndings = convertToOSLineEndings;                                  // 108
                                                                                        // 109
_.extend(VelocityMeteorInternals.files, files);                                         // 110
                                                                                        // 111
//////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['velocity:meteor-internals'] = {
  VelocityMeteorInternals: VelocityMeteorInternals
};

})();

//# sourceMappingURL=velocity_meteor-internals.js.map
